
create table examesunilab (
       fil_codigo            integer not null,
       lae_codigo            integer not null,
       unl_codigoexame       varchar(8) not null,
       unl_codigomaterial    varchar(10) not null,
       unl_descricaoexame    varchar(120),
       unl_xml               text,
       unl_descricaomaterial varchar(100)
);

create unique index xpkexamesunilab on examesunilab
(
       fil_codigo,
       lae_codigo,
       unl_codigoexame,
       unl_codigomaterial
);

create index xif1examesunilab on examesunilab
(
       fil_codigo,
       lae_codigo
);


alter table examesunilab
       add primary key (fil_codigo, lae_codigo, unl_codigoexame, 
              unl_codigomaterial);



--drop function fn_ti_examesunilab() cascade;

create function fn_ti_examesunilab() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from labexterno
      where
        new.fil_codigo = labexterno.fil_codigo and
        new.lae_codigo = labexterno.lae_codigo;
    tmp:=''labexterno|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''lae_codigo='' || new.lae_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela labexterno. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_examesunilab
after insert on examesunilab
for each row execute procedure fn_ti_examesunilab();


--drop function fn_tu_examesunilab() cascade;

create function fn_tu_examesunilab() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from labexterno
    where
      new.fil_codigo = labexterno.fil_codigo and
      new.lae_codigo = labexterno.lae_codigo;
    tmp:=''labexterno|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''lae_codigo='' || new.lae_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela labexterno. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_examesunilab
after update on examesunilab
for each row execute procedure fn_tu_examesunilab();


drop function fn_td_labexterno() cascade;

create function fn_td_labexterno() returns opaque as '
declare
	numrows integer;										 
begin
    delete from examesunilab
      where
        examesunilab.fil_codigo = old.fil_codigo and
        examesunilab.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from filiais_postocoleta
      where
        filiais_postocoleta.fil_codigo = old.fil_codigo and
        filiais_postocoleta.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filiais_postocoleta.'';
    end if;

    delete from logimportacaolabexterno
      where
        logimportacaolabexterno.fil_codigo = old.fil_codigo and
        logimportacaolabexterno.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from examessolucao
      where
        examessolucao.fil_codigo = old.fil_codigo and
        examessolucao.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examessolucao.'';
    end if;

    select count(*) into numrows
      from examesdb
      where
        examesdb.fil_codigo = old.fil_codigo and
        examesdb.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesdb.'';
    end if;

    delete from examesatitude
      where
        examesatitude.fil_codigo = old.fil_codigo and
        examesatitude.lae_codigo = old.lae_codigo;

    delete from examesbalague
      where
        examesbalague.fil_codigo = old.fil_codigo and
        examesbalague.lae_codigo = old.lae_codigo;

    delete from examesdelta
      where
        examesdelta.fil_codigo = old.fil_codigo and
        examesdelta.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from examematcoletalabexterno
      where
        examematcoletalabexterno.fil_codigo = old.fil_codigo and
        examematcoletalabexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examematcoletalabexterno.'';
    end if;

    select count(*) into numrows
      from examesmatrix
      where
        examesmatrix.fil_codigo = old.fil_codigo and
        examesmatrix.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesmatrix.'';
    end if;

    select count(*) into numrows
      from examesrede
      where
        examesrede.fil_codigo = old.fil_codigo and
        examesrede.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesrede.'';
    end if;

    delete from examesreacao
      where
        examesreacao.fil_codigo = old.fil_codigo and
        examesreacao.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from pacientelabexterno
      where
        pacientelabexterno.fil_codigo = old.fil_codigo and
        pacientelabexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pacientelabexterno.'';
    end if;

    select count(*) into numrows
      from requisicaolabexterno
      where
        requisicaolabexterno.fil_codigo = old.fil_codigo and
        requisicaolabexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaolabexterno.'';
    end if;

    delete from examessergiofranco
      where
        examessergiofranco.fil_codigo = old.fil_codigo and
        examessergiofranco.lae_codigo = old.lae_codigo;

    delete from examesalvaro
      where
        examesalvaro.fil_codigo = old.fil_codigo and
        examesalvaro.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from examesjalis
      where
        examesjalis.fil_codigo = old.fil_codigo and
        examesjalis.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesjalis.'';
    end if;

    delete from examespardini
      where
        examespardini.fil_codigo = old.fil_codigo and
        examespardini.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from loteexterno
      where
        loteexterno.fil_codigo = old.fil_codigo and
        loteexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela loteexterno.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_labexterno
after delete on labexterno
for each row execute procedure fn_td_labexterno();


drop function fn_ti_labexterno() cascade;

create function fn_ti_labexterno() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from prazoentrega
      where
        new.fil_codigo = prazoentrega.fil_codigo and
        new.prz_codigo = prazoentrega.prz_codigo;
    tmp:=''prazoentrega|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''prz_codigo='' || new.prz_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.prz_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela prazoentrega. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from metodologia
      where
        new.fil_codigo = metodologia.fil_codigo and
        new.met_codigo = metodologia.met_codigo;
    tmp:=''metodologia|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''met_codigo='' || new.met_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.met_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela metodologia. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from setores
      where
        new.fil_codigo = setores.fil_codigo and
        new.set_codigo = setores.set_codigo;
    tmp:=''setores|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''set_codigo='' || new.set_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.set_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela setores. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codconferir = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codconferir || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codconferir is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_labexterno
after insert on labexterno
for each row execute procedure fn_ti_labexterno();


drop function fn_tu_labexterno() cascade;

create function fn_tu_labexterno() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesunilab
      where
        examesunilab.fil_codigo = old.fil_codigo and
        examesunilab.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesunilab.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from filiais_postocoleta
      where
        filiais_postocoleta.fil_codigo = old.fil_codigo and
        filiais_postocoleta.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filiais_postocoleta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from logimportacaolabexterno
      where
        logimportacaolabexterno.fil_codigo = old.fil_codigo and
        logimportacaolabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logimportacaolabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examessolucao
      where
        examessolucao.fil_codigo = old.fil_codigo and
        examessolucao.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examessolucao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesdb
      where
        examesdb.fil_codigo = old.fil_codigo and
        examesdb.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesdb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesatitude
      where
        examesatitude.fil_codigo = old.fil_codigo and
        examesatitude.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesatitude.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesbalague
      where
        examesbalague.fil_codigo = old.fil_codigo and
        examesbalague.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesbalague.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesdelta
      where
        examesdelta.fil_codigo = old.fil_codigo and
        examesdelta.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesdelta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examematcoletalabexterno
      where
        examematcoletalabexterno.fil_codigo = old.fil_codigo and
        examematcoletalabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examematcoletalabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesmatrix
      where
        examesmatrix.fil_codigo = old.fil_codigo and
        examesmatrix.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesmatrix.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesrede
      where
        examesrede.fil_codigo = old.fil_codigo and
        examesrede.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesrede.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesreacao
      where
        examesreacao.fil_codigo = old.fil_codigo and
        examesreacao.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesreacao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from pacientelabexterno
      where
        pacientelabexterno.fil_codigo = old.fil_codigo and
        pacientelabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacientelabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from requisicaolabexterno
      where
        requisicaolabexterno.fil_codigo = old.fil_codigo and
        requisicaolabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaolabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examessergiofranco
      where
        examessergiofranco.fil_codigo = old.fil_codigo and
        examessergiofranco.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examessergiofranco.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesalvaro
      where
        examesalvaro.fil_codigo = old.fil_codigo and
        examesalvaro.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesalvaro.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesjalis
      where
        examesjalis.fil_codigo = old.fil_codigo and
        examesjalis.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesjalis.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examespardini
      where
        examespardini.fil_codigo = old.fil_codigo and
        examespardini.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examespardini.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from loteexterno
      where
        loteexterno.fil_codigo = old.fil_codigo and
        loteexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela loteexterno.'';
    end if;
  end if;
  select count(*) into numrows
    from prazoentrega
    where
      new.fil_codigo = prazoentrega.fil_codigo and
      new.prz_codigo = prazoentrega.prz_codigo;
    tmp:=''prazoentrega|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''prz_codigo='' || new.prz_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.prz_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela prazoentrega. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from metodologia
    where
      new.fil_codigo = metodologia.fil_codigo and
      new.met_codigo = metodologia.met_codigo;
    tmp:=''metodologia|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''met_codigo='' || new.met_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.met_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela metodologia. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from setores
    where
      new.fil_codigo = setores.fil_codigo and
      new.set_codigo = setores.set_codigo;
    tmp:=''setores|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''set_codigo='' || new.set_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.set_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela setores. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codconferir = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codconferir || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codconferir is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_labexterno
after update on labexterno
for each row execute procedure fn_tu_labexterno();


insert into atualizacoes(atu_nome) values ('v17030001_040417.sql');


alter table unidadesaude add uns_sequencialequipe varchar(8), add uns_areaequipe varchar(3);
alter table exames add exa_tipobpa varchar(1);


create table ambbpa (
       fil_codigo           integer not null,
       abp_codigoamb        varchar(9) not null,
       abp_classificacao    varchar(3),
       abp_servico          varchar(3)
);

create unique index xpkambbpa on ambbpa
(
       fil_codigo,
       abp_codigoamb
);

create index xif1ambbpa on ambbpa
(
       fil_codigo
);


alter table ambbpa
       add primary key (fil_codigo, abp_codigoamb);



--drop function fn_ti_ambbpa() cascade;

create function fn_ti_ambbpa() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_ambbpa
after insert on ambbpa
for each row execute procedure fn_ti_ambbpa();


--drop function fn_tu_ambbpa() cascade;

create function fn_tu_ambbpa() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_ambbpa
after update on ambbpa
for each row execute procedure fn_tu_ambbpa();


drop function fn_td_filiais_postocoleta() cascade;

create function fn_td_filiais_postocoleta() returns opaque as '
declare
	numrows integer;										 
begin
    select count(*) into numrows
      from ambbpa
      where
        ambbpa.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela ambbpa.'';
    end if;

    select count(*) into numrows
      from categoriaprodutoalimentos
      where
        categoriaprodutoalimentos.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela categoriaprodutoalimentos.'';
    end if;

    delete from responsavelcertificado
      where
        responsavelcertificado.fil_codigo = old.fil_codigo;

    select count(*) into numrows
      from origemnaoconformidade
      where
        origemnaoconformidade.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela origemnaoconformidade.'';
    end if;

    select count(*) into numrows
      from filialemailaniversario
      where
        filialemailaniversario.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filialemailaniversario.'';
    end if;

    select count(*) into numrows
      from filialsmsaniversario
      where
        filialsmsaniversario.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filialsmsaniversario.'';
    end if;

    select count(*) into numrows
      from logemail
      where
        logemail.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela logemail.'';
    end if;

    delete from filialsmsresumo
      where
        filialsmsresumo.fil_codigo = old.fil_codigo;

    select count(*) into numrows
      from lanctocaixa
      where
        lanctocaixa.fil_codentrefilial = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lanctocaixa.'';
    end if;

    select count(*) into numrows
      from lotefilial
      where
        lotefilial.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lotefilial.'';
    end if;

    select count(*) into numrows
      from taxa
      where
        taxa.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela taxa.'';
    end if;

    select count(*) into numrows
      from logoffline
      where
        logoffline.fil_coddestino = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela logoffline.'';
    end if;

    select count(*) into numrows
      from logoffline
      where
        logoffline.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela logoffline.'';
    end if;

    select count(*) into numrows
      from pais
      where
        pais.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pais.'';
    end if;

    select count(*) into numrows
      from logsms
      where
        logsms.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela logsms.'';
    end if;

    select count(*) into numrows
      from naoconformidade
      where
        naoconformidade.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela naoconformidade.'';
    end if;

    select count(*) into numrows
      from acaonaoconformidade
      where
        acaonaoconformidade.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela acaonaoconformidade.'';
    end if;

    select count(*) into numrows
      from procedencianaoconformidade
      where
        procedencianaoconformidade.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela procedencianaoconformidade.'';
    end if;

    select count(*) into numrows
      from banhomaria
      where
        banhomaria.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela banhomaria.'';
    end if;

    select count(*) into numrows
      from identificadorlamina
      where
        identificadorlamina.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela identificadorlamina.'';
    end if;

    select count(*) into numrows
      from materiallote
      where
        materiallote.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materiallote.'';
    end if;

    select count(*) into numrows
      from examerequisicaohash
      where
        examerequisicaohash.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examerequisicaohash.'';
    end if;

    select count(*) into numrows
      from motivoalteracao
      where
        motivoalteracao.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela motivoalteracao.'';
    end if;

    select count(*) into numrows
      from tipomaterialcoleta
      where
        tipomaterialcoleta.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela tipomaterialcoleta.'';
    end if;

    select count(*) into numrows
      from salaatendimento
      where
        salaatendimento.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela salaatendimento.'';
    end if;

    select count(*) into numrows
      from agendamento
      where
        agendamento.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela agendamento.'';
    end if;

    select count(*) into numrows
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaoweb.'';
    end if;

    select count(*) into numrows
      from lanctoestoquecmc
      where
        lanctoestoquecmc.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lanctoestoquecmc.'';
    end if;

    select count(*) into numrows
      from lanctoestoqueueps
      where
        lanctoestoqueueps.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lanctoestoqueueps.'';
    end if;

    select count(*) into numrows
      from lanctoestoquepeps
      where
        lanctoestoquepeps.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lanctoestoquepeps.'';
    end if;

    select count(*) into numrows
      from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela contrassenharequisicao.'';
    end if;

    select count(*) into numrows
      from solicitarsoroteca
      where
        solicitarsoroteca.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela solicitarsoroteca.'';
    end if;

    select count(*) into numrows
      from exportaintegracaohospital
      where
        exportaintegracaohospital.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela exportaintegracaohospital.'';
    end if;

    select count(*) into numrows
      from examerequisicaohistoricolaudo
      where
        examerequisicaohistoricolaudo.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examerequisicaohistoricolaudo.'';
    end if;

    select count(*) into numrows
      from examerequisicaosetor
      where
        examerequisicaosetor.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examerequisicaosetor.'';
    end if;

    select count(*) into numrows
      from materialenviado
      where
        materialenviado.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialenviado.'';
    end if;

    select count(*) into numrows
      from rota
      where
        rota.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela rota.'';
    end if;

    select count(*) into numrows
      from montagemkit
      where
        montagemkit.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela montagemkit.'';
    end if;

    select count(*) into numrows
      from transfestoque
      where
        transfestoque.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela transfestoque.'';
    end if;

    select count(*) into numrows
      from orcamento
      where
        orcamento.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela orcamento.'';
    end if;

    select count(*) into numrows
      from estoquemanual
      where
        estoquemanual.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela estoquemanual.'';
    end if;

    select count(*) into numrows
      from requisicaoestoque
      where
        requisicaoestoque.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaoestoque.'';
    end if;

    select count(*) into numrows
      from conferenciaestoque
      where
        conferenciaestoque.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conferenciaestoque.'';
    end if;

    select count(*) into numrows
      from lanctoestoque
      where
        lanctoestoque.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lanctoestoque.'';
    end if;

    select count(*) into numrows
      from conferenciaentrada
      where
        conferenciaentrada.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conferenciaentrada.'';
    end if;

    select count(*) into numrows
      from pedido
      where
        pedido.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pedido.'';
    end if;

    select count(*) into numrows
      from cotacao
      where
        cotacao.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela cotacao.'';
    end if;

    select count(*) into numrows
      from cfop
      where
        cfop.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela cfop.'';
    end if;

    select count(*) into numrows
      from celulaestoque
      where
        celulaestoque.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela celulaestoque.'';
    end if;

    select count(*) into numrows
      from unidadesaude
      where
        unidadesaude.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela unidadesaude.'';
    end if;

    select count(*) into numrows
      from estantes
      where
        estantes.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela estantes.'';
    end if;

    select count(*) into numrows
      from geladeiras
      where
        geladeiras.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela geladeiras.'';
    end if;

    delete from usuariofilial
      where
        usuariofilial.fil_codigo = old.fil_codigo;

    select count(*) into numrows
      from origemplanocusto
      where
        origemplanocusto.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela origemplanocusto.'';
    end if;

    select count(*) into numrows
      from filialimposto
      where
        filialimposto.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filialimposto.'';
    end if;

    select count(*) into numrows
      from embalagemproduto
      where
        embalagemproduto.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela embalagemproduto.'';
    end if;

    select count(*) into numrows
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela notafiscal.'';
    end if;

    select count(*) into numrows
      from servico
      where
        servico.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela servico.'';
    end if;

    select count(*) into numrows
      from baixa
      where
        baixa.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela baixa.'';
    end if;

    select count(*) into numrows
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela receberpagar.'';
    end if;

    select count(*) into numrows
      from entidade
      where
        entidade.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela entidade.'';
    end if;

    select count(*) into numrows
      from motivoscancelamentos
      where
        motivoscancelamentos.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela motivoscancelamentos.'';
    end if;

    select count(*) into numrows
      from formapagto
      where
        formapagto.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela formapagto.'';
    end if;

    select count(*) into numrows
      from especie
      where
        especie.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela especie.'';
    end if;

    select count(*) into numrows
      from series
      where
        series.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela series.'';
    end if;

    delete from filiaisweb
      where
        filiaisweb.fil_kodigo = old.fil_codigo;

    delete from filiaisweb
      where
        filiaisweb.fil_codigo = old.fil_codigo;

    select count(*) into numrows
      from labexterno
      where
        labexterno.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela labexterno.'';
    end if;

    select count(*) into numrows
      from loteexterno
      where
        loteexterno.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela loteexterno.'';
    end if;

    select count(*) into numrows
      from log
      where
        log.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela log.'';
    end if;

    select count(*) into numrows
      from alahospital
      where
        alahospital.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela alahospital.'';
    end if;

    select count(*) into numrows
      from loteapoio
      where
        loteapoio.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela loteapoio.'';
    end if;

    select count(*) into numrows
      from exportaapoio
      where
        exportaapoio.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela exportaapoio.'';
    end if;

    select count(*) into numrows
      from exportafiliais
      where
        exportafiliais.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela exportafiliais.'';
    end if;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codcopia = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;

    select count(*) into numrows
      from filiaisexamesexportar
      where
        filiaisexamesexportar.fil_coddestino = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filiaisexamesexportar.'';
    end if;

    select count(*) into numrows
      from contrasenha
      where
        contrasenha.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela contrasenha.'';
    end if;

    select count(*) into numrows
      from exportaweb
      where
        exportaweb.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela exportaweb.'';
    end if;

    select count(*) into numrows
      from interface
      where
        interface.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela interface.'';
    end if;

    select count(*) into numrows
      from banco
      where
        banco.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela banco.'';
    end if;

    select count(*) into numrows
      from agencia
      where
        agencia.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela agencia.'';
    end if;

    select count(*) into numrows
      from historicopadrao
      where
        historicopadrao.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela historicopadrao.'';
    end if;

    select count(*) into numrows
      from prioridade
      where
        prioridade.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela prioridade.'';
    end if;

    select count(*) into numrows
      from destino
      where
        destino.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela destino.'';
    end if;

    select count(*) into numrows
      from grupo
      where
        grupo.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela grupo.'';
    end if;

    select count(*) into numrows
      from feriados
      where
        feriados.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela feriados.'';
    end if;

    select count(*) into numrows
      from especialidades
      where
        especialidades.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela especialidades.'';
    end if;

    select count(*) into numrows
      from coletas
      where
        coletas.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela coletas.'';
    end if;

    select count(*) into numrows
      from tabelaprecoexames
      where
        tabelaprecoexames.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela tabelaprecoexames.'';
    end if;

    select count(*) into numrows
      from tipomaterial
      where
        tipomaterial.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela tipomaterial.'';
    end if;

    select count(*) into numrows
      from unidademedida
      where
        unidademedida.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela unidademedida.'';
    end if;

    select count(*) into numrows
      from situacao
      where
        situacao.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela situacao.'';
    end if;

    select count(*) into numrows
      from principios
      where
        principios.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela principios.'';
    end if;

    select count(*) into numrows
      from medicamentos
      where
        medicamentos.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medicamentos.'';
    end if;

    select count(*) into numrows
      from layout
      where
        layout.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela layout.'';
    end if;

    select count(*) into numrows
      from metodologia
      where
        metodologia.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela metodologia.'';
    end if;

    select count(*) into numrows
      from recipientes
      where
        recipientes.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela recipientes.'';
    end if;

    select count(*) into numrows
      from cidades
      where
        cidades.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela cidades.'';
    end if;

    select count(*) into numrows
      from bairro
      where
        bairro.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela bairro.'';
    end if;

    select count(*) into numrows
      from materialcoleta
      where
        materialcoleta.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialcoleta.'';
    end if;

    select count(*) into numrows
      from prazoentrega
      where
        prazoentrega.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela prazoentrega.'';
    end if;

    select count(*) into numrows
      from historicos
      where
        historicos.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela historicos.'';
    end if;

    select count(*) into numrows
      from lanctocaixa
      where
        lanctocaixa.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lanctocaixa.'';
    end if;

    select count(*) into numrows
      from centrocusto
      where
        centrocusto.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela centrocusto.'';
    end if;

    select count(*) into numrows
      from planoconta
      where
        planoconta.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela planoconta.'';
    end if;

    select count(*) into numrows
      from contacorrente
      where
        contacorrente.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela contacorrente.'';
    end if;

    select count(*) into numrows
      from material
      where
        material.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela material.'';
    end if;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;

    select count(*) into numrows
      from medico
      where
        medico.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medico.'';
    end if;

    select count(*) into numrows
      from convenios
      where
        convenios.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela convenios.'';
    end if;

    delete from exames
      where
        exames.fil_codigo = old.fil_codigo;

    select count(*) into numrows
      from fatura
      where
        fatura.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela fatura.'';
    end if;

    select count(*) into numrows
      from setores
      where
        setores.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela setores.'';
    end if;

    select count(*) into numrows
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela paciente.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_filiais_postocoleta
after delete on filiais_postocoleta
for each row execute procedure fn_td_filiais_postocoleta();


drop function fn_ti_filiais_postocoleta() cascade;

create function fn_ti_filiais_postocoleta() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from labexterno
      where
        new.fil_codigo = labexterno.fil_codigo and
        new.lae_codigo = labexterno.lae_codigo;
    tmp:=''labexterno|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''lae_codigo='' || new.lae_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.lae_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela labexterno. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codcompras = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codcompras || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codcompras is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codestoque = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codestoque || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codestoque is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.bai_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cid_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_filiais_postocoleta
after insert on filiais_postocoleta
for each row execute procedure fn_ti_filiais_postocoleta();


drop function fn_tu_filiais_postocoleta() cascade;

create function fn_tu_filiais_postocoleta() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from ambbpa
      where
        ambbpa.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela ambbpa.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from categoriaprodutoalimentos
      where
        categoriaprodutoalimentos.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela categoriaprodutoalimentos.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from responsavelcertificado
      where
        responsavelcertificado.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela responsavelcertificado.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from origemnaoconformidade
      where
        origemnaoconformidade.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela origemnaoconformidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from filialemailaniversario
      where
        filialemailaniversario.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filialemailaniversario.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from filialsmsaniversario
      where
        filialsmsaniversario.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filialsmsaniversario.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from logemail
      where
        logemail.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logemail.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from filialsmsresumo
      where
        filialsmsresumo.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filialsmsresumo.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from lanctocaixa
      where
        lanctocaixa.fil_codentrefilial = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lanctocaixa.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from lotefilial
      where
        lotefilial.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lotefilial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from taxa
      where
        taxa.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela taxa.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from logoffline
      where
        logoffline.fil_coddestino = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logoffline.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from logoffline
      where
        logoffline.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logoffline.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from pais
      where
        pais.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pais.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from logsms
      where
        logsms.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logsms.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from naoconformidade
      where
        naoconformidade.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela naoconformidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from acaonaoconformidade
      where
        acaonaoconformidade.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela acaonaoconformidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from procedencianaoconformidade
      where
        procedencianaoconformidade.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela procedencianaoconformidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from banhomaria
      where
        banhomaria.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela banhomaria.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from identificadorlamina
      where
        identificadorlamina.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela identificadorlamina.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from materiallote
      where
        materiallote.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materiallote.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from examerequisicaohash
      where
        examerequisicaohash.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examerequisicaohash.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from motivoalteracao
      where
        motivoalteracao.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela motivoalteracao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from tipomaterialcoleta
      where
        tipomaterialcoleta.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela tipomaterialcoleta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from salaatendimento
      where
        salaatendimento.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela salaatendimento.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from agendamento
      where
        agendamento.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela agendamento.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaoweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from lanctoestoquecmc
      where
        lanctoestoquecmc.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lanctoestoquecmc.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from lanctoestoqueueps
      where
        lanctoestoqueueps.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lanctoestoqueueps.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from lanctoestoquepeps
      where
        lanctoestoquepeps.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lanctoestoquepeps.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela contrassenharequisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from solicitarsoroteca
      where
        solicitarsoroteca.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela solicitarsoroteca.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from exportaintegracaohospital
      where
        exportaintegracaohospital.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportaintegracaohospital.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from examerequisicaohistoricolaudo
      where
        examerequisicaohistoricolaudo.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examerequisicaohistoricolaudo.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from examerequisicaosetor
      where
        examerequisicaosetor.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examerequisicaosetor.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from materialenviado
      where
        materialenviado.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialenviado.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from rota
      where
        rota.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela rota.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from montagemkit
      where
        montagemkit.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela montagemkit.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from transfestoque
      where
        transfestoque.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela transfestoque.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from orcamento
      where
        orcamento.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela orcamento.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from estoquemanual
      where
        estoquemanual.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela estoquemanual.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from requisicaoestoque
      where
        requisicaoestoque.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaoestoque.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from conferenciaestoque
      where
        conferenciaestoque.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conferenciaestoque.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from lanctoestoque
      where
        lanctoestoque.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lanctoestoque.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from conferenciaentrada
      where
        conferenciaentrada.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conferenciaentrada.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from pedido
      where
        pedido.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pedido.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from cotacao
      where
        cotacao.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela cotacao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from cfop
      where
        cfop.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela cfop.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from celulaestoque
      where
        celulaestoque.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela celulaestoque.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from unidadesaude
      where
        unidadesaude.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela unidadesaude.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from estantes
      where
        estantes.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela estantes.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from geladeiras
      where
        geladeiras.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela geladeiras.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from origemplanocusto
      where
        origemplanocusto.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela origemplanocusto.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from filialimposto
      where
        filialimposto.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filialimposto.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from embalagemproduto
      where
        embalagemproduto.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela embalagemproduto.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela notafiscal.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from servico
      where
        servico.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela servico.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from baixa
      where
        baixa.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela baixa.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela receberpagar.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from entidade
      where
        entidade.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela entidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from motivoscancelamentos
      where
        motivoscancelamentos.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela motivoscancelamentos.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from formapagto
      where
        formapagto.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela formapagto.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from especie
      where
        especie.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela especie.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from series
      where
        series.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela series.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from filiaisweb
      where
        filiaisweb.fil_kodigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filiaisweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from filiaisweb
      where
        filiaisweb.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filiaisweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from labexterno
      where
        labexterno.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela labexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from loteexterno
      where
        loteexterno.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela loteexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from log
      where
        log.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela log.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from alahospital
      where
        alahospital.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela alahospital.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from loteapoio
      where
        loteapoio.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela loteapoio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from exportaapoio
      where
        exportaapoio.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportaapoio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from exportafiliais
      where
        exportafiliais.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportafiliais.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codcopia = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from filiaisexamesexportar
      where
        filiaisexamesexportar.fil_coddestino = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filiaisexamesexportar.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from contrasenha
      where
        contrasenha.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela contrasenha.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from exportaweb
      where
        exportaweb.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportaweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from interface
      where
        interface.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela interface.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from banco
      where
        banco.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela banco.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from agencia
      where
        agencia.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela agencia.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from historicopadrao
      where
        historicopadrao.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela historicopadrao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from prioridade
      where
        prioridade.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela prioridade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from destino
      where
        destino.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela destino.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from grupo
      where
        grupo.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela grupo.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from feriados
      where
        feriados.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela feriados.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from especialidades
      where
        especialidades.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela especialidades.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from coletas
      where
        coletas.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela coletas.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from tabelaprecoexames
      where
        tabelaprecoexames.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela tabelaprecoexames.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from tipomaterial
      where
        tipomaterial.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela tipomaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from unidademedida
      where
        unidademedida.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela unidademedida.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from situacao
      where
        situacao.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela situacao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from principios
      where
        principios.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela principios.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from medicamentos
      where
        medicamentos.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicamentos.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from layout
      where
        layout.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela layout.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from metodologia
      where
        metodologia.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela metodologia.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from recipientes
      where
        recipientes.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela recipientes.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from cidades
      where
        cidades.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela cidades.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from bairro
      where
        bairro.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela bairro.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from materialcoleta
      where
        materialcoleta.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialcoleta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from prazoentrega
      where
        prazoentrega.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela prazoentrega.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from historicos
      where
        historicos.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela historicos.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from lanctocaixa
      where
        lanctocaixa.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lanctocaixa.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from centrocusto
      where
        centrocusto.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela centrocusto.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from planoconta
      where
        planoconta.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela planoconta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from contacorrente
      where
        contacorrente.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela contacorrente.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from material
      where
        material.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela material.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from medico
      where
        medico.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medico.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from convenios
      where
        convenios.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenios.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from exames
      where
        exames.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exames.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from fatura
      where
        fatura.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela fatura.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from setores
      where
        setores.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela setores.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela paciente.'';
    end if;
  end if;
  select count(*) into numrows
    from labexterno
    where
      new.fil_codigo = labexterno.fil_codigo and
      new.lae_codigo = labexterno.lae_codigo;
    tmp:=''labexterno|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''lae_codigo='' || new.lae_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.lae_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela labexterno. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codcompras = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codcompras || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codcompras is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codestoque = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codestoque || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codestoque is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.bai_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cid_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_filiais_postocoleta
after update on filiais_postocoleta
for each row execute procedure fn_tu_filiais_postocoleta();





insert into atualizacoes(atu_nome) values ('v17030002_090517.sql');

/*insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010101004', '134', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201005', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201006', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201007', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201014', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201015', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201016', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201017', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201018', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201019', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201020', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201021', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201022', '108', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201022', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201023', '108', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201023', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201024', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201025', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201026', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201027', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201028', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201029', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201030', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201031', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201032', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201033', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201034', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201035', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201036', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201037', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201038', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201039', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201040', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201041', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201042', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201043', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201044', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201045', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201046', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201047', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201048', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201049', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201050', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201051', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201052', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201053', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201054', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201055', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201056', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201057', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201058', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201059', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201060', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201061', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201062', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201063', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201064', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201065', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010201066', '141', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010202001', '108', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010202002', '108', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010202002', '108', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '010202003', '108', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101015', '110', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101015', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101018', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101018', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101018', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101024', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101024', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101024', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101053', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101054', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101054', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101054', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020101054', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201001', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201002', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201003', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201004', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201005', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201006', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201007', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201008', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201009', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201010', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201011', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201012', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201013', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201014', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201015', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201016', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201017', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201018', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201019', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201020', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201021', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201022', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201023', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201024', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201025', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201026', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201027', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201028', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201029', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201030', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201031', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201032', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201033', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201034', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201035', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201036', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201037', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201038', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201039', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201040', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201041', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201042', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201043', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201044', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201045', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201046', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201047', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201048', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201049', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201050', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201051', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201052', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201053', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201054', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201055', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201056', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201057', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201058', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201059', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201060', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201061', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201062', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201063', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201064', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201065', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201066', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201067', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201068', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201069', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201070', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201071', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201072', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201073', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201074', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201075', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020201076', '145', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202001', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202002', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202003', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202004', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202005', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202006', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202007', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202008', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202009', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202010', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202011', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202012', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202013', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202014', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202015', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202016', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202017', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202018', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202019', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202020', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202021', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202022', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202023', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202024', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202025', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202026', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202027', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202028', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202029', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202030', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202031', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202032', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202033', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202034', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202035', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202036', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202037', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202038', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202039', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202040', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202041', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202042', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202043', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202044', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202046', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202047', '128', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202048', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202049', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202051', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202052', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202053', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020202054', '145', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203001', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203002', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203003', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203004', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203005', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203006', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203007', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203008', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203009', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203010', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203011', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203012', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203013', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203014', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203015', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203016', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203017', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203018', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203019', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203020', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203021', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203022', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203023', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203023', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203025', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203026', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203027', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203028', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203029', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203030', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203031', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203032', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203033', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203034', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203035', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203036', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203037', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203038', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203039', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203040', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203041', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203042', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203043', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203044', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203045', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203046', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203047', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203048', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203050', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203051', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203052', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203053', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203054', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203055', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203056', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203057', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203058', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203059', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203060', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203061', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203062', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203063', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203064', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203065', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203066', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203067', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203068', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203069', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203070', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203071', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203072', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203073', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203074', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203075', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203076', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203077', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203078', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203079', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203080', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203081', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203082', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203083', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203084', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203085', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203086', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203087', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203088', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203089', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203090', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203091', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203092', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203093', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203094', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203095', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203096', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203097', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203098', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203099', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203100', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203101', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203102', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203103', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203104', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203105', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203106', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203107', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203108', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203109', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203110', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203111', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203112', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203113', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203117', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203118', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203119', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203120', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203121', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203122', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203123', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203123', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203125', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203125', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203126', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020203126', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204001', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204002', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204003', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204004', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204005', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204006', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204007', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204008', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204009', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204010', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204011', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204012', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204013', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204014', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204015', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204016', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020204017', '145', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205001', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205002', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205003', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205004', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205005', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205006', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205007', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205007', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205008', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205009', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205010', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205011', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205012', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205013', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205014', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205015', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205016', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205017', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205018', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205019', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205020', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205021', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205022', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205023', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205024', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205025', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205026', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205027', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205028', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205029', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205030', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205031', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020205032', '145', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206001', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206001', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206002', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206002', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206003', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206003', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206004', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206004', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206005', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206005', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206006', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206006', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206007', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206007', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206008', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206008', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206009', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206009', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206010', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206010', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206011', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206011', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206012', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206012', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206013', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206013', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206014', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206014', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206015', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206015', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206016', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206016', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206017', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206017', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206018', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206018', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206019', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206019', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206020', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206020', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206021', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206021', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206022', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206022', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206023', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206023', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206024', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206024', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206025', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206025', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206026', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206026', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206027', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206027', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206028', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206028', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206029', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206029', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206030', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206030', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206031', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206031', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206032', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206032', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206033', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206033', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206034', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206034', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206035', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206035', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206036', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206036', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206037', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206037', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206038', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206038', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206039', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206039', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206040', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206040', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206041', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206041', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206042', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206042', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206043', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206043', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206044', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206044', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206045', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206045', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206046', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206046', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020206047', '145', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207001', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207002', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207003', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207004', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207005', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207006', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207007', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207008', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207009', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207010', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207011', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207012', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207013', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207014', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207015', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207016', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207017', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207018', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207019', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207020', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207021', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207022', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207023', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207024', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207025', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207026', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207027', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207028', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207029', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207030', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207031', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207032', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207033', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207034', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020207035', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208001', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208002', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208003', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208004', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208005', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208006', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208007', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208008', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208009', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208010', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208011', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208012', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208013', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208014', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208015', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208016', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208017', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208018', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208019', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208020', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208021', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208022', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020208023', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209001', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209002', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209003', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209004', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209005', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209006', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209007', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209008', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209009', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209010', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209011', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209012', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209013', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209014', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209015', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209016', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209018', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209019', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209021', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209022', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209022', '151', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209023', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209024', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209025', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209026', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209027', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209028', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209029', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209030', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209031', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209032', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209033', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209034', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020209035', '145', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210001', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210002', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210003', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210004', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210004', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210005', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210006', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210007', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210008', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210009', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210010', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210011', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210012', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210013', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210014', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210015', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210016', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210017', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210018', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020210019', '145', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211001', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211002', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211003', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211004', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211005', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211006', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211007', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211008', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211009', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211010', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211011', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211012', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211013', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020211014', '145', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212001', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212001', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212002', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212002', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212003', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212003', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212004', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212004', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212005', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212005', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212006', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212006', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212007', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212007', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212008', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212008', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212009', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212009', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212010', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020212010', '145', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020301001', '120', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020301002', '120', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020301003', '120', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020301004', '120', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020301007', '120', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020301008', '120', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020301008', '120', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302001', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302001', '120', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302002', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302003', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302004', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302005', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302006', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302007', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020302008', '120', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401002', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401002', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401003', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401003', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401004', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401004', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401006', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401006', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401007', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401007', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401008', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401008', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401009', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401009', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401010', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401010', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401011', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401011', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401012', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401012', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401013', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401013', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401014', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401014', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401015', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401015', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401017', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401017', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401019', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401019', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401020', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020401020', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402002', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402002', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402003', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402003', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402004', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402004', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402006', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402006', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402007', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402007', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402008', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402008', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402009', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402009', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402010', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402010', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402011', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402011', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402012', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402012', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402013', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020402013', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403002', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403002', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403003', '121', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403003', '121', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403004', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403004', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403006', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403006', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403007', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403007', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403008', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403008', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403009', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403009', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403010', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403010', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403011', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403011', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403012', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403012', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403013', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403013', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403014', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403014', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403015', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403015', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403016', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403016', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403017', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403017', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403018', '121', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020403018', '121', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404002', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404002', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404003', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404003', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404004', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404004', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404006', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404006', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404007', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404007', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404008', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404008', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404009', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404009', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404010', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404010', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404011', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404011', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404012', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020404012', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405002', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405002', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405003', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405003', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405004', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405004', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405006', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405006', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405007', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405007', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405008', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405008', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405009', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405009', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405010', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405010', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405011', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405011', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405012', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405012', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405013', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405013', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405014', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405014', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405015', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405015', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405016', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405016', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405017', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405017', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405018', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020405018', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406003', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406003', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406004', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406004', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406006', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406006', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406007', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406007', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406008', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406008', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406009', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406009', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406010', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406010', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406011', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406011', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406012', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406012', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406013', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406013', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406014', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406014', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406015', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406015', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406016', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406016', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406017', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020406017', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501001', '122', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501001', '122', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501002', '122', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501002', '122', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501003', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501003', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501004', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501004', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501005', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020501005', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502001', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502001', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502002', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502002', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502002', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502003', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502003', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502004', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502004', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502005', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502005', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502006', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502006', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502007', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502007', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502008', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502008', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502008', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502008', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502009', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502009', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502010', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502010', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502011', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502011', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502012', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502012', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502013', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502013', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502014', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502014', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502015', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502015', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502016', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502016', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502017', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502017', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502018', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502018', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502019', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502019', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502020', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502020', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502021', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020502021', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601001', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601002', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601003', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601004', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601005', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601006', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601007', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601008', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601009', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020601009', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020602001', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020602002', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020602003', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020602004', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020603001', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020603002', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020603003', '121', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701001', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701001', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701002', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701002', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701003', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701003', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701004', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701004', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701005', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701005', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701006', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701006', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701007', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020701007', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702001', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702001', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702002', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702002', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702003', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702003', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702004', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702004', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702005', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020702005', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703001', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703001', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703002', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703002', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703003', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703003', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703004', '121', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020703004', '121', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801004', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801005', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801005', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801006', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801006', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801007', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801007', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801008', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801008', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801009', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020801009', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802004', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802005', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802005', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802006', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802006', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802007', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802007', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802008', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802008', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802009', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802009', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802010', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802010', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802011', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802011', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802012', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020802012', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803004', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803005', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020803005', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804004', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804005', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804005', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804006', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804006', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804007', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804007', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804008', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804008', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804009', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804009', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804010', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020804010', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020805004', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020806001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020806001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020806002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020806002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020806003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020806003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020807004', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020808004', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020809001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020809001', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020809002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020809002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020809003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020809003', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020901001', '142', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020901002', '142', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020901003', '142', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020901004', '142', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020901005', '142', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020901006', '142', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020902001', '142', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020903001', '142', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020904001', '142', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020904002', '142', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020904003', '142', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020904004', '142', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '020904005', '142', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001002', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001002', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001003', '121', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001003', '121', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001004', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001004', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001006', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001006', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001007', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001007', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001008', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001008', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001009', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001009', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001010', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001010', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001011', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001011', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001012', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001012', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001013', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001013', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001014', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001014', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001015', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001015', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001016', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001016', '121', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001016', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001017', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001017', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001018', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001018', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001019', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001019', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001020', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021001020', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021002001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021002001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021101002', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102001', '116', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102002', '116', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102003', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102003', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102003', '122', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102003', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102003', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102003', '122', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102004', '122', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102004', '122', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102006', '122', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021102006', '122', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103001', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103002', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103003', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103004', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103005', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103006', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103007', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103008', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021103009', '126', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021104003', '145', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105002', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105002', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105003', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105003', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105004', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105004', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105005', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105005', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105006', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105006', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105009', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105010', '105', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105014', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105015', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021105015', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106001', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106001', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106001', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106001', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106001', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106002', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106002', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106003', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106005', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106006', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106007', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106007', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106007', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106008', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106008', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106008', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106009', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106010', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106010', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106010', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106011', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106011', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106011', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106012', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106012', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106012', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106012', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106012', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106013', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106014', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106015', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106015', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106015', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106015', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106015', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106015', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106015', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106016', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106016', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106016', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106017', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106017', '131', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106017', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106017', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106018', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106018', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106018', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106020', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106021', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106021', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106021', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106022', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106022', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106022', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106023', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106023', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106023', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106023', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106023', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106024', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106025', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106025', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106025', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106026', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106026', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021106026', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107002', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107002', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107003', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107003', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107004', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107009', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107009', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107010', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107010', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107012', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107015', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107015', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107016', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107016', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107019', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107019', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107019', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107019', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107019', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107019', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107020', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107020', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107021', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107021', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107023', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107023', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107024', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107024', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107025', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107026', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107026', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107027', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107027', '107', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107028', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107028', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107029', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107029', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107030', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107030', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107031', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107031', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107032', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107032', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107033', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107033', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107034', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107034', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107037', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107038', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107039', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107040', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021107041', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108001', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108002', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108003', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108004', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108005', '133', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108005', '133', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108006', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108007', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108008', '122', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021108008', '122', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021110001', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021110001', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021110001', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021110001', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021110001', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021110001', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021110001', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021201001', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021201002', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021201003', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021201004', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021201005', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021201006', '128', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021202001', '128', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021202002', '128', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021202003', '128', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021202004', '128', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021202005', '128', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021202006', '128', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301001', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301002', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301003', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301004', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301005', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301006', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301007', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301008', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301009', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301010', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301011', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301012', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301013', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301014', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301015', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301016', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301017', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301018', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301019', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301020', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301021', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301022', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301023', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301024', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301025', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301026', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301027', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301028', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301029', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301030', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301031', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301032', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301033', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301034', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301035', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301036', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301037', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301038', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301039', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301040', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301041', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301042', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301043', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301044', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301045', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301047', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301048', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301049', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301050', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301051', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301052', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301053', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301054', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301055', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301056', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301057', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301058', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301059', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301060', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301061', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301062', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301063', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301064', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301065', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301066', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301067', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301068', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301069', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301070', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021301071', '141', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302001', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302002', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302003', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302004', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302005', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302006', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302007', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '021302008', '141', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101010', '131', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101018', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101018', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101019', '168', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101019', '168', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101020', '168', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101020', '168', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101021', '168', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101021', '168', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101022', '168', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030101022', '168', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030102001', '108', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030102002', '108', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103002', '103', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103004', '103', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103005', '103', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103005', '103', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103008', '103', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103009', '103', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103010', '103', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103011', '104', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103012', '104', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103013', '104', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103014', '104', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103015', '103', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103016', '103', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030103016', '103', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030104005', '165', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030104006', '165', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105001', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105003', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105003', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105003', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105004', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105006', '133', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105006', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105006', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105007', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105008', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105008', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105011', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105011', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105012', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105012', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105013', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105013', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105014', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105014', '108', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105014', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105015', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030105015', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107001', '107', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107002', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107003', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107003', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107004', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107006', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107007', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107007', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107007', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107007', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107007', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107007', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107007', '135', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107008', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107008', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107008', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107008', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107008', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107008', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107009', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107009', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107010', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107010', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107011', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107012', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107013', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107013', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107014', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107014', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107015', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107015', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107016', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107016', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107017', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107018', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030107019', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108001', '119', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108002', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108003', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108004', '115', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108004', '115', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108004', '115', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108016', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108016', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108016', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108016', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108016', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108016', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108016', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108017', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108019', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108020', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108021', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108022', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108023', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108024', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108025', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108026', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108027', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108028', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108029', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108030', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108031', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108032', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108033', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108034', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108035', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108036', '115', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108037', '115', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108038', '115', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030108039', '115', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030111001', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030111002', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030112005', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030112006', '139', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030112007', '139', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030112008', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030113003', '153', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030113004', '153', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030113004', '153', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030113005', '130', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030113006', '130', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030114001', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030114001', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030201001', '126', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030201002', '126', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030201003', '126', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202001', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202001', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202001', '126', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202001', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202001', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202002', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202002', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202002', '126', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202002', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202002', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030202003', '126', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030203001', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030203001', '126', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030203001', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030203002', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030203002', '126', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030203002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204001', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204001', '126', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204001', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204001', '126', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204001', '126', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204001', '126', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204002', '126', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204003', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204003', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204003', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204003', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204003', '126', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204004', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204004', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204004', '126', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204005', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204005', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030204005', '126', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205001', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205001', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205001', '126', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205002', '126', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030205003', '126', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206001', '126', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206002', '126', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206003', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206003', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206003', '126', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206004', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206004', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206004', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206004', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206004', '126', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206005', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206005', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030206005', '126', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030207001', '126', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030207002', '126', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030207003', '126', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030303008', '153', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030303009', '153', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304006', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304010', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304010', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304010', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304010', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304010', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '155', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304011', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304012', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304012', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304012', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304012', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304012', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304030', '140', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304030', '140', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030304030', '140', '019');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305001', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305002', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305003', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305004', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305005', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305006', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305007', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305008', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305009', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305010', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305011', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305012', '167', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305012', '167', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305012', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305012', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305013', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305014', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305015', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305016', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305017', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305018', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305019', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305020', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305021', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030305022', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030307001', '142', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030307013', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030317013', '115', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030317014', '115', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030317015', '115', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030317016', '115', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030317017', '115', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030317018', '115', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030319001', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030319001', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030319001', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030319001', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030319001', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401001', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401002', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401003', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401004', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401005', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401006', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401007', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401008', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401009', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401011', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401011', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401011', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401011', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401012', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401013', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401014', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401015', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401016', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401017', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401018', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401019', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401020', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401021', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401023', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401024', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401026', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401028', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401029', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401030', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401031', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401032', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401033', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030401034', '132', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402001', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402002', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402003', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402004', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402005', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402006', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402007', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402008', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402009', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402010', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402011', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402012', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402013', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402014', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402015', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402016', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402017', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402018', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402019', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402020', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402021', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402022', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402023', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402024', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402025', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402026', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402027', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402028', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402029', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402030', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402031', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402032', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402033', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402034', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402036', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402037', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402038', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402039', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030402040', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403001', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403001', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403002', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403002', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403003', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403003', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403004', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403004', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403005', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403005', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403006', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403006', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403007', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403007', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403008', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403008', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403009', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403009', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403010', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403010', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403011', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403011', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403012', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403012', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403013', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403013', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403014', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403014', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403015', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403015', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403016', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403016', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403017', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403017', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403018', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403018', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403019', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403019', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403020', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403020', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403021', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403021', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403022', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403022', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403023', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030403024', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404001', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404002', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404004', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404005', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404006', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404007', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404008', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404009', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404010', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404011', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404012', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404013', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404014', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404015', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404016', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404017', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404018', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404019', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030404020', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405001', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405002', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405003', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405004', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405006', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405007', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405011', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405012', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405013', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405017', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405018', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405020', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405021', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405022', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405025', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405026', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405027', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405028', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405029', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405030', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405031', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405032', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405033', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030405034', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406001', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406001', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406003', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406003', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406004', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406004', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406007', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406007', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406008', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406008', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406009', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406009', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406010', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406010', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406011', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406011', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406012', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406012', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406013', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406013', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406015', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406016', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406017', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406018', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406020', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406021', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406022', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030406022', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407001', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407001', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407001', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407002', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407002', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407002', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407003', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407003', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407003', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407004', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407004', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407004', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407005', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030407005', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408001', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408001', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408001', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408002', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408002', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408002', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408003', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408003', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408003', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408004', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408005', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408005', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408005', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408006', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408007', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408007', '132', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030408007', '132', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030409001', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030409002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030409003', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030409004', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030409005', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030409006', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501001', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501002', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501009', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501010', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501011', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501012', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501016', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030501020', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030601001', '128', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030601002', '128', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030601003', '128', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602001', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602002', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602003', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602004', '128', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602005', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602006', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602007', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602008', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602009', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602010', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602011', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602012', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602013', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602014', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030602015', '128', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030903005', '142', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030903006', '142', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030903010', '169', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030903011', '169', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030903012', '169', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030903013', '169', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '134', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905001', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '134', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905002', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '135', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '113', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '135', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '135', '011');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '113', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '135', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '113', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '134', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '135', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '113', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '135', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030905003', '135', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '030907001', '116', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301004', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301004', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301004', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301004', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301004', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301005', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301005', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301005', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301005', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301005', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301007', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301007', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301007', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301007', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301007', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301011', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301011', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301011', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301011', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301011', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301012', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301012', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301012', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301012', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301012', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301013', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301013', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301013', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301013', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301013', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301014', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301014', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301014', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301014', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301014', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301014', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301021', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301021', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301021', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301021', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301021', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301022', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301022', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301022', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301022', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301022', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301023', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301023', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301023', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301023', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301023', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301024', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301024', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301024', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301024', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301024', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301024', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301025', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301025', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301025', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301025', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301025', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301025', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301029', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301029', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301029', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301029', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301029', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301029', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301033', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301033', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301033', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301033', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301033', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301035', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301035', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301035', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301035', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301035', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040301035', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302001', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302002', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302003', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302004', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302005', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302006', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302009', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302009', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302009', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302009', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302009', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302011', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '155', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '155', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040302013', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303001', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303001', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303001', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303001', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303001', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303002', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303002', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303002', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303002', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303002', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303003', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303003', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303003', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303003', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303003', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303004', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303004', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303004', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303004', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303004', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303005', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303005', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303005', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303005', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303005', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303006', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303006', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303006', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303006', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303006', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303008', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303008', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303008', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303008', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303008', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303009', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303009', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303009', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303009', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303009', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303010', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303010', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303010', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303010', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303010', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303010', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303011', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303011', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303011', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303011', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303011', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303012', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303012', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303012', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303012', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303012', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303013', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303013', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303013', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303013', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303013', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303013', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303014', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303014', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303014', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303014', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303014', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303014', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303015', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303015', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303015', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303015', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303015', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303015', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303016', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303016', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303016', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303016', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303016', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040303016', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304001', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304001', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304001', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304001', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304001', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304002', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304002', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304002', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304002', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304002', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304005', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304005', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304005', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304005', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304005', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304006', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304006', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304006', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304006', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304006', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304007', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304007', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304007', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304007', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304007', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304008', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304008', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304008', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304008', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304008', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304009', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304009', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304009', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304009', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304009', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304010', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304010', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304010', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304010', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304010', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304011', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304011', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304011', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304011', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304011', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304012', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304012', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304012', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304012', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040304012', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305003', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305003', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305003', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305003', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305003', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305004', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305004', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305004', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305004', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305004', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305005', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305006', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305006', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305006', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305006', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305006', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305007', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305007', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305007', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305007', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305007', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305009', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305009', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305009', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305009', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305009', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305010', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305010', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305010', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305010', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305010', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305010', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305015', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305015', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305015', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305015', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305015', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305015', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305016', '105', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305016', '105', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305016', '105', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305016', '105', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305016', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040305016', '105', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306001', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306002', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306003', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306004', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306005', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306006', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306007', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306008', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040306009', '105', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307001', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307004', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307005', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307008', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307009', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307010', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307011', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307012', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307013', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307013', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307014', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307015', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040307016', '105', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308001', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308002', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308003', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308004', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308005', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308006', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308007', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308008', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308009', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040308010', '105', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401056', '153', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401057', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401058', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401059', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401060', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401061', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401062', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401063', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040401064', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040402044', '114', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040402044', '114', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501001', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501002', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501003', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501004', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501005', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501006', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501007', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501008', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501010', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501011', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501012', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501012', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501013', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501013', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501013', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501014', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501015', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501016', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501017', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501018', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501019', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040501020', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040502001', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040502001', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040502001', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040502002', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040502002', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040502002', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503001', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503001', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503002', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503003', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503004', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503004', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503004', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503005', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503007', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503009', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503010', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503011', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503012', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503012', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503013', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503014', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503015', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503016', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503017', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503018', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503019', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503020', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503021', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503022', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040503023', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504001', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504002', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504002', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504004', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504005', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504006', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504006', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504007', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504007', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504008', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504008', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504009', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504009', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504010', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504013', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504014', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504014', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504014', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504015', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504015', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504015', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504016', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504016', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504016', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504018', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504019', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504020', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040504021', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505001', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505002', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505003', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505004', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505005', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505006', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505007', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505008', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505008', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505009', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505010', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505011', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505012', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505013', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505014', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505015', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505016', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505017', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505018', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505019', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505020', '132', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505020', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505020', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505021', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505022', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505023', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505024', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505025', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505026', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505028', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505029', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505030', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505031', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505032', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505035', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505036', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505037', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505037', '131', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505037', '131', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505038', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040505039', '131', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601001', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601002', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601002', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601004', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601004', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601005', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601005', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601006', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601006', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601007', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601007', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601008', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601008', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601009', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601009', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601013', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601013', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601013', '116', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601015', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601016', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601016', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601017', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601017', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601018', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601018', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601019', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601020', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601020', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601021', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601021', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601022', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601023', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601023', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601024', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601024', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601025', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601026', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601027', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601028', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601029', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601029', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601030', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601030', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601031', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601031', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601032', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601032', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601033', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601034', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601034', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601035', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601035', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601036', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601037', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601038', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601038', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601039', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601039', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601040', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601040', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601042', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601043', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601043', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601044', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601045', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601045', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601046', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601047', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601048', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601048', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601049', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601050', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601050', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601052', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601052', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601053', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601053', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601054', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601054', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601055', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601055', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601056', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601056', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601057', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601057', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601061', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601061', '116', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601072', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601123', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601123', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601124', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601124', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601125', '116', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040601125', '116', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040701012', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040701017', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040701018', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040701036', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040701037', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040703008', '121', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040703009', '121', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040703010', '121', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040703011', '121', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040703023', '121', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040901018', '169', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040905013', '153', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040905014', '153', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '040906029', '153', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041001019', '153', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041001020', '153', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301001', '140', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301001', '140', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301001', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301001', '140', '019');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301003', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301004', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301005', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301006', '140', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301006', '140', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301006', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301006', '140', '019');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301007', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301008', '140', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301008', '140', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301008', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301008', '140', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301008', '140', '019');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301009', '140', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301009', '140', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301009', '117', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301009', '140', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301009', '140', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041301009', '140', '019');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303001', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303002', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303003', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303004', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303004', '117', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303005', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303006', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303007', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041303008', '117', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041304003', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041304005', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041304006', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041304007', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041304008', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041304025', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041502001', '127', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041502005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601013', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601016', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601017', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601018', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601019', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601020', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601021', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041601022', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602015', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602016', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602017', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602018', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602019', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602020', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602021', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602022', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602023', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602024', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041602025', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603014', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603015', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603016', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603017', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603018', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603019', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603020', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603021', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603022', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603023', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603024', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603025', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603026', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603027', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603028', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603029', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603030', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603031', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603032', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603033', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603034', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603035', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041603036', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604010', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604014', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604017', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604018', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604019', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604020', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604021', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604022', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604023', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604024', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604025', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604026', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041604027', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605010', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041605011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606010', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041606012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041608001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041608003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041608008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041608009', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041608011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041608012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609010', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609011', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609012', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041609013', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611001', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611006', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611007', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041611008', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041612002', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041612003', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041612004', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041612005', '132', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041801001', '150', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041801002', '150', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041801003', '150', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041801004', '130', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041801006', '130', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041801008', '130', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041801009', '130', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041802001', '130', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041802002', '130', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '041802003', '130', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050101001', '128', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106001', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106001', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106001', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106002', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106002', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106002', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106003', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106003', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106003', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106004', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106004', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106004', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '121', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '151', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '121', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '151', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '122', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '121', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '121', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050106005', '122', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050107002', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050107003', '145', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050108003', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050108010', '145', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050201001', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050201002', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050301001', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050301002', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303001', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303002', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303003', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303004', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303005', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303005', '149', '016');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303006', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303007', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303008', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303009', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050303010', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050304001', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050304002', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050304003', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050304004', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050304005', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050304006', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050304008', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050402001', '154', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050402002', '154', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050402003', '154', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050402004', '154', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050402005', '154', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050403001', '154', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050403002', '154', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050601002', '149', '014');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '050601005', '149', '015');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201001', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201002', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201003', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201004', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201005', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201006', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201007', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201008', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201009', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201011', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201012', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201013', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201014', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201015', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060201016', '125', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060301001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302002', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302003', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302004', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302005', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302006', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302007', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302008', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302009', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060302010', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060303001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060303002', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060303003', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060303004', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060304001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305002', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305003', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305004', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305005', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305006', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305007', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305008', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305009', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305010', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305011', '103', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305011', '103', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305011', '103', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305012', '103', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305012', '103', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060305012', '103', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060306001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060307001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060307002', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060307003', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060307004', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060307005', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308001', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308002', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308003', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308004', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308005', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308006', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308007', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308008', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308009', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308010', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308011', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308012', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308013', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308014', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308015', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308016', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308017', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308018', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308019', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308020', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308021', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060308022', '125', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060401009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060402001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060402002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060402003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060402004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060402005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060403001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060403003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060403004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060403005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060403006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060404009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405010', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060405011', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060406001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060406002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060407001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060408001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060408002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060409001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060410001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060411001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060411002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060411003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060411004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060411005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060411006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060412001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413010', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060413011', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060414002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060414003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060415001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060415002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060416001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060416002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060416004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060416005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060417001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060417002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060417003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060417004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060417005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060418001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060418002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060419001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060420001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060421001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060421002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060422001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060423008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060424001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060424002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060424003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060424004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060424005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060425001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060426001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427010', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060427011', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060428006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060428007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060428008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060428009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060428010', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060429001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060429002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060429003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060429004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060429006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060429007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060429008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060430001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060430002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060430003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060431001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060431002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060431003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060431004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060431005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060431006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432011', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432012', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432013', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060432014', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060433001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060433002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060434001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060434002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060434003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060434004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060434005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060434006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060434007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060435001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060435002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060435003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436010', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436011', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060436012', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060437001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060437002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060438008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439009', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439010', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060439011', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060440001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060441001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060441002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060441003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060442001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060443001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060444001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060445001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060446001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060446002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060446003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060446004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060446005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060446006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060447001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060447002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060447003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060447004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060447005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060448001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060449001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060449002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450005', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450006', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450007', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060450008', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060451001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060451002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060451003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060451004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060452001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060453001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060453002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060453003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060454001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060455001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060455002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060456001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060457001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060457002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060457003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060458001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060458002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060459001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060459002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060460001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060460002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060461001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060461002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060462001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060462002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060462003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060462004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060463001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060464001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060464002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060464003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060465001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060465002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060465003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060466001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060466002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060466003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060467001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060468002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060469001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060470001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060471001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060471002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060472001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060472002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060473001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060474001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060475001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060475002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060475003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060475004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060476001', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060476002', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060476003', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '060476004', '125', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101001', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101002', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101003', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101004', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101005', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101006', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101007', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101008', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101009', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101010', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101011', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101012', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101013', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101014', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101015', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101016', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101017', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101018', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101019', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101020', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101020', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101021', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101021', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101022', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101022', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101023', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101023', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101024', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101024', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101025', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101025', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101026', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101026', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101027', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101027', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101028', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101028', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101029', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101029', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101030', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101030', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101031', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101031', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101032', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101032', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101033', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070101033', '164', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102001', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102002', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102003', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102004', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102005', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102006', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102007', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102008', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102009', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102010', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102011', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102012', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102013', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102014', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102015', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102016', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102017', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102018', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102019', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102020', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102021', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102022', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102023', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102024', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102025', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102026', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102027', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102028', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102029', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102030', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102031', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102032', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102033', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102034', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102035', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102036', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102037', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102038', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102039', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102040', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102041', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102042', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102043', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102044', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102045', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102046', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102047', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102048', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102049', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102050', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102051', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102052', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102053', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102054', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102055', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102056', '164', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102057', '164', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102058', '164', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102059', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102060', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102061', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102062', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102063', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102064', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070102065', '164', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103001', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103002', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103003', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103004', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103005', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103006', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103007', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103008', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103009', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103010', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103011', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103012', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103013', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103014', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103015', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103016', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103017', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103018', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103019', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103020', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103021', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103022', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103023', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103024', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103025', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103026', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103027', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103028', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103029', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103030', '164', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103032', '164', '005');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070103032', '164', '006');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104001', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104002', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104003', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104004', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104005', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104006', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104007', '167', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104007', '123', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104007', '167', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104007', '123', '014');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104008', '167', '003');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104008', '123', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104008', '167', '004');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104008', '123', '014');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104009', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104010', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104011', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104012', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104013', '164', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104014', '164', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070104015', '164', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070105001', '135', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070105001', '135', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070105002', '135', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070105002', '135', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070105004', '135', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070105004', '135', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106001', '135', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106001', '135', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106002', '135', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106002', '135', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106003', '135', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106003', '135', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106004', '135', '012');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070106004', '135', '013');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107001', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107002', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107003', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107004', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107005', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107006', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107007', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107008', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107009', '157', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107010', '157', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107011', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107012', '157', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107013', '157', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107014', '157', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107016', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107016', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107017', '123', '007');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070107017', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108002', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108004', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108005', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108006', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108007', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108008', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108009', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108013', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108014', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108015', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108016', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108017', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108018', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070108019', '123', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109001', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109002', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109003', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109004', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109005', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109006', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109007', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109008', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109009', '164', '009');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109010', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109011', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109012', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109013', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109014', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109015', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109016', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109017', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109018', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109019', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109020', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109021', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109022', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070109023', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110001', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110002', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110003', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110004', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110005', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110006', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110007', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110008', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110009', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070110010', '123', '010');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070207004', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070207005', '131', '002');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070209005', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070209006', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070209007', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070209008', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070209009', '107', '008');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210001', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210002', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210003', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210004', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210005', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210006', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210007', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210008', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210009', '130', '001');
insert into ambbpa (fil_codigo, abp_codigoamb, abp_servico, abp_classificacao) values (1, '070210010', '130', '001');*/


insert into atualizacoes(atu_nome) values ('v17030003_190517.sql');
alter table paciente add pac_nomesocial varchar(80);

alter table usuariocompromisso add uco_codigopai integer;


create index xie7pacientesocial on paciente
(
       fil_codigo,
       pac_nomesocial
);

create index xie2usuariocompromissopai on usuariocompromisso
(
       uco_codigopai
);

insert into atualizacoes(atu_nome) values ('v17030004_250517.sql');

alter table paciente add pac_origemapoio boolean;

insert into atualizacoes(atu_nome) values ('v17030005_250517.sql');
