drop function fn_td_material() cascade;

create function fn_td_material() returns opaque as '
declare
	numrows integer;										 
begin
    select count(*) into numrows
      from interfaceexamereagente
      where
        interfaceexamereagente.fil_codigo = old.fil_codigo and
        interfaceexamereagente.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela interfaceexamereagente.'';
    end if;

    delete from materialusuario
      where
        materialusuario.fil_codigo = old.fil_codigo and
        materialusuario.mat_codigo = old.mat_codigo;

    select count(*) into numrows
      from materialalternativo
      where
        materialalternativo.fil_codigo = old.fil_codigo and
        materialalternativo.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialalternativo.'';
    end if;

    select count(*) into numrows
      from materiallote
      where
        materiallote.fil_codigo = old.fil_codigo and
        materiallote.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materiallote.'';
    end if;

    select count(*) into numrows
      from materialenviadomaterial
      where
        materialenviadomaterial.fil_codigo = old.fil_codigo and
        materialenviadomaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialenviadomaterial.'';
    end if;

    select count(*) into numrows
      from materialidentificado
      where
        materialidentificado.fil_codigo = old.fil_codigo and
        materialidentificado.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialidentificado.'';
    end if;

    select count(*) into numrows
      from montagemkitconsumido
      where
        montagemkitconsumido.fil_codigo = old.fil_codigo and
        montagemkitconsumido.mat_codconsumido = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela montagemkitconsumido.'';
    end if;

    select count(*) into numrows
      from montagemkitmaterial
      where
        montagemkitmaterial.fil_codigo = old.fil_codigo and
        montagemkitmaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela montagemkitmaterial.'';
    end if;

    select count(*) into numrows
      from transfestoquematerial
      where
        transfestoquematerial.fil_codigo = old.fil_codigo and
        transfestoquematerial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela transfestoquematerial.'';
    end if;

    select count(*) into numrows
      from estoquemanualmaterial
      where
        estoquemanualmaterial.fil_codigo = old.fil_codigo and
        estoquemanualmaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela estoquemanualmaterial.'';
    end if;

    select count(*) into numrows
      from requisicaoestoquematerial
      where
        requisicaoestoquematerial.fil_codigo = old.fil_codigo and
        requisicaoestoquematerial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaoestoquematerial.'';
    end if;

    select count(*) into numrows
      from lanctoestoque
      where
        lanctoestoque.fil_codigo = old.fil_codigo and
        lanctoestoque.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela lanctoestoque.'';
    end if;

    select count(*) into numrows
      from conferenciaestoquematerial
      where
        conferenciaestoquematerial.fil_codigo = old.fil_codigo and
        conferenciaestoquematerial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conferenciaestoquematerial.'';
    end if;

    select count(*) into numrows
      from conferenciaentradamaterial
      where
        conferenciaentradamaterial.fil_codigo = old.fil_codigo and
        conferenciaentradamaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conferenciaentradamaterial.'';
    end if;

    select count(*) into numrows
      from notafiscalmaterial
      where
        notafiscalmaterial.fil_codigo = old.fil_codigo and
        notafiscalmaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela notafiscalmaterial.'';
    end if;

    select count(*) into numrows
      from pedidomaterial
      where
        pedidomaterial.fil_codigo = old.fil_codigo and
        pedidomaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pedidomaterial.'';
    end if;

    select count(*) into numrows
      from fichatecnicamaterial
      where
        fichatecnicamaterial.fil_codigo = old.fil_codigo and
        fichatecnicamaterial.mat_codigofilho = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela fichatecnicamaterial.'';
    end if;

    select count(*) into numrows
      from fichatecnicamaterial
      where
        fichatecnicamaterial.fil_codigo = old.fil_codigo and
        fichatecnicamaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela fichatecnicamaterial.'';
    end if;

    select count(*) into numrows
      from cotacaomaterial
      where
        cotacaomaterial.fil_codigo = old.fil_codigo and
        cotacaomaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela cotacaomaterial.'';
    end if;

    select count(*) into numrows
      from saldoestoquecelula
      where
        saldoestoquecelula.fil_codigo = old.fil_codigo and
        saldoestoquecelula.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela saldoestoquecelula.'';
    end if;

    select count(*) into numrows
      from saldoestoque
      where
        saldoestoque.fil_codigo = old.fil_codigo and
        saldoestoque.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela saldoestoque.'';
    end if;

    select count(*) into numrows
      from materialpatrimonio
      where
        materialpatrimonio.fil_codigo = old.fil_codigo and
        materialpatrimonio.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialpatrimonio.'';
    end if;

    select count(*) into numrows
      from recipmaterial
      where
        recipmaterial.fil_codigo = old.fil_codigo and
        recipmaterial.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela recipmaterial.'';
    end if;

    select count(*) into numrows
      from materialexamerequis
      where
        materialexamerequis.fil_codigo = old.fil_codigo and
        materialexamerequis.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialexamerequis.'';
    end if;

    select count(*) into numrows
      from materialexame
      where
        materialexame.fil_codigo = old.fil_codigo and
        materialexame.mat_codigo = old.mat_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialexame.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_material
after delete on material
for each row execute procedure fn_td_material();


drop function fn_ti_material() cascade;

create function fn_ti_material() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from conferenciaentrada
      where
        new.fil_codigo = conferenciaentrada.fil_codigo and
        new.cen_codigoultcompra = conferenciaentrada.cen_codigo;
    tmp:=''conferenciaentrada|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cen_codigo='' || new.cen_codigoultcompra || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cen_codigoultcompra is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela conferenciaentrada. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from pedido
      where
        new.fil_codigo = pedido.fil_codigo and
        new.ped_codigoultcompra = pedido.ped_codigo;
    tmp:=''pedido|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''ped_codigo='' || new.ped_codigoultcompra || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.ped_codigoultcompra is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela pedido. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from notafiscal
      where
        new.fil_codigo = notafiscal.fil_codigo and
        new.nfi_codigoultcompra = notafiscal.nfi_codigo;
    tmp:=''notafiscal|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''nfi_codigo='' || new.nfi_codigoultcompra || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.nfi_codigoultcompra is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela notafiscal. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codavisolote = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codavisolote || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codavisolote is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codigo = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from unidademedida
      where
        new.fil_codigo = unidademedida.fil_codigo and
        new.unm_codigo = unidademedida.unm_codigo;
    tmp:=''unidademedida|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''unm_codigo='' || new.unm_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.unm_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela unidademedida. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from tipomaterial
      where
        new.fil_codigo = tipomaterial.fil_codigo and
        new.tpm_codigo = tipomaterial.tpm_codigo;
    tmp:=''tipomaterial|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''tpm_codigo='' || new.tpm_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.tpm_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela tipomaterial. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_material
after insert on material
for each row execute procedure fn_ti_material();


drop function fn_tu_material() cascade;

create function fn_tu_material() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from interfaceexamereagente
      where
        interfaceexamereagente.fil_codigo = old.fil_codigo and
        interfaceexamereagente.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela interfaceexamereagente.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materialusuario
      where
        materialusuario.fil_codigo = old.fil_codigo and
        materialusuario.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialusuario.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materialalternativo
      where
        materialalternativo.fil_codigo = old.fil_codigo and
        materialalternativo.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialalternativo.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materiallote
      where
        materiallote.fil_codigo = old.fil_codigo and
        materiallote.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materiallote.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materialenviadomaterial
      where
        materialenviadomaterial.fil_codigo = old.fil_codigo and
        materialenviadomaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialenviadomaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materialidentificado
      where
        materialidentificado.fil_codigo = old.fil_codigo and
        materialidentificado.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialidentificado.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from montagemkitconsumido
      where
        montagemkitconsumido.fil_codigo = old.fil_codigo and
        montagemkitconsumido.mat_codconsumido = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela montagemkitconsumido.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from montagemkitmaterial
      where
        montagemkitmaterial.fil_codigo = old.fil_codigo and
        montagemkitmaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela montagemkitmaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from transfestoquematerial
      where
        transfestoquematerial.fil_codigo = old.fil_codigo and
        transfestoquematerial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela transfestoquematerial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from estoquemanualmaterial
      where
        estoquemanualmaterial.fil_codigo = old.fil_codigo and
        estoquemanualmaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela estoquemanualmaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from requisicaoestoquematerial
      where
        requisicaoestoquematerial.fil_codigo = old.fil_codigo and
        requisicaoestoquematerial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaoestoquematerial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from lanctoestoque
      where
        lanctoestoque.fil_codigo = old.fil_codigo and
        lanctoestoque.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela lanctoestoque.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from conferenciaestoquematerial
      where
        conferenciaestoquematerial.fil_codigo = old.fil_codigo and
        conferenciaestoquematerial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conferenciaestoquematerial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from conferenciaentradamaterial
      where
        conferenciaentradamaterial.fil_codigo = old.fil_codigo and
        conferenciaentradamaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conferenciaentradamaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from notafiscalmaterial
      where
        notafiscalmaterial.fil_codigo = old.fil_codigo and
        notafiscalmaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela notafiscalmaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from pedidomaterial
      where
        pedidomaterial.fil_codigo = old.fil_codigo and
        pedidomaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pedidomaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from fichatecnicamaterial
      where
        fichatecnicamaterial.fil_codigo = old.fil_codigo and
        fichatecnicamaterial.mat_codigofilho = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela fichatecnicamaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from fichatecnicamaterial
      where
        fichatecnicamaterial.fil_codigo = old.fil_codigo and
        fichatecnicamaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela fichatecnicamaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from cotacaomaterial
      where
        cotacaomaterial.fil_codigo = old.fil_codigo and
        cotacaomaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela cotacaomaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from saldoestoquecelula
      where
        saldoestoquecelula.fil_codigo = old.fil_codigo and
        saldoestoquecelula.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela saldoestoquecelula.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from saldoestoque
      where
        saldoestoque.fil_codigo = old.fil_codigo and
        saldoestoque.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela saldoestoque.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materialpatrimonio
      where
        materialpatrimonio.fil_codigo = old.fil_codigo and
        materialpatrimonio.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialpatrimonio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from recipmaterial
      where
        recipmaterial.fil_codigo = old.fil_codigo and
        recipmaterial.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela recipmaterial.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materialexamerequis
      where
        materialexamerequis.fil_codigo = old.fil_codigo and
        materialexamerequis.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialexamerequis.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mat_codigo <> new.mat_codigo) then
    select count(*)
      from materialexame
      where
        materialexame.fil_codigo = old.fil_codigo and
        materialexame.mat_codigo = old.mat_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialexame.'';
    end if;
  end if;
  select count(*) into numrows
    from usuario
    where
      new.usr_codavisolote = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codavisolote || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codavisolote is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codigo = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from unidademedida
    where
      new.fil_codigo = unidademedida.fil_codigo and
      new.unm_codigo = unidademedida.unm_codigo;
    tmp:=''unidademedida|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''unm_codigo='' || new.unm_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.unm_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela unidademedida. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from tipomaterial
    where
      new.fil_codigo = tipomaterial.fil_codigo and
      new.tpm_codigo = tipomaterial.tpm_codigo;
    tmp:=''tipomaterial|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''tpm_codigo='' || new.tpm_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.tpm_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela tipomaterial. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_material
after update on material
for each row execute procedure fn_tu_material();




insert into atualizacoes(atu_nome) values ('v21040001_010621.sql');

alter table requisicaovisualizada add rvi_acessado varchar(30);



create table acessowebconvenio (
       awc_codigo           serial not null,
       fil_codigo           integer,
       con_codigo           integer,
       awc_datahora         timestamp default current_timestamp,
       awc_tipo             varchar(1)
);

create unique index xpkacessowebconvenio on acessowebconvenio
(
       awc_codigo
);

create index xif1acessowebconvenio on acessowebconvenio
(
       fil_codigo,
       con_codigo
);


alter table acessowebconvenio
       add primary key (awc_codigo);


create table acessowebdestino (
       awd_codigo           serial not null,
       fil_codigo           integer,
       des_codigo           varchar(5),
       awd_datahora         timestamp,
       awd_tipo             varchar(1)
);

create unique index xpkacessowebdestino on acessowebdestino
(
       awd_codigo
);

create index xif1acessowebdestino on acessowebdestino
(
       fil_codigo,
       des_codigo
);


alter table acessowebdestino
       add primary key (awd_codigo);


create table acessowebentidade (
       awe_codigo           serial not null,
       fil_codigo           integer,
       ent_codigo           integer,
       awe_datahora         timestamp,
       awe_tipo             varchar(1)
);

create unique index xpkacessowebentidade on acessowebentidade
(
       awe_codigo
);

create index xif1acessowebentidade on acessowebentidade
(
       fil_codigo,
       ent_codigo
);


alter table acessowebentidade
       add primary key (awe_codigo);


create table acessowebmedico (
       awm_codigo           serial not null,
       fil_codigo           integer,
       med_conselho         varchar(7),
       med_crm              varchar(10),
       med_uf               varchar(2),
       awm_datahora         timestamp,
       awm_tipo             varchar(1)
);

create unique index xpkacessowebmedico on acessowebmedico
(
       awm_codigo
);

create index xif1acessowebmedico on acessowebmedico
(
       fil_codigo,
       med_conselho,
       med_crm,
       med_uf
);


alter table acessowebmedico
       add primary key (awm_codigo);


create table acessowebpaciente (
       awp_codigo           serial not null,
       fil_codigo           integer,
       pac_codigo           integer,
       awp_datahora         timestamp,
       awp_tipo             varchar(1)
);

create unique index xpkacessowebpaciente on acessowebpaciente
(
       awp_codigo
);

create index xif1acessowebpaciente on acessowebpaciente
(
       fil_codigo,
       pac_codigo
);


alter table acessowebpaciente
       add primary key (awp_codigo);



create function fn_ti_acessowebconvenio() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from convenios
      where
        new.fil_codigo = convenios.fil_codigo and
        new.con_codigo = convenios.con_codigo;
    tmp:=''convenios|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''con_codigo='' || new.con_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.con_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela convenios. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_acessowebconvenio
after insert on acessowebconvenio
for each row execute procedure fn_ti_acessowebconvenio();



create function fn_tu_acessowebconvenio() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from convenios
    where
      new.fil_codigo = convenios.fil_codigo and
      new.con_codigo = convenios.con_codigo;
    tmp:=''convenios|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''con_codigo='' || new.con_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.con_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela convenios. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_acessowebconvenio
after update on acessowebconvenio
for each row execute procedure fn_tu_acessowebconvenio();



create function fn_ti_acessowebdestino() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from destino
      where
        new.fil_codigo = destino.fil_codigo and
        new.des_codigo = destino.des_codigo;
    tmp:=''destino|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''des_codigo='' || new.des_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.des_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela destino. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_acessowebdestino
after insert on acessowebdestino
for each row execute procedure fn_ti_acessowebdestino();



create function fn_tu_acessowebdestino() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from destino
    where
      new.fil_codigo = destino.fil_codigo and
      new.des_codigo = destino.des_codigo;
    tmp:=''destino|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''des_codigo='' || new.des_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.des_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela destino. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_acessowebdestino
after update on acessowebdestino
for each row execute procedure fn_tu_acessowebdestino();



create function fn_ti_acessowebentidade() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from entidade
      where
        new.fil_codigo = entidade.fil_codigo and
        new.ent_codigo = entidade.ent_codigo;
    tmp:=''entidade|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''ent_codigo='' || new.ent_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.ent_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela entidade. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_acessowebentidade
after insert on acessowebentidade
for each row execute procedure fn_ti_acessowebentidade();



create function fn_tu_acessowebentidade() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from entidade
    where
      new.fil_codigo = entidade.fil_codigo and
      new.ent_codigo = entidade.ent_codigo;
    tmp:=''entidade|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''ent_codigo='' || new.ent_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.ent_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela entidade. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_acessowebentidade
after update on acessowebentidade
for each row execute procedure fn_tu_acessowebentidade();



create function fn_ti_acessowebmedico() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from medico
      where
        new.fil_codigo = medico.fil_codigo and
        new.med_conselho = medico.med_conselho and
        new.med_crm = medico.med_crm and
        new.med_uf = medico.med_uf;
    tmp:=''medico|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''med_conselho='' || new.med_conselho || ''|'';
    
      tmp:=tmp || ''med_crm='' || new.med_crm || ''|'';
    
      tmp:=tmp || ''med_uf='' || new.med_uf || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.med_conselho is not null and
      new.med_crm is not null and
      new.med_uf is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela medico. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_acessowebmedico
after insert on acessowebmedico
for each row execute procedure fn_ti_acessowebmedico();



create function fn_tu_acessowebmedico() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from medico
    where
      new.fil_codigo = medico.fil_codigo and
      new.med_conselho = medico.med_conselho and
      new.med_crm = medico.med_crm and
      new.med_uf = medico.med_uf;
    tmp:=''medico|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''med_conselho='' || new.med_conselho || ''|'';
    
      tmp:=tmp || ''med_crm='' || new.med_crm || ''|'';
    
      tmp:=tmp || ''med_uf='' || new.med_uf || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.med_conselho is not null and
    new.med_crm is not null and
    new.med_uf is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela medico. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_acessowebmedico
after update on acessowebmedico
for each row execute procedure fn_tu_acessowebmedico();



create function fn_ti_acessowebpaciente() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from paciente
      where
        new.fil_codigo = paciente.fil_codigo and
        new.pac_codigo = paciente.pac_codigo;
    tmp:=''paciente|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''pac_codigo='' || new.pac_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.pac_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela paciente. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_acessowebpaciente
after insert on acessowebpaciente
for each row execute procedure fn_ti_acessowebpaciente();



create function fn_tu_acessowebpaciente() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from paciente
    where
      new.fil_codigo = paciente.fil_codigo and
      new.pac_codigo = paciente.pac_codigo;
    tmp:=''paciente|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''pac_codigo='' || new.pac_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.pac_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela paciente. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_acessowebpaciente
after update on acessowebpaciente
for each row execute procedure fn_tu_acessowebpaciente();


drop function fn_td_convenios() cascade;

create function fn_td_convenios() returns opaque as '
declare
	numrows integer;										 
begin
    delete from acessowebconvenio
      where
        acessowebconvenio.fil_codigo = old.fil_codigo and
        acessowebconvenio.con_codigo = old.con_codigo;

    select count(*) into numrows
      from conveniounidadesaude
      where
        conveniounidadesaude.fil_codigo = old.fil_codigo and
        conveniounidadesaude.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conveniounidadesaude.'';
    end if;

    delete from conveniosintegracaooperadora
      where
        conveniosintegracaooperadora.fil_codigo = old.fil_codigo and
        conveniosintegracaooperadora.con_codigo = old.con_codigo;

    select count(*) into numrows
      from exportaintegracaooperadora
      where
        exportaintegracaooperadora.fil_codigo = old.fil_codigo and
        exportaintegracaooperadora.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela exportaintegracaooperadora.'';
    end if;

    delete from conveniocotaexamesituacao
      where
        conveniocotaexamesituacao.fil_codigo = old.fil_codigo and
        conveniocotaexamesituacao.con_codigo = old.con_codigo;

    select count(*) into numrows
      from conveniocotaexame
      where
        conveniocotaexame.fil_codigo = old.fil_codigo and
        conveniocotaexame.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conveniocotaexame.'';
    end if;

    select count(*) into numrows
      from conveniomatricula
      where
        conveniomatricula.fil_codigo = old.fil_codigo and
        conveniomatricula.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conveniomatricula.'';
    end if;

    delete from conveniostaxa
      where
        conveniostaxa.fil_codigo = old.fil_codigo and
        conveniostaxa.con_codigo = old.con_codigo;

    delete from convenioshistoricocota
      where
        convenioshistoricocota.fil_codigo = old.fil_codigo and
        convenioshistoricocota.con_codigo = old.con_codigo;

    select count(*) into numrows
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaoweb.'';
    end if;

    delete from convenioapoiado
      where
        convenioapoiado.fil_codigo = old.fil_codigo and
        convenioapoiado.con_codigo = old.con_codigo;

    delete from apropriaplanoconta
      where
        apropriaplanoconta.fil_codigo = old.fil_codigo and
        apropriaplanoconta.con_codigo = old.con_codigo;

    delete from apropriacentrocusto
      where
        apropriacentrocusto.fil_codigo = old.fil_codigo and
        apropriacentrocusto.con_codigo = old.con_codigo;

    delete from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo and
        contrassenharequisicao.con_codigo = old.con_codigo;

    delete from convenioignorarecebimento
      where
        convenioignorarecebimento.fil_codigo = old.fil_codigo and
        convenioignorarecebimento.con_codigo = old.con_codigo;

    select count(*) into numrows
      from materialenviado
      where
        materialenviado.fil_codigo = old.fil_codigo and
        materialenviado.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialenviado.'';
    end if;

    select count(*) into numrows
      from faturarequisicao
      where
        faturarequisicao.fil_codigo = old.fil_codigo and
        faturarequisicao.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela faturarequisicao.'';
    end if;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.con_codrepasse = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;

    select count(*) into numrows
      from conveniosrepasse
      where
        conveniosrepasse.fil_codigo = old.fil_codigo and
        conveniosrepasse.con_codrepasse = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conveniosrepasse.'';
    end if;

    delete from conveniosrepasse
      where
        conveniosrepasse.fil_codigo = old.fil_codigo and
        conveniosrepasse.con_codigo = old.con_codigo;

    delete from conveniospreco
      where
        conveniospreco.fil_codigo = old.fil_codigo and
        conveniospreco.con_codigo = old.con_codigo;

    select count(*) into numrows
      from orcamentoconvenio
      where
        orcamentoconvenio.fil_codigo = old.fil_codigo and
        orcamentoconvenio.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela orcamentoconvenio.'';
    end if;

    delete from convenioentidade
      where
        convenioentidade.fil_codigo = old.fil_codigo and
        convenioentidade.con_codigo = old.con_codigo;

    select count(*) into numrows
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo and
        notafiscal.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela notafiscal.'';
    end if;

    select count(*) into numrows
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo and
        receberpagar.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela receberpagar.'';
    end if;

    delete from convenioscontatos
      where
        convenioscontatos.fil_codigo = old.fil_codigo and
        convenioscontatos.con_codigo = old.con_codigo;

    delete from medicoconvenioproibido
      where
        medicoconvenioproibido.fil_codigo = old.fil_codigo and
        medicoconvenioproibido.con_codigo = old.con_codigo;

    select count(*) into numrows
      from medicoconveniotiss
      where
        medicoconveniotiss.fil_codigo = old.fil_codigo and
        medicoconveniotiss.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medicoconveniotiss.'';
    end if;

    select count(*) into numrows
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo and
        paciente.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela paciente.'';
    end if;

    select count(*) into numrows
      from examematconvenioprazo
      where
        examematconvenioprazo.fil_codigo = old.fil_codigo and
        examematconvenioprazo.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examematconvenioprazo.'';
    end if;

    select count(*) into numrows
      from loteapoio
      where
        loteapoio.fil_codigo = old.fil_codigo and
        loteapoio.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela loteapoio.'';
    end if;

    delete from exportaapoio
      where
        exportaapoio.fil_codigo = old.fil_codigo and
        exportaapoio.con_codigo = old.con_codigo;

    select count(*) into numrows
      from conveniomensagem
      where
        conveniomensagem.fil_codigo = old.fil_codigo and
        conveniomensagem.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela conveniomensagem.'';
    end if;

    select count(*) into numrows
      from fatura
      where
        fatura.fil_codigo = old.fil_codigo and
        fatura.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela fatura.'';
    end if;

    select count(*) into numrows
      from agrupasituacao
      where
        agrupasituacao.fil_codigo = old.fil_codigo and
        agrupasituacao.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela agrupasituacao.'';
    end if;

    select count(*) into numrows
      from agrupaexameconvenio
      where
        agrupaexameconvenio.fil_codigo = old.fil_codigo and
        agrupaexameconvenio.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela agrupaexameconvenio.'';
    end if;

    delete from examesmatconvenio
      where
        examesmatconvenio.fil_codigo = old.fil_codigo and
        examesmatconvenio.con_codigo = old.con_codigo;

    delete from conveniodesconto
      where
        conveniodesconto.fil_codigo = old.fil_codigo and
        conveniodesconto.con_codigo = old.con_codigo;

    select count(*) into numrows
      from filialfatura
      where
        filialfatura.fil_codigo = old.fil_codigo and
        filialfatura.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filialfatura.'';
    end if;

    select count(*) into numrows
      from filialfatura
      where
        filialfatura.fil_codfat = old.fil_codigo and
        filialfatura.con_codfat = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filialfatura.'';
    end if;

    delete from adicionalfatura
      where
        adicionalfatura.fil_codigo = old.fil_codigo and
        adicionalfatura.con_codigo = old.con_codigo;

    delete from despcobranca
      where
        despcobranca.fil_codigo = old.fil_codigo and
        despcobranca.con_codigo = old.con_codigo;

    delete from pacienteconvenio
      where
        pacienteconvenio.fil_codigo = old.fil_codigo and
        pacienteconvenio.con_codigo = old.con_codigo;

    select count(*) into numrows
      from medicoconvenio
      where
        medicoconvenio.fil_codigo = old.fil_codigo and
        medicoconvenio.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medicoconvenio.'';
    end if;

    delete from destinoconvlayout
      where
        destinoconvlayout.fil_codigo = old.fil_codigo and
        destinoconvlayout.con_codigo = old.con_codigo;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.con_codigo = old.con_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;

    delete from conveniosvencimento
      where
        conveniosvencimento.fil_codigo = old.fil_codigo and
        conveniosvencimento.con_codigo = old.con_codigo;


return old;
end;'
language 'plpgsql';
					
create trigger td_convenios
after delete on convenios
for each row execute procedure fn_td_convenios();


drop function fn_ti_convenios() cascade;

create function fn_ti_convenios() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from layout
      where
        new.lay_codigoapoio = layout.lay_codigo and
        new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigoapoio || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.lay_codigoapoio is not null and
      new.fil_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from rota
      where
        new.fil_codigo = rota.fil_codigo and
        new.rot_codigo = rota.rot_codigo;
    tmp:=''rota|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''rot_codigo='' || new.rot_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.rot_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela rota. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from celulaestoque
      where
        new.fil_codigo = celulaestoque.fil_codigo and
        new.cel_codigo = celulaestoque.cel_codigo;
    tmp:=''celulaestoque|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cel_codigo='' || new.cel_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cel_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela celulaestoque. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codigo = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from layout
      where
        new.lay_codigo = layout.lay_codigo and
        new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigo || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.lay_codigo is not null and
      new.fil_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.bai_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codcobranca = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codcobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.bai_codcobranca is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cid_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codcobranca = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codcobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cid_codcobranca is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from tabelaprecoexames
      where
        new.fil_codigo = tabelaprecoexames.fil_codigo and
        new.tpe_codigo = tabelaprecoexames.tpe_codigo;
    tmp:=''tabelaprecoexames|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''tpe_codigo='' || new.tpe_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.tpe_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela tabelaprecoexames. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from prioridade
      where
        new.fil_codigo = prioridade.fil_codigo and
        new.pri_codigo = prioridade.pri_codigo;
    tmp:=''prioridade|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''pri_codigo='' || new.pri_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.pri_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela prioridade. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from destino
      where
        new.fil_codigo = destino.fil_codigo and
        new.des_codigo = destino.des_codigo;
    tmp:=''destino|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''des_codigo='' || new.des_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.des_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela destino. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from coletas
      where
        new.fil_codigo = coletas.fil_codigo and
        new.col_codigo = coletas.col_codigo;
    tmp:=''coletas|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''col_codigo='' || new.col_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.col_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela coletas. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_convenios
after insert on convenios
for each row execute procedure fn_ti_convenios();


drop function fn_tu_convenios() cascade;

create function fn_tu_convenios() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from acessowebconvenio
      where
        acessowebconvenio.fil_codigo = old.fil_codigo and
        acessowebconvenio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela acessowebconvenio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniounidadesaude
      where
        conveniounidadesaude.fil_codigo = old.fil_codigo and
        conveniounidadesaude.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniounidadesaude.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniosintegracaooperadora
      where
        conveniosintegracaooperadora.fil_codigo = old.fil_codigo and
        conveniosintegracaooperadora.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniosintegracaooperadora.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from exportaintegracaooperadora
      where
        exportaintegracaooperadora.fil_codigo = old.fil_codigo and
        exportaintegracaooperadora.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportaintegracaooperadora.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniocotaexamesituacao
      where
        conveniocotaexamesituacao.fil_codigo = old.fil_codigo and
        conveniocotaexamesituacao.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniocotaexamesituacao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniocotaexame
      where
        conveniocotaexame.fil_codigo = old.fil_codigo and
        conveniocotaexame.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniocotaexame.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniomatricula
      where
        conveniomatricula.fil_codigo = old.fil_codigo and
        conveniomatricula.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniomatricula.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniostaxa
      where
        conveniostaxa.fil_codigo = old.fil_codigo and
        conveniostaxa.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniostaxa.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from convenioshistoricocota
      where
        convenioshistoricocota.fil_codigo = old.fil_codigo and
        convenioshistoricocota.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenioshistoricocota.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaoweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from convenioapoiado
      where
        convenioapoiado.fil_codigo = old.fil_codigo and
        convenioapoiado.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenioapoiado.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from apropriaplanoconta
      where
        apropriaplanoconta.fil_codigo = old.fil_codigo and
        apropriaplanoconta.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela apropriaplanoconta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from apropriacentrocusto
      where
        apropriacentrocusto.fil_codigo = old.fil_codigo and
        apropriacentrocusto.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela apropriacentrocusto.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo and
        contrassenharequisicao.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela contrassenharequisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from convenioignorarecebimento
      where
        convenioignorarecebimento.fil_codigo = old.fil_codigo and
        convenioignorarecebimento.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenioignorarecebimento.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from materialenviado
      where
        materialenviado.fil_codigo = old.fil_codigo and
        materialenviado.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialenviado.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from faturarequisicao
      where
        faturarequisicao.fil_codigo = old.fil_codigo and
        faturarequisicao.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela faturarequisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.con_codrepasse = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniosrepasse
      where
        conveniosrepasse.fil_codigo = old.fil_codigo and
        conveniosrepasse.con_codrepasse = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniosrepasse.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniosrepasse
      where
        conveniosrepasse.fil_codigo = old.fil_codigo and
        conveniosrepasse.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniosrepasse.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniospreco
      where
        conveniospreco.fil_codigo = old.fil_codigo and
        conveniospreco.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniospreco.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from orcamentoconvenio
      where
        orcamentoconvenio.fil_codigo = old.fil_codigo and
        orcamentoconvenio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela orcamentoconvenio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from convenioentidade
      where
        convenioentidade.fil_codigo = old.fil_codigo and
        convenioentidade.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenioentidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo and
        notafiscal.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela notafiscal.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo and
        receberpagar.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela receberpagar.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from convenioscontatos
      where
        convenioscontatos.fil_codigo = old.fil_codigo and
        convenioscontatos.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenioscontatos.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from medicoconvenioproibido
      where
        medicoconvenioproibido.fil_codigo = old.fil_codigo and
        medicoconvenioproibido.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoconvenioproibido.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from medicoconveniotiss
      where
        medicoconveniotiss.fil_codigo = old.fil_codigo and
        medicoconveniotiss.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoconveniotiss.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo and
        paciente.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela paciente.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from examematconvenioprazo
      where
        examematconvenioprazo.fil_codigo = old.fil_codigo and
        examematconvenioprazo.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examematconvenioprazo.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from loteapoio
      where
        loteapoio.fil_codigo = old.fil_codigo and
        loteapoio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela loteapoio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from exportaapoio
      where
        exportaapoio.fil_codigo = old.fil_codigo and
        exportaapoio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportaapoio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniomensagem
      where
        conveniomensagem.fil_codigo = old.fil_codigo and
        conveniomensagem.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniomensagem.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from fatura
      where
        fatura.fil_codigo = old.fil_codigo and
        fatura.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela fatura.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from agrupasituacao
      where
        agrupasituacao.fil_codigo = old.fil_codigo and
        agrupasituacao.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela agrupasituacao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from agrupaexameconvenio
      where
        agrupaexameconvenio.fil_codigo = old.fil_codigo and
        agrupaexameconvenio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela agrupaexameconvenio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from examesmatconvenio
      where
        examesmatconvenio.fil_codigo = old.fil_codigo and
        examesmatconvenio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesmatconvenio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniodesconto
      where
        conveniodesconto.fil_codigo = old.fil_codigo and
        conveniodesconto.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniodesconto.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from filialfatura
      where
        filialfatura.fil_codigo = old.fil_codigo and
        filialfatura.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filialfatura.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from filialfatura
      where
        filialfatura.fil_codfat = old.fil_codigo and
        filialfatura.con_codfat = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filialfatura.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from adicionalfatura
      where
        adicionalfatura.fil_codigo = old.fil_codigo and
        adicionalfatura.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela adicionalfatura.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from despcobranca
      where
        despcobranca.fil_codigo = old.fil_codigo and
        despcobranca.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela despcobranca.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from pacienteconvenio
      where
        pacienteconvenio.fil_codigo = old.fil_codigo and
        pacienteconvenio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacienteconvenio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from medicoconvenio
      where
        medicoconvenio.fil_codigo = old.fil_codigo and
        medicoconvenio.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoconvenio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from destinoconvlayout
      where
        destinoconvlayout.fil_codigo = old.fil_codigo and
        destinoconvlayout.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela destinoconvlayout.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.con_codigo <> new.con_codigo) then
    select count(*)
      from conveniosvencimento
      where
        conveniosvencimento.fil_codigo = old.fil_codigo and
        conveniosvencimento.con_codigo = old.con_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela conveniosvencimento.'';
    end if;
  end if;
  select count(*) into numrows
    from layout
    where
      new.lay_codigoapoio = layout.lay_codigo and
      new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigoapoio || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.lay_codigoapoio is not null and
    new.fil_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from rota
    where
      new.fil_codigo = rota.fil_codigo and
      new.rot_codigo = rota.rot_codigo;
    tmp:=''rota|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''rot_codigo='' || new.rot_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.rot_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela rota. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from celulaestoque
    where
      new.fil_codigo = celulaestoque.fil_codigo and
      new.cel_codigo = celulaestoque.cel_codigo;
    tmp:=''celulaestoque|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cel_codigo='' || new.cel_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cel_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela celulaestoque. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codigo = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from layout
    where
      new.lay_codigo = layout.lay_codigo and
      new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigo || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.lay_codigo is not null and
    new.fil_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.bai_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codcobranca = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codcobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.bai_codcobranca is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cid_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codcobranca = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codcobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cid_codcobranca is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from tabelaprecoexames
    where
      new.fil_codigo = tabelaprecoexames.fil_codigo and
      new.tpe_codigo = tabelaprecoexames.tpe_codigo;
    tmp:=''tabelaprecoexames|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''tpe_codigo='' || new.tpe_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.tpe_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela tabelaprecoexames. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from prioridade
    where
      new.fil_codigo = prioridade.fil_codigo and
      new.pri_codigo = prioridade.pri_codigo;
    tmp:=''prioridade|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''pri_codigo='' || new.pri_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.pri_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela prioridade. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from destino
    where
      new.fil_codigo = destino.fil_codigo and
      new.des_codigo = destino.des_codigo;
    tmp:=''destino|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''des_codigo='' || new.des_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.des_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela destino. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from coletas
    where
      new.fil_codigo = coletas.fil_codigo and
      new.col_codigo = coletas.col_codigo;
    tmp:=''coletas|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''col_codigo='' || new.col_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.col_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela coletas. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_convenios
after update on convenios
for each row execute procedure fn_tu_convenios();


drop function fn_td_destino() cascade;

create function fn_td_destino() returns opaque as '
declare
	numrows integer;										 
begin
    delete from acessowebdestino
      where
        acessowebdestino.fil_codigo = old.fil_codigo and
        acessowebdestino.des_codigo = old.des_codigo;

    select count(*) into numrows
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.des_codigo = old.des_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaoweb.'';
    end if;

    select count(*) into numrows
      from medicodestino
      where
        medicodestino.fil_codigo = old.fil_codigo and
        medicodestino.des_codigo = old.des_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medicodestino.'';
    end if;

    delete from destinotaxa
      where
        destinotaxa.fil_codigo = old.fil_codigo and
        destinotaxa.des_codigo = old.des_codigo;

    select count(*) into numrows
      from examecoletadestino
      where
        examecoletadestino.fil_codigo = old.fil_codigo and
        examecoletadestino.des_codigo = old.des_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examecoletadestino.'';
    end if;

    select count(*) into numrows
      from pacienteentidadedestino
      where
        pacienteentidadedestino.fil_codigo = old.fil_codigo and
        pacienteentidadedestino.des_codigo = old.des_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pacienteentidadedestino.'';
    end if;

    delete from destinoconvlayout
      where
        destinoconvlayout.fil_codigo = old.fil_codigo and
        destinoconvlayout.des_codigo = old.des_codigo;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.des_codigo = old.des_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;

    select count(*) into numrows
      from convenios
      where
        convenios.fil_codigo = old.fil_codigo and
        convenios.des_codigo = old.des_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela convenios.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_destino
after delete on destino
for each row execute procedure fn_td_destino();


drop function fn_ti_destino() cascade;

create function fn_ti_destino() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.bai_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cid_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_destino
after insert on destino
for each row execute procedure fn_ti_destino();


drop function fn_tu_destino() cascade;

create function fn_tu_destino() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from acessowebdestino
      where
        acessowebdestino.fil_codigo = old.fil_codigo and
        acessowebdestino.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela acessowebdestino.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaoweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from medicodestino
      where
        medicodestino.fil_codigo = old.fil_codigo and
        medicodestino.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicodestino.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from destinotaxa
      where
        destinotaxa.fil_codigo = old.fil_codigo and
        destinotaxa.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela destinotaxa.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from examecoletadestino
      where
        examecoletadestino.fil_codigo = old.fil_codigo and
        examecoletadestino.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examecoletadestino.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from pacienteentidadedestino
      where
        pacienteentidadedestino.fil_codigo = old.fil_codigo and
        pacienteentidadedestino.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacienteentidadedestino.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from destinoconvlayout
      where
        destinoconvlayout.fil_codigo = old.fil_codigo and
        destinoconvlayout.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela destinoconvlayout.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.des_codigo <> new.des_codigo) then
    select count(*)
      from convenios
      where
        convenios.fil_codigo = old.fil_codigo and
        convenios.des_codigo = old.des_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenios.'';
    end if;
  end if;
  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.bai_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cid_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_destino
after update on destino
for each row execute procedure fn_tu_destino();


drop function fn_td_entidade() cascade;

create function fn_td_entidade() returns opaque as '
declare
	numrows integer;										 
begin
    delete from acessowebentidade
      where
        acessowebentidade.fil_codigo = old.fil_codigo and
        acessowebentidade.ent_codigo = old.ent_codigo;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.ent_codempresa = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;

    select count(*) into numrows
      from naoconformidade
      where
        naoconformidade.fil_codigo = old.fil_codigo and
        naoconformidade.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela naoconformidade.'';
    end if;

    select count(*) into numrows
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo and
        paciente.ent_codempresa = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela paciente.'';
    end if;

    select count(*) into numrows
      from pedido
      where
        pedido.fil_codigo = old.fil_codigo and
        pedido.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pedido.'';
    end if;

    select count(*) into numrows
      from cotacaoentidade
      where
        cotacaoentidade.fil_codigo = old.fil_codigo and
        cotacaoentidade.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela cotacaoentidade.'';
    end if;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;

    select count(*) into numrows
      from convenioentidade
      where
        convenioentidade.fil_codigo = old.fil_codigo and
        convenioentidade.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela convenioentidade.'';
    end if;

    select count(*) into numrows
      from pacienteentidade
      where
        pacienteentidade.fil_codigo = old.fil_codigo and
        pacienteentidade.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pacienteentidade.'';
    end if;

    select count(*) into numrows
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo and
        notafiscal.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela notafiscal.'';
    end if;

    select count(*) into numrows
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo and
        receberpagar.ent_codigo = old.ent_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela receberpagar.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_entidade
after delete on entidade
for each row execute procedure fn_td_entidade();


drop function fn_ti_entidade() cascade;

create function fn_ti_entidade() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_entidade
after insert on entidade
for each row execute procedure fn_ti_entidade();


drop function fn_tu_entidade() cascade;

create function fn_tu_entidade() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from acessowebentidade
      where
        acessowebentidade.fil_codigo = old.fil_codigo and
        acessowebentidade.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela acessowebentidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.ent_codempresa = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from naoconformidade
      where
        naoconformidade.fil_codigo = old.fil_codigo and
        naoconformidade.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela naoconformidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo and
        paciente.ent_codempresa = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela paciente.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from pedido
      where
        pedido.fil_codigo = old.fil_codigo and
        pedido.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pedido.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from cotacaoentidade
      where
        cotacaoentidade.fil_codigo = old.fil_codigo and
        cotacaoentidade.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela cotacaoentidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from convenioentidade
      where
        convenioentidade.fil_codigo = old.fil_codigo and
        convenioentidade.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenioentidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from pacienteentidade
      where
        pacienteentidade.fil_codigo = old.fil_codigo and
        pacienteentidade.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacienteentidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo and
        notafiscal.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela notafiscal.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.ent_codigo <> new.ent_codigo) then
    select count(*)
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo and
        receberpagar.ent_codigo = old.ent_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela receberpagar.'';
    end if;
  end if;
  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_entidade
after update on entidade
for each row execute procedure fn_tu_entidade();


drop function fn_td_medico() cascade;

create function fn_td_medico() returns opaque as '
declare
	numrows integer;										 
begin
    delete from acessowebmedico
      where
        acessowebmedico.fil_codigo = old.fil_codigo and
        acessowebmedico.med_conselho = old.med_conselho and
        acessowebmedico.med_crm = old.med_crm and
        acessowebmedico.med_uf = old.med_uf;

    select count(*) into numrows
      from medicocontato
      where
        medicocontato.fil_codigo = old.fil_codigo and
        medicocontato.med_conselho = old.med_conselho and
        medicocontato.med_crm = old.med_crm and
        medicocontato.med_uf = old.med_uf;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medicocontato.'';
    end if;

    select count(*) into numrows
      from orcamento
      where
        orcamento.fil_codigo = old.fil_codigo and
        orcamento.med_conselho = old.med_conselho and
        orcamento.med_crm = old.med_crm and
        orcamento.med_uf = old.med_uf;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela orcamento.'';
    end if;

    select count(*) into numrows
      from medicodestino
      where
        medicodestino.fil_codigo = old.fil_codigo and
        medicodestino.med_conselho = old.med_conselho and
        medicodestino.med_crm = old.med_crm and
        medicodestino.med_uf = old.med_uf;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medicodestino.'';
    end if;

    select count(*) into numrows
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.med_conselho = old.med_conselho and
        requisicaoweb.med_crm = old.med_crm and
        requisicaoweb.med_uf = old.med_uf;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaoweb.'';
    end if;

    delete from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo and
        contrassenharequisicao.med_conselho = old.med_conselho and
        contrassenharequisicao.med_crm = old.med_crm and
        contrassenharequisicao.med_uf = old.med_uf;

    delete from medicoexameweb
      where
        medicoexameweb.fil_codigo = old.fil_codigo and
        medicoexameweb.med_conselho = old.med_conselho and
        medicoexameweb.med_crm = old.med_crm and
        medicoexameweb.med_uf = old.med_uf;

    delete from medicoconvenioproibido
      where
        medicoconvenioproibido.fil_codigo = old.fil_codigo and
        medicoconvenioproibido.med_conselho = old.med_conselho and
        medicoconvenioproibido.med_crm = old.med_crm and
        medicoconvenioproibido.med_uf = old.med_uf;

    delete from medicoconveniotiss
      where
        medicoconveniotiss.fil_codigo = old.fil_codigo and
        medicoconveniotiss.med_conselho = old.med_conselho and
        medicoconveniotiss.med_crm = old.med_crm and
        medicoconveniotiss.med_uf = old.med_uf;

    select count(*) into numrows
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo and
        paciente.med_conselho = old.med_conselho and
        paciente.med_crm = old.med_crm and
        paciente.med_uf = old.med_uf;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela paciente.'';
    end if;

    delete from medicoespecialidades
      where
        medicoespecialidades.fil_codigo = old.fil_codigo and
        medicoespecialidades.med_conselho = old.med_conselho and
        medicoespecialidades.med_crm = old.med_crm and
        medicoespecialidades.med_uf = old.med_uf;

    select count(*) into numrows
      from medicoconvenio
      where
        medicoconvenio.fil_codigo = old.fil_codigo and
        medicoconvenio.med_conselho = old.med_conselho and
        medicoconvenio.med_crm = old.med_crm and
        medicoconvenio.med_uf = old.med_uf;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela medicoconvenio.'';
    end if;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.med_conselho = old.med_conselho and
        requisicao.med_crm = old.med_crm and
        requisicao.med_uf = old.med_uf;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_medico
after delete on medico
for each row execute procedure fn_td_medico();


drop function fn_ti_medico() cascade;

create function fn_ti_medico() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from celulaestoque
      where
        new.fil_codigo = celulaestoque.fil_codigo and
        new.cel_codigo = celulaestoque.cel_codigo;
    tmp:=''celulaestoque|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cel_codigo='' || new.cel_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cel_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela celulaestoque. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.bai_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cid_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_medico
after insert on medico
for each row execute procedure fn_ti_medico();


drop function fn_tu_medico() cascade;

create function fn_tu_medico() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from acessowebmedico
      where
        acessowebmedico.fil_codigo = old.fil_codigo and
        acessowebmedico.med_conselho = old.med_conselho and
        acessowebmedico.med_crm = old.med_crm and
        acessowebmedico.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela acessowebmedico.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from medicocontato
      where
        medicocontato.fil_codigo = old.fil_codigo and
        medicocontato.med_conselho = old.med_conselho and
        medicocontato.med_crm = old.med_crm and
        medicocontato.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicocontato.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from orcamento
      where
        orcamento.fil_codigo = old.fil_codigo and
        orcamento.med_conselho = old.med_conselho and
        orcamento.med_crm = old.med_crm and
        orcamento.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela orcamento.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from medicodestino
      where
        medicodestino.fil_codigo = old.fil_codigo and
        medicodestino.med_conselho = old.med_conselho and
        medicodestino.med_crm = old.med_crm and
        medicodestino.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicodestino.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.med_conselho = old.med_conselho and
        requisicaoweb.med_crm = old.med_crm and
        requisicaoweb.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaoweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo and
        contrassenharequisicao.med_conselho = old.med_conselho and
        contrassenharequisicao.med_crm = old.med_crm and
        contrassenharequisicao.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela contrassenharequisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from medicoexameweb
      where
        medicoexameweb.fil_codigo = old.fil_codigo and
        medicoexameweb.med_conselho = old.med_conselho and
        medicoexameweb.med_crm = old.med_crm and
        medicoexameweb.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoexameweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from medicoconvenioproibido
      where
        medicoconvenioproibido.fil_codigo = old.fil_codigo and
        medicoconvenioproibido.med_conselho = old.med_conselho and
        medicoconvenioproibido.med_crm = old.med_crm and
        medicoconvenioproibido.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoconvenioproibido.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from medicoconveniotiss
      where
        medicoconveniotiss.fil_codigo = old.fil_codigo and
        medicoconveniotiss.med_conselho = old.med_conselho and
        medicoconveniotiss.med_crm = old.med_crm and
        medicoconveniotiss.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoconveniotiss.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from paciente
      where
        paciente.fil_codigo = old.fil_codigo and
        paciente.med_conselho = old.med_conselho and
        paciente.med_crm = old.med_crm and
        paciente.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela paciente.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from medicoespecialidades
      where
        medicoespecialidades.fil_codigo = old.fil_codigo and
        medicoespecialidades.med_conselho = old.med_conselho and
        medicoespecialidades.med_crm = old.med_crm and
        medicoespecialidades.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoespecialidades.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from medicoconvenio
      where
        medicoconvenio.fil_codigo = old.fil_codigo and
        medicoconvenio.med_conselho = old.med_conselho and
        medicoconvenio.med_crm = old.med_crm and
        medicoconvenio.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela medicoconvenio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.med_conselho <> new.med_conselho or 
     old.med_crm <> new.med_crm or 
     old.med_uf <> new.med_uf) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.med_conselho = old.med_conselho and
        requisicao.med_crm = old.med_crm and
        requisicao.med_uf = old.med_uf into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  select count(*) into numrows
    from celulaestoque
    where
      new.fil_codigo = celulaestoque.fil_codigo and
      new.cel_codigo = celulaestoque.cel_codigo;
    tmp:=''celulaestoque|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cel_codigo='' || new.cel_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cel_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela celulaestoque. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.bai_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cid_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_medico
after update on medico
for each row execute procedure fn_tu_medico();


drop function fn_td_paciente() cascade;

create function fn_td_paciente() returns opaque as '
declare
	numrows integer;										 
begin
    delete from acessowebpaciente
      where
        acessowebpaciente.fil_codigo = old.fil_codigo and
        acessowebpaciente.pac_codigo = old.pac_codigo;

    delete from logpushapp
      where
        logpushapp.fil_codigo = old.fil_codigo and
        logpushapp.pac_codigo = old.pac_codigo;

    select count(*) into numrows
      from logemail
      where
        logemail.fil_codigo = old.fil_codigo and
        logemail.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela logemail.'';
    end if;

    delete from exportaintegracaooperadora
      where
        exportaintegracaooperadora.fil_codigo = old.fil_codigo and
        exportaintegracaooperadora.pac_codigo = old.pac_codigo;

    delete from pacienteimagens
      where
        pacienteimagens.fil_codigo = old.fil_codigo and
        pacienteimagens.pac_codigo = old.pac_codigo;

    delete from logsms
      where
        logsms.fil_codigo = old.fil_codigo and
        logsms.pac_codigo = old.pac_codigo;

    select count(*) into numrows
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaoweb.'';
    end if;

    delete from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo and
        contrassenharequisicao.pac_codigo = old.pac_codigo;

    select count(*) into numrows
      from materialenviado
      where
        materialenviado.fil_codigo = old.fil_codigo and
        materialenviado.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialenviado.'';
    end if;

    select count(*) into numrows
      from orcamento
      where
        orcamento.fil_codigo = old.fil_codigo and
        orcamento.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela orcamento.'';
    end if;

    select count(*) into numrows
      from loteapoio
      where
        loteapoio.fil_codigo = old.fil_codigo and
        loteapoio.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela loteapoio.'';
    end if;

    delete from exportaapoio
      where
        exportaapoio.fil_codigo = old.fil_codigo and
        exportaapoio.pac_codigo = old.pac_codigo;

    select count(*) into numrows
      from pacientelabexterno
      where
        pacientelabexterno.fil_codigo = old.fil_codigo and
        pacientelabexterno.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pacientelabexterno.'';
    end if;

    delete from pacienteentidade
      where
        pacienteentidade.fil_codigo = old.fil_codigo and
        pacienteentidade.pac_codigo = old.pac_codigo;

    select count(*) into numrows
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo and
        notafiscal.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela notafiscal.'';
    end if;

    select count(*) into numrows
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo and
        receberpagar.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela receberpagar.'';
    end if;

    delete from pacientescontatos
      where
        pacientescontatos.fil_codigo = old.fil_codigo and
        pacientescontatos.pac_codigo = old.pac_codigo;

    delete from pacientemedicamento
      where
        pacientemedicamento.fil_codigo = old.fil_codigo and
        pacientemedicamento.pac_codigo = old.pac_codigo;

    delete from examescontrole
      where
        examescontrole.fil_codigo = old.fil_codigo and
        examescontrole.pac_codigo = old.pac_codigo;

    select count(*) into numrows
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.pac_codigo = old.pac_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicao.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_paciente
after delete on paciente
for each row execute procedure fn_td_paciente();


drop function fn_ti_paciente() cascade;

create function fn_ti_paciente() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codorigem = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codorigem || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codorigem is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from entidade
      where
        new.fil_codigo = entidade.fil_codigo and
        new.ent_codempresa = entidade.ent_codigo;
    tmp:=''entidade|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''ent_codigo='' || new.ent_codempresa || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.ent_codempresa is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela entidade. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from indicacaopaciente
      where
        new.ind_codigo = indicacaopaciente.ind_codigo;
    tmp:=''indicacaopaciente|'';
    
      tmp:=tmp || ''ind_codigo='' || new.ind_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.ind_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela indicacaopaciente. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codimpressaocarteira = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codimpressaocarteira || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codimpressaocarteira is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from celulaestoque
      where
        new.fil_codigo = celulaestoque.fil_codigo and
        new.cel_codigo = celulaestoque.cel_codigo;
    tmp:=''celulaestoque|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cel_codigo='' || new.cel_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cel_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela celulaestoque. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codalteracao = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codalteracao || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codalteracao is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from layout
      where
        new.lay_codigoapoio = layout.lay_codigo and
        new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigoapoio || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.lay_codigoapoio is not null and
      new.fil_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from unidadesaude
      where
        new.fil_codigo = unidadesaude.fil_codigo and
        new.uns_codigo = unidadesaude.uns_codigo;
    tmp:=''unidadesaude|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''uns_codigo='' || new.uns_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.uns_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela unidadesaude. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from raca
      where
        new.fil_codigo = raca.fil_codigo and
        new.epc_codigo = raca.epc_codigo and
        new.rac_codigo = raca.rac_codigo;
    tmp:=''raca|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''epc_codigo='' || new.epc_codigo || ''|'';
    
      tmp:=tmp || ''rac_codigo='' || new.rac_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.epc_codigo is not null and
      new.rac_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela raca. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codigocobranca = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigocobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cid_codigocobranca is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codigocobranca = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigocobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.bai_codigocobranca is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from bairro
      where
        new.fil_codigo = bairro.fil_codigo and
        new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.bai_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from cidades
      where
        new.fil_codigo = cidades.fil_codigo and
        new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.cid_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from convenios
      where
        new.fil_codigo = convenios.fil_codigo and
        new.con_codigo = convenios.con_codigo;
    tmp:=''convenios|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''con_codigo='' || new.con_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.con_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela convenios. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from medico
      where
        new.fil_codigo = medico.fil_codigo and
        new.med_conselho = medico.med_conselho and
        new.med_crm = medico.med_crm and
        new.med_uf = medico.med_uf;
    tmp:=''medico|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''med_conselho='' || new.med_conselho || ''|'';
    
      tmp:=tmp || ''med_crm='' || new.med_crm || ''|'';
    
      tmp:=tmp || ''med_uf='' || new.med_uf || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.med_conselho is not null and
      new.med_crm is not null and
      new.med_uf is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela medico. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codigo = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_paciente
after insert on paciente
for each row execute procedure fn_ti_paciente();


drop function fn_tu_paciente() cascade;

create function fn_tu_paciente() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from acessowebpaciente
      where
        acessowebpaciente.fil_codigo = old.fil_codigo and
        acessowebpaciente.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela acessowebpaciente.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from logpushapp
      where
        logpushapp.fil_codigo = old.fil_codigo and
        logpushapp.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logpushapp.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from logemail
      where
        logemail.fil_codigo = old.fil_codigo and
        logemail.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logemail.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from exportaintegracaooperadora
      where
        exportaintegracaooperadora.fil_codigo = old.fil_codigo and
        exportaintegracaooperadora.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportaintegracaooperadora.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from pacienteimagens
      where
        pacienteimagens.fil_codigo = old.fil_codigo and
        pacienteimagens.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacienteimagens.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from logsms
      where
        logsms.fil_codigo = old.fil_codigo and
        logsms.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logsms.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from requisicaoweb
      where
        requisicaoweb.fil_codigo = old.fil_codigo and
        requisicaoweb.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaoweb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from contrassenharequisicao
      where
        contrassenharequisicao.fil_codigo = old.fil_codigo and
        contrassenharequisicao.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela contrassenharequisicao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from materialenviado
      where
        materialenviado.fil_codigo = old.fil_codigo and
        materialenviado.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialenviado.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from orcamento
      where
        orcamento.fil_codigo = old.fil_codigo and
        orcamento.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela orcamento.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from loteapoio
      where
        loteapoio.fil_codigo = old.fil_codigo and
        loteapoio.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela loteapoio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from exportaapoio
      where
        exportaapoio.fil_codigo = old.fil_codigo and
        exportaapoio.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela exportaapoio.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from pacientelabexterno
      where
        pacientelabexterno.fil_codigo = old.fil_codigo and
        pacientelabexterno.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacientelabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from pacienteentidade
      where
        pacienteentidade.fil_codigo = old.fil_codigo and
        pacienteentidade.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacienteentidade.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from notafiscal
      where
        notafiscal.fil_codigo = old.fil_codigo and
        notafiscal.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela notafiscal.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from receberpagar
      where
        receberpagar.fil_codigo = old.fil_codigo and
        receberpagar.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela receberpagar.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from pacientescontatos
      where
        pacientescontatos.fil_codigo = old.fil_codigo and
        pacientescontatos.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacientescontatos.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from pacientemedicamento
      where
        pacientemedicamento.fil_codigo = old.fil_codigo and
        pacientemedicamento.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacientemedicamento.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from examescontrole
      where
        examescontrole.fil_codigo = old.fil_codigo and
        examescontrole.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examescontrole.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.pac_codigo <> new.pac_codigo) then
    select count(*)
      from requisicao
      where
        requisicao.fil_codigo = old.fil_codigo and
        requisicao.pac_codigo = old.pac_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicao.'';
    end if;
  end if;
  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codorigem = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codorigem || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codorigem is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from entidade
    where
      new.fil_codigo = entidade.fil_codigo and
      new.ent_codempresa = entidade.ent_codigo;
    tmp:=''entidade|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''ent_codigo='' || new.ent_codempresa || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.ent_codempresa is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela entidade. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from indicacaopaciente
    where
      new.ind_codigo = indicacaopaciente.ind_codigo;
    tmp:=''indicacaopaciente|'';
    
      tmp:=tmp || ''ind_codigo='' || new.ind_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.ind_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela indicacaopaciente. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codimpressaocarteira = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codimpressaocarteira || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codimpressaocarteira is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from celulaestoque
    where
      new.fil_codigo = celulaestoque.fil_codigo and
      new.cel_codigo = celulaestoque.cel_codigo;
    tmp:=''celulaestoque|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cel_codigo='' || new.cel_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cel_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela celulaestoque. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codalteracao = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codalteracao || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codalteracao is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from layout
    where
      new.lay_codigoapoio = layout.lay_codigo and
      new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigoapoio || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.lay_codigoapoio is not null and
    new.fil_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from unidadesaude
    where
      new.fil_codigo = unidadesaude.fil_codigo and
      new.uns_codigo = unidadesaude.uns_codigo;
    tmp:=''unidadesaude|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''uns_codigo='' || new.uns_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.uns_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela unidadesaude. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from raca
    where
      new.fil_codigo = raca.fil_codigo and
      new.epc_codigo = raca.epc_codigo and
      new.rac_codigo = raca.rac_codigo;
    tmp:=''raca|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''epc_codigo='' || new.epc_codigo || ''|'';
    
      tmp:=tmp || ''rac_codigo='' || new.rac_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.epc_codigo is not null and
    new.rac_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela raca. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codigocobranca = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigocobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cid_codigocobranca is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codigocobranca = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigocobranca || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.bai_codigocobranca is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from bairro
    where
      new.fil_codigo = bairro.fil_codigo and
      new.bai_codigo = bairro.bai_codigo;
    tmp:=''bairro|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''bai_codigo='' || new.bai_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.bai_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela bairro. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from cidades
    where
      new.fil_codigo = cidades.fil_codigo and
      new.cid_codigo = cidades.cid_codigo;
    tmp:=''cidades|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''cid_codigo='' || new.cid_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.cid_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela cidades. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from convenios
    where
      new.fil_codigo = convenios.fil_codigo and
      new.con_codigo = convenios.con_codigo;
    tmp:=''convenios|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''con_codigo='' || new.con_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.con_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela convenios. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from medico
    where
      new.fil_codigo = medico.fil_codigo and
      new.med_conselho = medico.med_conselho and
      new.med_crm = medico.med_crm and
      new.med_uf = medico.med_uf;
    tmp:=''medico|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''med_conselho='' || new.med_conselho || ''|'';
    
      tmp:=tmp || ''med_crm='' || new.med_crm || ''|'';
    
      tmp:=tmp || ''med_uf='' || new.med_uf || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.med_conselho is not null and
    new.med_crm is not null and
    new.med_uf is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela medico. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codigo = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_paciente
after update on paciente
for each row execute procedure fn_tu_paciente();




insert into atualizacoes(atu_nome) values ('v21040002_140621.sql');

create table palavras(id serial, palavra varchar(12));

 insert into palavras(palavra) values ('Berenice');
 insert into palavras(palavra) values ('Cesareia');
 insert into palavras(palavra) values ('Floriano');
 insert into palavras(palavra) values ('abalizarao');
 insert into palavras(palavra) values ('abalroarao');
 insert into palavras(palavra) values ('abanando');
 insert into palavras(palavra) values ('abandalharam');
 insert into palavras(palavra) values ('abandalhava');
 insert into palavras(palavra) values ('abandalha');
 insert into palavras(palavra) values ('abandonamos');
 insert into palavras(palavra) values ('abarcarias');
 insert into palavras(palavra) values ('abarquemo');
 insert into palavras(palavra) values ('abarracados');
 insert into palavras(palavra) values ('abarrotavas');
 insert into palavras(palavra) values ('abastada');
 insert into palavras(palavra) values ('abasteceras');
 insert into palavras(palavra) values ('abastecidas');
 insert into palavras(palavra) values ('abatedouro');
 insert into palavras(palavra) values ('abaterdes');
 insert into palavras(palavra) values ('abeirados');
 insert into palavras(palavra) values ('abeiraria');
 insert into palavras(palavra) values ('abeiremo');
 insert into palavras(palavra) values ('abiscoitaram');
 insert into palavras(palavra) values ('abismando');
 insert into palavras(palavra) values ('abismariam');
 insert into palavras(palavra) values ('abismassem');
 insert into palavras(palavra) values ('abismava');
 insert into palavras(palavra) values ('abismavas');
 insert into palavras(palavra) values ('abjurarmos');
 insert into palavras(palavra) values ('abjuraste');
 insert into palavras(palavra) values ('abluiriam');
 insert into palavras(palavra) values ('abluiriamos');
 insert into palavras(palavra) values ('abnegaras');
 insert into palavras(palavra) values ('abnegasse');
 insert into palavras(palavra) values ('abobalhados');
 insert into palavras(palavra) values ('abocanhas');
 insert into palavras(palavra) values ('aboletamos');
 insert into palavras(palavra) values ('aboliremo');
 insert into palavras(palavra) values ('abolissem');
 insert into palavras(palavra) values ('abominara');
 insert into palavras(palavra) values ('abominarei');
 insert into palavras(palavra) values ('abominarmo');
 insert into palavras(palavra) values ('abominara');
 insert into palavras(palavra) values ('abordagens');
 insert into palavras(palavra) values ('abordarmos');
 insert into palavras(palavra) values ('aborrecendo');
 insert into palavras(palavra) values ('aborreceras');
 insert into palavras(palavra) values ('abortareis');
 insert into palavras(palavra) values ('abortariam');
 insert into palavras(palavra) values ('aborticias');
 insert into palavras(palavra) values ('abotoardes');
 insert into palavras(palavra) values ('abotoasseis');
 insert into palavras(palavra) values ('abracemos');
 insert into palavras(palavra) values ('abraseis');
 insert into palavras(palavra) values ('abracadeiras');
 insert into palavras(palavra) values ('abracaras');
 insert into palavras(palavra) values ('abracarieis');
 insert into palavras(palavra) values ('abracavam');
 insert into palavras(palavra) values ('abrenharem');
 insert into palavras(palavra) values ('abreviar');
 insert into palavras(palavra) values ('abriguemo');
 insert into palavras(palavra) values ('abrireis');
 insert into palavras(palavra) values ('abrirmos');
 insert into palavras(palavra) values ('abrocharias');
 insert into palavras(palavra) values ('absolvermos');
 insert into palavras(palavra) values ('absorvei');
 insert into palavras(palavra) values ('abstencoes');
 insert into palavras(palavra) values ('abstiveram');
 insert into palavras(palavra) values ('abstrairem');
 insert into palavras(palavra) values ('abundassemos');
 insert into palavras(palavra) values ('aburguesas');
 insert into palavras(palavra) values ('acabrunharia');
 insert into palavras(palavra) values ('acabavamos');
 insert into palavras(palavra) values ('academicizo');
 insert into palavras(palavra) values ('acalentara');
 insert into palavras(palavra) values ('acalmasse');
 insert into palavras(palavra) values ('acaloraste');
 insert into palavras(palavra) values ('acantonamo');
 insert into palavras(palavra) values ('acariciais');
 insert into palavras(palavra) values ('acariciemo');
 insert into palavras(palavra) values ('acarpetava');
 insert into palavras(palavra) values ('acarretes');
 insert into palavras(palavra) values ('acasalarao');
 insert into palavras(palavra) values ('acasalareis');
 insert into palavras(palavra) values ('aceitaras');
 insert into palavras(palavra) values ('aceitarei');
 insert into palavras(palavra) values ('aceleradores');
 insert into palavras(palavra) values ('acelerariam');
 insert into palavras(palavra) values ('acenaras');
 insert into palavras(palavra) values ('acendessem');
 insert into palavras(palavra) values ('acentuamos');
 insert into palavras(palavra) values ('acercarias');
 insert into palavras(palavra) values ('acertadas');
 insert into palavras(palavra) values ('acertamo');
 insert into palavras(palavra) values ('acertarmo');
 insert into palavras(palavra) values ('acetinavam');
 insert into palavras(palavra) values ('achardes');
 insert into palavras(palavra) values ('achegavam');
 insert into palavras(palavra) values ('acheguei');
 insert into palavras(palavra) values ('acidentarao');
 insert into palavras(palavra) values ('acidentei');
 insert into palavras(palavra) values ('acidulamo');
 insert into palavras(palavra) values ('acidulamos');
 insert into palavras(palavra) values ('acidulavam');
 insert into palavras(palavra) values ('aciduleis');
 insert into palavras(palavra) values ('acinzentavam');
 insert into palavras(palavra) values ('acionadora');
 insert into palavras(palavra) values ('acionemo');
 insert into palavras(palavra) values ('acionario');
 insert into palavras(palavra) values ('acirraremos');
 insert into palavras(palavra) values ('acirrasse');
 insert into palavras(palavra) values ('acirraste');
 insert into palavras(palavra) values ('aclamara');
 insert into palavras(palavra) values ('aclarara');
 insert into palavras(palavra) values ('aclaraveis');
 insert into palavras(palavra) values ('aclimatamos');
 insert into palavras(palavra) values ('aclimataria');
 insert into palavras(palavra) values ('aclimatem');
 insert into palavras(palavra) values ('aclimatiza');
 insert into palavras(palavra) values ('aclimatizava');
 insert into palavras(palavra) values ('acolchoareis');
 insert into palavras(palavra) values ('acometas');
 insert into palavras(palavra) values ('acomodareis');
 insert into palavras(palavra) values ('acomodarias');
 insert into palavras(palavra) values ('acomodarao');
 insert into palavras(palavra) values ('acompanhares');
 insert into palavras(palavra) values ('acompanhou');
 insert into palavras(palavra) values ('aconchegara');
 insert into palavras(palavra) values ('aconchegues');
 insert into palavras(palavra) values ('aconselharas');
 insert into palavras(palavra) values ('aconselhem');
 insert into palavras(palavra) values ('aconselha');
 insert into palavras(palavra) values ('aconteceras');
 insert into palavras(palavra) values ('acontecermos');
 insert into palavras(palavra) values ('acoplado');
 insert into palavras(palavra) values ('acoplarei');
 insert into palavras(palavra) values ('acorrera');
 insert into palavras(palavra) values ('acorrias');
 insert into palavras(palavra) values ('acossarem');
 insert into palavras(palavra) values ('acossavamos');
 insert into palavras(palavra) values ('acovardaste');
 insert into palavras(palavra) values ('acovardareis');
 insert into palavras(palavra) values ('acreditais');
 insert into palavras(palavra) values ('acreditaste');
 insert into palavras(palavra) values ('acreditavam');
 insert into palavras(palavra) values ('acrisolam');
 insert into palavras(palavra) values ('acumularemos');
 insert into palavras(palavra) values ('acumularas');
 insert into palavras(palavra) values ('acusarieis');
 insert into palavras(palavra) values ('adaptadas');
 insert into palavras(palavra) values ('adaptados');
 insert into palavras(palavra) values ('adensarem');
 insert into palavras(palavra) values ('adentraras');
 insert into palavras(palavra) values ('adentrasse');
 insert into palavras(palavra) values ('adentraste');
 insert into palavras(palavra) values ('adestraveis');
 insert into palavras(palavra) values ('adiantamos');
 insert into palavras(palavra) values ('adiantaste');
 insert into palavras(palavra) values ('adiantastes');
 insert into palavras(palavra) values ('adimplencia');
 insert into palavras(palavra) values ('adjetivarias');
 insert into palavras(palavra) values ('adjudicavam');
 insert into palavras(palavra) values ('admitias');
 insert into palavras(palavra) values ('admoestada');
 insert into palavras(palavra) values ('admoestei');
 insert into palavras(palavra) values ('adocicados');
 insert into palavras(palavra) values ('adocicando');
 insert into palavras(palavra) values ('adocicaveis');
 insert into palavras(palavra) values ('adormecerias');
 insert into palavras(palavra) values ('adotamos');
 insert into palavras(palavra) values ('adotassem');
 insert into palavras(palavra) values ('adquiras');
 insert into palavras(palavra) values ('adquirimo');
 insert into palavras(palavra) values ('adquirisseis');
 insert into palavras(palavra) values ('adstringira');
 insert into palavras(palavra) values ('adubados');
 insert into palavras(palavra) values ('adulariamos');
 insert into palavras(palavra) values ('adulteras');
 insert into palavras(palavra) values ('adulterei');
 insert into palavras(palavra) values ('advertes');
 insert into palavras(palavra) values ('advertia');
 insert into palavras(palavra) values ('advertirmo');
 insert into palavras(palavra) values ('adviessem');
 insert into palavras(palavra) values ('advogado');
 insert into palavras(palavra) values ('advogasse');
 insert into palavras(palavra) values ('aerolito');
 insert into palavras(palavra) values ('aerostatos');
 insert into palavras(palavra) values ('afanastes');
 insert into palavras(palavra) values ('afastando');
 insert into palavras(palavra) values ('afastareis');
 insert into palavras(palavra) values ('afeminarmo');
 insert into palavras(palavra) values ('aferirei');
 insert into palavras(palavra) values ('aferrardes');
 insert into palavras(palavra) values ('aferroamos');
 insert into palavras(palavra) values ('aferventarem');
 insert into palavras(palavra) values ('aferventasse');
 insert into palavras(palavra) values ('afetasse');
 insert into palavras(palavra) values ('afetavas');
 insert into palavras(palavra) values ('afiancam');
 insert into palavras(palavra) values ('afiguramos');
 insert into palavras(palavra) values ('afigurar');
 insert into palavras(palavra) values ('afigurarias');
 insert into palavras(palavra) values ('afiliarao');
 insert into palavras(palavra) values ('afinadora');
 insert into palavras(palavra) values ('afincastes');
 insert into palavras(palavra) values ('afirmardes');
 insert into palavras(palavra) values ('afirmacao');
 insert into palavras(palavra) values ('afivelasse');
 insert into palavras(palavra) values ('afivelemo');
 insert into palavras(palavra) values ('afiveles');
 insert into palavras(palavra) values ('afivelavamos');
 insert into palavras(palavra) values ('afiassemos');
 insert into palavras(palavra) values ('afligiras');
 insert into palavras(palavra) values ('afligiremo');
 insert into palavras(palavra) values ('afligisse');
 insert into palavras(palavra) values ('afloramo');
 insert into palavras(palavra) values ('afluirieis');
 insert into palavras(palavra) values ('afobamentos');
 insert into palavras(palavra) values ('afobaras');
 insert into palavras(palavra) values ('afofareis');
 insert into palavras(palavra) values ('aformosaras');
 insert into palavras(palavra) values ('aformosearia');
 insert into palavras(palavra) values ('aformoseemo');
 insert into palavras(palavra) values ('afortunada');
 insert into palavras(palavra) values ('afrontaria');
 insert into palavras(palavra) values ('afrontavam');
 insert into palavras(palavra) values ('afrouxei');
 insert into palavras(palavra) values ('afunilarei');
 insert into palavras(palavra) values ('afunilei');
 insert into palavras(palavra) values ('afunilavamos');
 insert into palavras(palavra) values ('agacharem');
 insert into palavras(palavra) values ('agarrassemos');
 insert into palavras(palavra) values ('agasalhem');
 insert into palavras(palavra) values ('agenciando');
 insert into palavras(palavra) values ('agenciastes');
 insert into palavras(palavra) values ('agilizei');
 insert into palavras(palavra) values ('agilizem');
 insert into palavras(palavra) values ('agilmente');
 insert into palavras(palavra) values ('agiotamo');
 insert into palavras(palavra) values ('agiotaramos');
 insert into palavras(palavra) values ('agiotareis');
 insert into palavras(palavra) values ('aglomerais');
 insert into palavras(palavra) values ('aglomerar');
 insert into palavras(palavra) values ('aglomeracoes');
 insert into palavras(palavra) values ('aglutinas');
 insert into palavras(palavra) values ('aglutino');
 insert into palavras(palavra) values ('agnostico');
 insert into palavras(palavra) values ('agonizar');
 insert into palavras(palavra) values ('agonizavas');
 insert into palavras(palavra) values ('agourardes');
 insert into palavras(palavra) values ('agourarao');
 insert into palavras(palavra) values ('agourentos');
 insert into palavras(palavra) values ('agraciasse');
 insert into palavras(palavra) values ('agraciavamos');
 insert into palavras(palavra) values ('agradeci');
 insert into palavras(palavra) values ('agradavamos');
 insert into palavras(palavra) values ('agredimos');
 insert into palavras(palavra) values ('agredires');
 insert into palavras(palavra) values ('agremiando');
 insert into palavras(palavra) values ('agremiaras');
 insert into palavras(palavra) values ('agressor');
 insert into palavras(palavra) values ('agruparias');
 insert into palavras(palavra) values ('aguardentes');
 insert into palavras(palavra) values ('aguarmos');
 insert into palavras(palavra) values ('aguentaveis');
 insert into palavras(palavra) values ('aguerrirao');
 insert into palavras(palavra) values ('aguilhoados');
 insert into palavras(palavra) values ('agulhais');
 insert into palavras(palavra) values ('aguentem');
 insert into palavras(palavra) values ('ajardinaram');
 insert into palavras(palavra) values ('ajardinarem');
 insert into palavras(palavra) values ('ajardinara');
 insert into palavras(palavra) values ('ajoelhariam');
 insert into palavras(palavra) values ('ajudaria');
 insert into palavras(palavra) values ('ajuizaveis');
 insert into palavras(palavra) values ('ajuntando');
 insert into palavras(palavra) values ('ajuntarao');
 insert into palavras(palavra) values ('ajustaremos');
 insert into palavras(palavra) values ('ajustaras');
 insert into palavras(palavra) values ('alagadico');
 insert into palavras(palavra) values ('alagavas');
 insert into palavras(palavra) values ('alargarias');
 insert into palavras(palavra) values ('alargaras');
 insert into palavras(palavra) values ('alarmados');
 insert into palavras(palavra) values ('alastrares');
 insert into palavras(palavra) values ('albatrozes');
 insert into palavras(palavra) values ('alberguemo');
 insert into palavras(palavra) values ('alcoolizado');
 insert into palavras(palavra) values ('alegassem');
 insert into palavras(palavra) values ('aleijais');
 insert into palavras(palavra) values ('aleijaramos');
 insert into palavras(palavra) values ('aleitareis');
 insert into palavras(palavra) values ('alevantar');
 insert into palavras(palavra) values ('alevantasse');
 insert into palavras(palavra) values ('alevantastes');
 insert into palavras(palavra) values ('alfabetizo');
 insert into palavras(palavra) values ('algebristas');
 insert into palavras(palavra) values ('algemeis');
 insert into palavras(palavra) values ('alheavas');
 insert into palavras(palavra) values ('alheasseis');
 insert into palavras(palavra) values ('aliciais');
 insert into palavras(palavra) values ('alienemo');
 insert into palavras(palavra) values ('alienavamos');
 insert into palavras(palavra) values ('aligeirando');
 insert into palavras(palavra) values ('alinhavamo');
 insert into palavras(palavra) values ('alistarem');
 insert into palavras(palavra) values ('alistaremo');
 insert into palavras(palavra) values ('alistares');
 insert into palavras(palavra) values ('alistastes');
 insert into palavras(palavra) values ('alistaveis');
 insert into palavras(palavra) values ('alisaramos');
 insert into palavras(palavra) values ('aliviado');
 insert into palavras(palavra) values ('aliviasses');
 insert into palavras(palavra) values ('aliviemos');
 insert into palavras(palavra) values ('aliviasseis');
 insert into palavras(palavra) values ('almejaremo');
 insert into palavras(palavra) values ('almirantado');
 insert into palavras(palavra) values ('almiscar');
 insert into palavras(palavra) values ('alocadores');
 insert into palavras(palavra) values ('alocariamos');
 insert into palavras(palavra) values ('alojadas');
 insert into palavras(palavra) values ('alongadas');
 insert into palavras(palavra) values ('alongamos');
 insert into palavras(palavra) values ('alongarias');
 insert into palavras(palavra) values ('alouraram');
 insert into palavras(palavra) values ('alourarem');
 insert into palavras(palavra) values ('alouraremos');
 insert into palavras(palavra) values ('alpendres');
 insert into palavras(palavra) values ('altearemo');
 insert into palavras(palavra) values ('alteariam');
 insert into palavras(palavra) values ('altercaras');
 insert into palavras(palavra) values ('altercaria');
 insert into palavras(palavra) values ('alternado');
 insert into palavras(palavra) values ('alternados');
 insert into palavras(palavra) values ('alternativas');
 insert into palavras(palavra) values ('altimetros');
 insert into palavras(palavra) values ('altissimas');
 insert into palavras(palavra) values ('alvejardes');
 insert into palavras(palavra) values ('alvejastes');
 insert into palavras(palavra) values ('alvejavas');
 insert into palavras(palavra) values ('alveolar');
 insert into palavras(palavra) values ('alvoradas');
 insert into palavras(palavra) values ('alvoreciam');
 insert into palavras(palavra) values ('alvorocando');
 insert into palavras(palavra) values ('alcardes');
 insert into palavras(palavra) values ('aliquotas');
 insert into palavras(palavra) values ('amaciarieis');
 insert into palavras(palavra) values ('amadureces');
 insert into palavras(palavra) values ('amainaria');
 insert into palavras(palavra) values ('amainariam');
 insert into palavras(palavra) values ('amaldicoares');
 insert into palavras(palavra) values ('amamentados');
 insert into palavras(palavra) values ('amamentai');
 insert into palavras(palavra) values ('amamentando');
 insert into palavras(palavra) values ('amamentasse');
 insert into palavras(palavra) values ('amamentastes');
 insert into palavras(palavra) values ('amamentei');
 insert into palavras(palavra) values ('amancebas');
 insert into palavras(palavra) values ('amancebastes');
 insert into palavras(palavra) values ('amancebeis');
 insert into palavras(palavra) values ('amarelarias');
 insert into palavras(palavra) values ('amarelarmo');
 insert into palavras(palavra) values ('amarelecida');
 insert into palavras(palavra) values ('amareleis');
 insert into palavras(palavra) values ('amarelou');
 insert into palavras(palavra) values ('amarrado');
 insert into palavras(palavra) values ('amarrarias');
 insert into palavras(palavra) values ('amarrasse');
 insert into palavras(palavra) values ('amasiaste');
 insert into palavras(palavra) values ('ambicionava');
 insert into palavras(palavra) values ('ambiciones');
 insert into palavras(palavra) values ('ambientamo');
 insert into palavras(palavra) values ('ameacara');
 insert into palavras(palavra) values ('ameacaria');
 insert into palavras(palavra) values ('ameacasses');
 insert into palavras(palavra) values ('amedrontara');
 insert into palavras(palavra) values ('amedrontarei');
 insert into palavras(palavra) values ('amenizai');
 insert into palavras(palavra) values ('amenizamo');
 insert into palavras(palavra) values ('amenizando');
 insert into palavras(palavra) values ('amesquinhara');
 insert into palavras(palavra) values ('amesquinha');
 insert into palavras(palavra) values ('amigardes');
 insert into palavras(palavra) values ('amigasses');
 insert into palavras(palavra) values ('amiguinhos');
 insert into palavras(palavra) values ('amimaveis');
 insert into palavras(palavra) values ('amiudando');
 insert into palavras(palavra) values ('amoldarei');
 insert into palavras(palavra) values ('amoldemo');
 insert into palavras(palavra) values ('amolecado');
 insert into palavras(palavra) values ('amoleceremo');
 insert into palavras(palavra) values ('amolecidas');
 insert into palavras(palavra) values ('amorosissima');
 insert into palavras(palavra) values ('amortalharmo');
 insert into palavras(palavra) values ('amortizareis');
 insert into palavras(palavra) values ('amotinavas');
 insert into palavras(palavra) values ('ampararem');
 insert into palavras(palavra) values ('amparaste');
 insert into palavras(palavra) values ('amplificado');
 insert into palavras(palavra) values ('anacronico');
 insert into palavras(palavra) values ('analisadas');
 insert into palavras(palavra) values ('ancorarmos');
 insert into palavras(palavra) values ('ancorarieis');
 insert into palavras(palavra) values ('andardes');
 insert into palavras(palavra) values ('anelardes');
 insert into palavras(palavra) values ('anelarieis');
 insert into palavras(palavra) values ('anestesiamos');
 insert into palavras(palavra) values ('anestesie');
 insert into palavras(palavra) values ('anexarieis');
 insert into palavras(palavra) values ('anexaste');
 insert into palavras(palavra) values ('angariou');
 insert into palavras(palavra) values ('angariaveis');
 insert into palavras(palavra) values ('angustiarao');
 insert into palavras(palavra) values ('angustiavam');
 insert into palavras(palavra) values ('angustura');
 insert into palavras(palavra) values ('animalizar');
 insert into palavras(palavra) values ('animalizara');
 insert into palavras(palavra) values ('aninhara');
 insert into palavras(palavra) values ('aninhareis');
 insert into palavras(palavra) values ('aniquilasses');
 insert into palavras(palavra) values ('aniquilemos');
 insert into palavras(palavra) values ('anistiarao');
 insert into palavras(palavra) values ('anistiareis');
 insert into palavras(palavra) values ('anistiaveis');
 insert into palavras(palavra) values ('anoitecei');
 insert into palavras(palavra) values ('anoiteceriam');
 insert into palavras(palavra) values ('anoitecermo');
 insert into palavras(palavra) values ('anotacoes');
 insert into palavras(palavra) values ('antagonico');
 insert into palavras(palavra) values ('antecipeis');
 insert into palavras(palavra) values ('antropologos');
 insert into palavras(palavra) values ('anuiremo');
 insert into palavras(palavra) values ('anularmo');
 insert into palavras(palavra) values ('anunciassem');
 insert into palavras(palavra) values ('anuencias');
 insert into palavras(palavra) values ('apadrinhamo');
 insert into palavras(palavra) values ('apadrinhara');
 insert into palavras(palavra) values ('apadrinhavas');
 insert into palavras(palavra) values ('apaixonarmos');
 insert into palavras(palavra) values ('apalpastes');
 insert into palavras(palavra) values ('apanagiara');
 insert into palavras(palavra) values ('apanharieis');
 insert into palavras(palavra) values ('apanhaste');
 insert into palavras(palavra) values ('apanagio');
 insert into palavras(palavra) values ('aparacerdes');
 insert into palavras(palavra) values ('aparacera');
 insert into palavras(palavra) values ('aparafusou');
 insert into palavras(palavra) values ('apareceram');
 insert into palavras(palavra) values ('apareceras');
 insert into palavras(palavra) values ('aparelhemos');
 insert into palavras(palavra) values ('aparentamos');
 insert into palavras(palavra) values ('aparentava');
 insert into palavras(palavra) values ('aparentavam');
 insert into palavras(palavra) values ('aparecais');
 insert into palavras(palavra) values ('apartaras');
 insert into palavras(palavra) values ('apartaste');
 insert into palavras(palavra) values ('apavoram');
 insert into palavras(palavra) values ('apavoraras');
 insert into palavras(palavra) values ('apavoravam');
 insert into palavras(palavra) values ('apaziguas');
 insert into palavras(palavra) values ('apaziguassem');
 insert into palavras(palavra) values ('apaziguo');
 insert into palavras(palavra) values ('apedrejas');
 insert into palavras(palavra) values ('apelasses');
 insert into palavras(palavra) values ('apendarei');
 insert into palavras(palavra) values ('apendaremo');
 insert into palavras(palavra) values ('apendara');
 insert into palavras(palavra) values ('apenavamos');
 insert into palavras(palavra) values ('aperceberas');
 insert into palavras(palavra) values ('apercebesses');
 insert into palavras(palavra) values ('aperfeicoamo');
 insert into palavras(palavra) values ('aperfeicoara');
 insert into palavras(palavra) values ('apetecas');
 insert into palavras(palavra) values ('apimentaras');
 insert into palavras(palavra) values ('apinhassemos');
 insert into palavras(palavra) values ('apitareis');
 insert into palavras(palavra) values ('aplacaste');
 insert into palavras(palavra) values ('aplainarao');
 insert into palavras(palavra) values ('aplaudiremo');
 insert into palavras(palavra) values ('aplaudirias');
 insert into palavras(palavra) values ('aplicados');
 insert into palavras(palavra) values ('aplicariamos');
 insert into palavras(palavra) values ('apocaliptico');
 insert into palavras(palavra) values ('apontaram');
 insert into palavras(palavra) values ('apontardes');
 insert into palavras(palavra) values ('aportaria');
 insert into palavras(palavra) values ('aportemos');
 insert into palavras(palavra) values ('aposentaremo');
 insert into palavras(palavra) values ('apossareis');
 insert into palavras(palavra) values ('apossaramos');
 insert into palavras(palavra) values ('apostais');
 insert into palavras(palavra) values ('apostamo');
 insert into palavras(palavra) values ('apostasse');
 insert into palavras(palavra) values ('apostassem');
 insert into palavras(palavra) values ('apostrofamo');
 insert into palavras(palavra) values ('apostrofaras');
 insert into palavras(palavra) values ('apostrofavam');
 insert into palavras(palavra) values ('apostrofemo');
 insert into palavras(palavra) values ('apreendera');
 insert into palavras(palavra) values ('aprendemos');
 insert into palavras(palavra) values ('aprendeu');
 insert into palavras(palavra) values ('apresentaram');
 insert into palavras(palavra) values ('apresenteis');
 insert into palavras(palavra) values ('apresentes');
 insert into palavras(palavra) values ('apressado');
 insert into palavras(palavra) values ('apressara');
 insert into palavras(palavra) values ('aprimoreis');
 insert into palavras(palavra) values ('aprisionados');
 insert into palavras(palavra) values ('aprisionais');
 insert into palavras(palavra) values ('aprisionaria');
 insert into palavras(palavra) values ('aprontares');
 insert into palavras(palavra) values ('apropriariam');
 insert into palavras(palavra) values ('aprovaremos');
 insert into palavras(palavra) values ('aproveitarem');
 insert into palavras(palavra) values ('aproveitem');
 insert into palavras(palavra) values ('aproximai');
 insert into palavras(palavra) values ('aprumarem');
 insert into palavras(palavra) values ('apurarias');
 insert into palavras(palavra) values ('aquartelasse');
 insert into palavras(palavra) values ('aquartelem');
 insert into palavras(palavra) values ('aqueceres');
 insert into palavras(palavra) values ('aquiesciamos');
 insert into palavras(palavra) values ('aquatico');
 insert into palavras(palavra) values ('arbitragens');
 insert into palavras(palavra) values ('arbitrarao');
 insert into palavras(palavra) values ('arborizar');
 insert into palavras(palavra) values ('arborizarias');
 insert into palavras(palavra) values ('ardorosa');
 insert into palavras(palavra) values ('arejareis');
 insert into palavras(palavra) values ('arejasseis');
 insert into palavras(palavra) values ('arfaveis');
 insert into palavras(palavra) values ('arguisseis');
 insert into palavras(palavra) values ('ariranha');
 insert into palavras(palavra) values ('arlequins');
 insert into palavras(palavra) values ('aromatizado');
 insert into palavras(palavra) values ('aromatico');
 insert into palavras(palavra) values ('arquearias');
 insert into palavras(palavra) values ('arquearao');
 insert into palavras(palavra) values ('arqueavas');
 insert into palavras(palavra) values ('arquejas');
 insert into palavras(palavra) values ('arquejavas');
 insert into palavras(palavra) values ('arquejes');
 insert into palavras(palavra) values ('arquemos');
 insert into palavras(palavra) values ('arquivada');
 insert into palavras(palavra) values ('arraigueis');
 insert into palavras(palavra) values ('arrancavam');
 insert into palavras(palavra) values ('arranhadas');
 insert into palavras(palavra) values ('arranhasses');
 insert into palavras(palavra) values ('arranjareis');
 insert into palavras(palavra) values ('arrasavas');
 insert into palavras(palavra) values ('arrastais');
 insert into palavras(palavra) values ('arrastaste');
 insert into palavras(palavra) values ('arrazoariam');
 insert into palavras(palavra) values ('arrazoassem');
 insert into palavras(palavra) values ('arrebanhavam');
 insert into palavras(palavra) values ('arrebatadora');
 insert into palavras(palavra) values ('arrebatarem');
 insert into palavras(palavra) values ('arrebatariam');
 insert into palavras(palavra) values ('arrecadado');
 insert into palavras(palavra) values ('arredara');
 insert into palavras(palavra) values ('arredarieis');
 insert into palavras(palavra) values ('arredondam');
 insert into palavras(palavra) values ('arredondaram');
 insert into palavras(palavra) values ('arrefecemos');
 insert into palavras(palavra) values ('arrefecermos');
 insert into palavras(palavra) values ('arrefece');
 insert into palavras(palavra) values ('arregalamo');
 insert into palavras(palavra) values ('arregalamos');
 insert into palavras(palavra) values ('arregalarias');
 insert into palavras(palavra) values ('arreganhavas');
 insert into palavras(palavra) values ('arregacais');
 insert into palavras(palavra) values ('arregacaria');
 insert into palavras(palavra) values ('arrematarei');
 insert into palavras(palavra) values ('arremedeis');
 insert into palavras(palavra) values ('arremessaram');
 insert into palavras(palavra) values ('arremessares');
 insert into palavras(palavra) values ('arremetida');
 insert into palavras(palavra) values ('arremetido');
 insert into palavras(palavra) values ('arrendam');
 insert into palavras(palavra) values ('arrendaram');
 insert into palavras(palavra) values ('arrendarem');
 insert into palavras(palavra) values ('arrendarias');
 insert into palavras(palavra) values ('arrependeram');
 insert into palavras(palavra) values ('arrepiado');
 insert into palavras(palavra) values ('arrepiadores');
 insert into palavras(palavra) values ('arriares');
 insert into palavras(palavra) values ('arriarmos');
 insert into palavras(palavra) values ('arrimais');
 insert into palavras(palavra) values ('arrimamo');
 insert into palavras(palavra) values ('arriscaremo');
 insert into palavras(palavra) values ('arriscarmos');
 insert into palavras(palavra) values ('arriscava');
 insert into palavras(palavra) values ('arriscareis');
 insert into palavras(palavra) values ('arriscasseis');
 insert into palavras(palavra) values ('arrisquei');
 insert into palavras(palavra) values ('arriavamos');
 insert into palavras(palavra) values ('arriaveis');
 insert into palavras(palavra) values ('arrochara');
 insert into palavras(palavra) values ('arrogareis');
 insert into palavras(palavra) values ('arrojados');
 insert into palavras(palavra) values ('arrojarieis');
 insert into palavras(palavra) values ('arrombaremo');
 insert into palavras(palavra) values ('arrostara');
 insert into palavras(palavra) values ('arrostaramos');
 insert into palavras(palavra) values ('arrotastes');
 insert into palavras(palavra) values ('arrotava');
 insert into palavras(palavra) values ('arroxeamos');
 insert into palavras(palavra) values ('arruinaras');
 insert into palavras(palavra) values ('arrumares');
 insert into palavras(palavra) values ('arrumaramos');
 insert into palavras(palavra) values ('articulamos');
 insert into palavras(palavra) values ('articulassem');
 insert into palavras(palavra) values ('arvorasse');
 insert into palavras(palavra) values ('ascender');
 insert into palavras(palavra) values ('asfaltai');
 insert into palavras(palavra) values ('asfaltamo');
 insert into palavras(palavra) values ('asfaltava');
 insert into palavras(palavra) values ('asfaltaveis');
 insert into palavras(palavra) values ('asfixiantes');
 insert into palavras(palavra) values ('asfixiei');
 insert into palavras(palavra) values ('asfixiaramos');
 insert into palavras(palavra) values ('asilamos');
 insert into palavras(palavra) values ('asmatica');
 insert into palavras(palavra) values ('aspergirem');
 insert into palavras(palavra) values ('aspirarao');
 insert into palavras(palavra) values ('aspirariamos');
 insert into palavras(palavra) values ('aspirastes');
 insert into palavras(palavra) values ('assalariarmo');
 insert into palavras(palavra) values ('assalariara');
 insert into palavras(palavra) values ('assalariemo');
 insert into palavras(palavra) values ('assalaries');
 insert into palavras(palavra) values ('assaltais');
 insert into palavras(palavra) values ('assaltareis');
 insert into palavras(palavra) values ('assaltas');
 insert into palavras(palavra) values ('assanhes');
 insert into palavras(palavra) values ('assassinava');
 insert into palavras(palavra) values ('assassinos');
 insert into palavras(palavra) values ('assediaria');
 insert into palavras(palavra) values ('assediassem');
 insert into palavras(palavra) values ('assenhoreai');
 insert into palavras(palavra) values ('assenhoreiem');
 insert into palavras(palavra) values ('assentareis');
 insert into palavras(palavra) values ('assercoes');
 insert into palavras(palavra) values ('assessorara');
 insert into palavras(palavra) values ('assessoraste');
 insert into palavras(palavra) values ('assessorias');
 insert into palavras(palavra) values ('assevera');
 insert into palavras(palavra) values ('assimilarei');
 insert into palavras(palavra) values ('assimilaremo');
 insert into palavras(palavra) values ('assimile');
 insert into palavras(palavra) values ('assimilemo');
 insert into palavras(palavra) values ('assinalaremo');
 insert into palavras(palavra) values ('assinares');
 insert into palavras(palavra) values ('assistemo');
 insert into palavras(palavra) values ('assistiremo');
 insert into palavras(palavra) values ('assistis');
 insert into palavras(palavra) values ('assistisse');
 insert into palavras(palavra) values ('assoalhos');
 insert into palavras(palavra) values ('assoaremo');
 insert into palavras(palavra) values ('assoarias');
 insert into palavras(palavra) values ('assoasse');
 insert into palavras(palavra) values ('assobiemos');
 insert into palavras(palavra) values ('associara');
 insert into palavras(palavra) values ('associativo');
 insert into palavras(palavra) values ('assolais');
 insert into palavras(palavra) values ('assolaram');
 insert into palavras(palavra) values ('assolarmo');
 insert into palavras(palavra) values ('assolasse');
 insert into palavras(palavra) values ('assolavas');
 insert into palavras(palavra) values ('assolavamos');
 insert into palavras(palavra) values ('assolaveis');
 insert into palavras(palavra) values ('assombrassem');
 insert into palavras(palavra) values ('assombros');
 insert into palavras(palavra) values ('assorearamos');
 insert into palavras(palavra) values ('assoreareis');
 insert into palavras(palavra) values ('assoreasseis');
 insert into palavras(palavra) values ('assoviaras');
 insert into palavras(palavra) values ('assustamo');
 insert into palavras(palavra) values ('assustara');
 insert into palavras(palavra) values ('assustassem');
 insert into palavras(palavra) values ('assustasses');
 insert into palavras(palavra) values ('assintotas');
 insert into palavras(palavra) values ('assirios');
 insert into palavras(palavra) values ('asteroide');
 insert into palavras(palavra) values ('astronomos');
 insert into palavras(palavra) values ('astucias');
 insert into palavras(palavra) values ('atabalhoada');
 insert into palavras(palavra) values ('atacaras');
 insert into palavras(palavra) values ('atacasse');
 insert into palavras(palavra) values ('atalhado');
 insert into palavras(palavra) values ('atapetaram');
 insert into palavras(palavra) values ('atapetarei');
 insert into palavras(palavra) values ('atarraxastes');
 insert into palavras(palavra) values ('ataviasseis');
 insert into palavras(palavra) values ('atazanes');
 insert into palavras(palavra) values ('atearemo');
 insert into palavras(palavra) values ('ateariam');
 insert into palavras(palavra) values ('atemorizavas');
 insert into palavras(palavra) values ('atendias');
 insert into palavras(palavra) values ('atentaremo');
 insert into palavras(palavra) values ('atenteis');
 insert into palavras(palavra) values ('atenuadas');
 insert into palavras(palavra) values ('atenuavas');
 insert into palavras(palavra) values ('aterradas');
 insert into palavras(palavra) values ('atestado');
 insert into palavras(palavra) values ('atinares');
 insert into palavras(palavra) values ('atinariam');
 insert into palavras(palavra) values ('atinaras');
 insert into palavras(palavra) values ('atingido');
 insert into palavras(palavra) values ('atingirmos');
 insert into palavras(palavra) values ('atingirieis');
 insert into palavras(palavra) values ('atiraremos');
 insert into palavras(palavra) values ('atiravamos');
 insert into palavras(palavra) values ('ativaveis');
 insert into palavras(palavra) values ('aticaria');
 insert into palavras(palavra) values ('atordoada');
 insert into palavras(palavra) values ('atordoei');
 insert into palavras(palavra) values ('atordoemos');
 insert into palavras(palavra) values ('atrapalhado');
 insert into palavras(palavra) values ('atrasarem');
 insert into palavras(palavra) values ('atravancava');
 insert into palavras(palavra) values ('atravessados');
 insert into palavras(palavra) values ('atrelaram');
 insert into palavras(palavra) values ('atrelares');
 insert into palavras(palavra) values ('atrevamos');
 insert into palavras(palavra) values ('atreveras');
 insert into palavras(palavra) values ('atribularmos');
 insert into palavras(palavra) values ('atribulara');
 insert into palavras(palavra) values ('atribulemo');
 insert into palavras(palavra) values ('atribuisseis');
 insert into palavras(palavra) values ('atribuiste');
 insert into palavras(palavra) values ('atrofiados');
 insert into palavras(palavra) values ('atrofiardes');
 insert into palavras(palavra) values ('atualizasses');
 insert into palavras(palavra) values ('atulhara');
 insert into palavras(palavra) values ('aturdimos');
 insert into palavras(palavra) values ('audazmente');
 insert into palavras(palavra) values ('auferimo');
 insert into palavras(palavra) values ('auferirmo');
 insert into palavras(palavra) values ('auferiramos');
 insert into palavras(palavra) values ('augurava');
 insert into palavras(palavra) values ('aumentativas');
 insert into palavras(palavra) values ('aureolei');
 insert into palavras(palavra) values ('auscultais');
 insert into palavras(palavra) values ('auscultaras');
 insert into palavras(palavra) values ('auscultassem');
 insert into palavras(palavra) values ('auscultasses');
 insert into palavras(palavra) values ('austeros');
 insert into palavras(palavra) values ('australiano');
 insert into palavras(palavra) values ('austriaca');
 insert into palavras(palavra) values ('autenticam');
 insert into palavras(palavra) values ('autenticaras');
 insert into palavras(palavra) values ('autentica');
 insert into palavras(palavra) values ('autistas');
 insert into palavras(palavra) values ('automatismo');
 insert into palavras(palavra) values ('autovetores');
 insert into palavras(palavra) values ('autoctone');
 insert into palavras(palavra) values ('autopsias');
 insert into palavras(palavra) values ('auxiliando');
 insert into palavras(palavra) values ('avacalhassem');
 insert into palavras(palavra) values ('avaliareis');
 insert into palavras(palavra) values ('avaliastes');
 insert into palavras(palavra) values ('avalizando');
 insert into palavras(palavra) values ('avalizara');
 insert into palavras(palavra) values ('avalizarmo');
 insert into palavras(palavra) values ('avaliasseis');
 insert into palavras(palavra) values ('avariariam');
 insert into palavras(palavra) values ('avassalaremo');
 insert into palavras(palavra) values ('avassalarmos');
 insert into palavras(palavra) values ('aventareis');
 insert into palavras(palavra) values ('aventurou');
 insert into palavras(palavra) values ('aventavamos');
 insert into palavras(palavra) values ('averiguam');
 insert into palavras(palavra) values ('avermelharao');
 insert into palavras(palavra) values ('avermelhavam');
 insert into palavras(palavra) values ('aviadores');
 insert into palavras(palavra) values ('avisareis');
 insert into palavras(palavra) values ('avistarem');
 insert into palavras(palavra) values ('avivardes');
 insert into palavras(palavra) values ('avivaria');
 insert into palavras(palavra) values ('avizinhamo');
 insert into palavras(palavra) values ('avizinharmos');
 insert into palavras(palavra) values ('avizinhasse');
 insert into palavras(palavra) values ('avizinhe');
 insert into palavras(palavra) values ('avizinhes');
 insert into palavras(palavra) values ('avultara');
 insert into palavras(palavra) values ('avultarieis');
 insert into palavras(palavra) values ('azararia');
 insert into palavras(palavra) values ('azeitais');
 insert into palavras(palavra) values ('azucrinamos');
 insert into palavras(palavra) values ('azucrinara');
 insert into palavras(palavra) values ('azulejam');
 insert into palavras(palavra) values ('azulejavas');
 insert into palavras(palavra) values ('azulavamos');
 insert into palavras(palavra) values ('acoitassemos');
 insert into palavras(palavra) values ('babassem');
 insert into palavras(palavra) values ('bacanais');
 insert into palavras(palavra) values ('badalarao');
 insert into palavras(palavra) values ('bafejarao');
 insert into palavras(palavra) values ('bagunceira');
 insert into palavras(palavra) values ('baguncaras');
 insert into palavras(palavra) values ('bailassem');
 insert into palavras(palavra) values ('baixariamos');
 insert into palavras(palavra) values ('balanceares');
 insert into palavras(palavra) values ('balancas');
 insert into palavras(palavra) values ('balancaramos');
 insert into palavras(palavra) values ('balbuciais');
 insert into palavras(palavra) values ('balbuciamo');
 insert into palavras(palavra) values ('baldaquim');
 insert into palavras(palavra) values ('baleeiro');
 insert into palavras(palavra) values ('balizasses');
 insert into palavras(palavra) values ('balzaquiana');
 insert into palavras(palavra) values ('balireis');
 insert into palavras(palavra) values ('bambearias');
 insert into palavras(palavra) values ('bamboleies');
 insert into palavras(palavra) values ('banalizam');
 insert into palavras(palavra) values ('banalizaremo');
 insert into palavras(palavra) values ('bancavamos');
 insert into palavras(palavra) values ('bandeirinhas');
 insert into palavras(palavra) values ('banditismo');
 insert into palavras(palavra) values ('bandoleiro');
 insert into palavras(palavra) values ('banheiro');
 insert into palavras(palavra) values ('banqueteies');
 insert into palavras(palavra) values ('banquetes');
 insert into palavras(palavra) values ('banquinhos');
 insert into palavras(palavra) values ('baqueando');
 insert into palavras(palavra) values ('baqueareis');
 insert into palavras(palavra) values ('baqueasse');
 insert into palavras(palavra) values ('baqueassem');
 insert into palavras(palavra) values ('baqueava');
 insert into palavras(palavra) values ('baqueavam');
 insert into palavras(palavra) values ('barbarizara');
 insert into palavras(palavra) values ('barbarizaras');
 insert into palavras(palavra) values ('barbarize');
 insert into palavras(palavra) values ('barganharam');
 insert into palavras(palavra) values ('barganharao');
 insert into palavras(palavra) values ('barricando');
 insert into palavras(palavra) values ('baseavas');
 insert into palavras(palavra) values ('bastarao');
 insert into palavras(palavra) values ('batimentos');
 insert into palavras(palavra) values ('batizarei');
 insert into palavras(palavra) values ('batizava');
 insert into palavras(palavra) values ('batucamos');
 insert into palavras(palavra) values ('batucares');
 insert into palavras(palavra) values ('batucassem');
 insert into palavras(palavra) values ('batucasseis');
 insert into palavras(palavra) values ('batessemos');
 insert into palavras(palavra) values ('beijardes');
 insert into palavras(palavra) values ('beijocais');
 insert into palavras(palavra) values ('beijocaria');
 insert into palavras(palavra) values ('beirarao');
 insert into palavras(palavra) values ('beliscaramos');
 insert into palavras(palavra) values ('bendiziam');
 insert into palavras(palavra) values ('beneficente');
 insert into palavras(palavra) values ('beneficiarmo');
 insert into palavras(palavra) values ('beneficios');
 insert into palavras(palavra) values ('benevolas');
 insert into palavras(palavra) values ('berrariam');
 insert into palavras(palavra) values ('berraras');
 insert into palavras(palavra) values ('berrariamos');
 insert into palavras(palavra) values ('besuntar');
 insert into palavras(palavra) values ('besuntaram');
 insert into palavras(palavra) values ('besuntarias');
 insert into palavras(palavra) values ('betumarem');
 insert into palavras(palavra) values ('betumariam');
 insert into palavras(palavra) values ('betumavas');
 insert into palavras(palavra) values ('betumavamos');
 insert into palavras(palavra) values ('bifurcassem');
 insert into palavras(palavra) values ('bilinear');
 insert into palavras(palavra) values ('blasfemos');
 insert into palavras(palavra) values ('blefarias');
 insert into palavras(palavra) values ('blindariam');
 insert into palavras(palavra) values ('bloqueasses');
 insert into palavras(palavra) values ('bloqueareis');
 insert into palavras(palavra) values ('boataria');
 insert into palavras(palavra) values ('bobearam');
 insert into palavras(palavra) values ('bocadinhos');
 insert into palavras(palavra) values ('bocejara');
 insert into palavras(palavra) values ('bocejara');
 insert into palavras(palavra) values ('bochecham');
 insert into palavras(palavra) values ('bochecho');
 insert into palavras(palavra) values ('bochechou');
 insert into palavras(palavra) values ('boiariamos');
 insert into palavras(palavra) values ('boicotaras');
 insert into palavras(palavra) values ('boicotou');
 insert into palavras(palavra) values ('bolivianas');
 insert into palavras(palavra) values ('bombardeava');
 insert into palavras(palavra) values ('bombastico');
 insert into palavras(palavra) values ('borbulhas');
 insert into palavras(palavra) values ('borbulhareis');
 insert into palavras(palavra) values ('bordejou');
 insert into palavras(palavra) values ('borrachudo');
 insert into palavras(palavra) values ('borrando');
 insert into palavras(palavra) values ('borrifara');
 insert into palavras(palavra) values ('borrifemos');
 insert into palavras(palavra) values ('bosquejardes');
 insert into palavras(palavra) values ('bosqueja');
 insert into palavras(palavra) values ('botoeira');
 insert into palavras(palavra) values ('botaveis');
 insert into palavras(palavra) values ('boxearia');
 insert into palavras(palavra) values ('boxeasseis');
 insert into palavras(palavra) values ('bracejaram');
 insert into palavras(palavra) values ('bramirao');
 insert into palavras(palavra) values ('brandireis');
 insert into palavras(palavra) values ('branqueado');
 insert into palavras(palavra) values ('branqueasse');
 insert into palavras(palavra) values ('branquinha');
 insert into palavras(palavra) values ('bravissima');
 insert into palavras(palavra) values ('brecariamos');
 insert into palavras(palavra) values ('brigareis');
 insert into palavras(palavra) values ('brindaram');
 insert into palavras(palavra) values ('brocares');
 insert into palavras(palavra) values ('brochassem');
 insert into palavras(palavra) values ('bronqueara');
 insert into palavras(palavra) values ('bronzearem');
 insert into palavras(palavra) values ('bronzearao');
 insert into palavras(palavra) values ('bronzeemos');
 insert into palavras(palavra) values ('broqueais');
 insert into palavras(palavra) values ('bubonico');
 insert into palavras(palavra) values ('bucefala');
 insert into palavras(palavra) values ('bucolico');
 insert into palavras(palavra) values ('bulirmos');
 insert into palavras(palavra) values ('burburinhos');
 insert into palavras(palavra) values ('burilareis');
 insert into palavras(palavra) values ('burilasses');
 insert into palavras(palavra) values ('burlescos');
 insert into palavras(palavra) values ('burrinho');
 insert into palavras(palavra) values ('buscasseis');
 insert into palavras(palavra) values ('buzinaram');
 insert into palavras(palavra) values ('balticos');
 insert into palavras(palavra) values ('cabotagens');
 insert into palavras(palavra) values ('cabriolarei');
 insert into palavras(palavra) values ('cabrioleis');
 insert into palavras(palavra) values ('cabriuva');
 insert into palavras(palavra) values ('cabiamos');
 insert into palavras(palavra) values ('cacarejaste');
 insert into palavras(palavra) values ('cachimbamo');
 insert into palavras(palavra) values ('cachimbaras');
 insert into palavras(palavra) values ('cadenciarias');
 insert into palavras(palavra) values ('cadenciarmos');
 insert into palavras(palavra) values ('caducarei');
 insert into palavras(palavra) values ('caducarao');
 insert into palavras(palavra) values ('caiaremos');
 insert into palavras(palavra) values ('caiariam');
 insert into palavras(palavra) values ('cajueiros');
 insert into palavras(palavra) values ('calafetaveis');
 insert into palavras(palavra) values ('calcificaria');
 insert into palavras(palavra) values ('calculassem');
 insert into palavras(palavra) values ('caldeirao');
 insert into palavras(palavra) values ('calejarao');
 insert into palavras(palavra) values ('calejareis');
 insert into palavras(palavra) values ('calhares');
 insert into palavras(palavra) values ('calhasse');
 insert into palavras(palavra) values ('calibradas');
 insert into palavras(palavra) values ('caloteassem');
 insert into palavras(palavra) values ('caloteavam');
 insert into palavras(palavra) values ('caloteei');
 insert into palavras(palavra) values ('caloteiam');
 insert into palavras(palavra) values ('calouros');
 insert into palavras(palavra) values ('calcarao');
 insert into palavras(palavra) values ('cambalacho');
 insert into palavras(palavra) values ('cambiarei');
 insert into palavras(palavra) values ('caminhamos');
 insert into palavras(palavra) values ('caminhoneta');
 insert into palavras(palavra) values ('campeareis');
 insert into palavras(palavra) values ('campeasses');
 insert into palavras(palavra) values ('campeoes');
 insert into palavras(palavra) values ('cancelais');
 insert into palavras(palavra) values ('cancelasse');
 insert into palavras(palavra) values ('candidatado');
 insert into palavras(palavra) values ('candidatavas');
 insert into palavras(palavra) values ('canicular');
 insert into palavras(palavra) values ('cansadinhas');
 insert into palavras(palavra) values ('cansarias');
 insert into palavras(palavra) values ('cansarao');
 insert into palavras(palavra) values ('cantarmo');
 insert into palavras(palavra) values ('capacetes');
 insert into palavras(palavra) values ('capacitaste');
 insert into palavras(palavra) values ('capacissima');
 insert into palavras(palavra) values ('capinassem');
 insert into palavras(palavra) values ('capinemos');
 insert into palavras(palavra) values ('capitaneara');
 insert into palavras(palavra) values ('capituleis');
 insert into palavras(palavra) values ('capotara');
 insert into palavras(palavra) values ('capotardes');
 insert into palavras(palavra) values ('capotareis');
 insert into palavras(palavra) values ('caprichasse');
 insert into palavras(palavra) values ('capturara');
 insert into palavras(palavra) values ('carapuca');
 insert into palavras(palavra) values ('carbonizemo');
 insert into palavras(palavra) values ('carbonicos');
 insert into palavras(palavra) values ('careceras');
 insert into palavras(palavra) values ('carecereis');
 insert into palavras(palavra) values ('carimbassem');
 insert into palavras(palavra) values ('cariatides');
 insert into palavras(palavra) values ('carnaubas');
 insert into palavras(palavra) values ('carpinteiras');
 insert into palavras(palavra) values ('carpirieis');
 insert into palavras(palavra) values ('carramelizam');
 insert into palavras(palavra) values ('carregariam');
 insert into palavras(palavra) values ('cartelas');
 insert into palavras(palavra) values ('carvaozinhos');
 insert into palavras(palavra) values ('casasses');
 insert into palavras(palavra) values ('castanhola');
 insert into palavras(palavra) values ('castrarao');
 insert into palavras(palavra) values ('casualidades');
 insert into palavras(palavra) values ('catalizariam');
 insert into palavras(palavra) values ('catassem');
 insert into palavras(palavra) values ('catequizei');
 insert into palavras(palavra) values ('cataveis');
 insert into palavras(palavra) values ('causarmo');
 insert into palavras(palavra) values ('cavalgadura');
 insert into palavras(palavra) values ('cavalgareis');
 insert into palavras(palavra) values ('caviaremos');
 insert into palavras(palavra) values ('cavocarei');
 insert into palavras(palavra) values ('cavocavam');
 insert into palavras(palavra) values ('cavoucais');
 insert into palavras(palavra) values ('cavoucaram');
 insert into palavras(palavra) values ('cavoucasseis');
 insert into palavras(palavra) values ('cavasseis');
 insert into palavras(palavra) values ('cacoareis');
 insert into palavras(palavra) values ('cacoareis');
 insert into palavras(palavra) values ('ceifaras');
 insert into palavras(palavra) values ('celebrarao');
 insert into palavras(palavra) values ('celebreis');
 insert into palavras(palavra) values ('celestes');
 insert into palavras(palavra) values ('censoras');
 insert into palavras(palavra) values ('censuraste');
 insert into palavras(palavra) values ('centralize');
 insert into palavras(palavra) values ('centralizemo');
 insert into palavras(palavra) values ('centrareis');
 insert into palavras(palavra) values ('centrifugar');
 insert into palavras(palavra) values ('centuplicou');
 insert into palavras(palavra) values ('centigrados');
 insert into palavras(palavra) values ('cerrarem');
 insert into palavras(palavra) values ('cerrastes');
 insert into palavras(palavra) values ('certificavam');
 insert into palavras(palavra) values ('chagareis');
 insert into palavras(palavra) values ('chamamentos');
 insert into palavras(palavra) values ('chamaram');
 insert into palavras(palavra) values ('chamaremos');
 insert into palavras(palavra) values ('chamejemo');
 insert into palavras(palavra) values ('chanfradas');
 insert into palavras(palavra) values ('charlataneei');
 insert into palavras(palavra) values ('charlataneou');
 insert into palavras(palavra) values ('chasqueia');
 insert into palavras(palavra) values ('chaveamo');
 insert into palavras(palavra) values ('chaveara');
 insert into palavras(palavra) values ('chaveareis');
 insert into palavras(palavra) values ('checarem');
 insert into palavras(palavra) values ('checasse');
 insert into palavras(palavra) values ('chefiado');
 insert into palavras(palavra) values ('chefiaremos');
 insert into palavras(palavra) values ('chegares');
 insert into palavras(palavra) values ('cheirariam');
 insert into palavras(palavra) values ('cheiremo');
 insert into palavras(palavra) values ('chifraram');
 insert into palavras(palavra) values ('chifrastes');
 insert into palavras(palavra) values ('chifrava');
 insert into palavras(palavra) values ('chilrearemos');
 insert into palavras(palavra) values ('chocaram');
 insert into palavras(palavra) values ('choramingara');
 insert into palavras(palavra) values ('choraram');
 insert into palavras(palavra) values ('chovamos');
 insert into palavras(palavra) values ('chuleassem');
 insert into palavras(palavra) values ('chumbeis');
 insert into palavras(palavra) values ('chupassem');
 insert into palavras(palavra) values ('chuviscando');
 insert into palavras(palavra) values ('chuviscava');
 insert into palavras(palavra) values ('chuviscavas');
 insert into palavras(palavra) values ('cicatrizarei');
 insert into palavras(palavra) values ('cimentamos');
 insert into palavras(palavra) values ('cimentasse');
 insert into palavras(palavra) values ('cimentaveis');
 insert into palavras(palavra) values ('cintilarmos');
 insert into palavras(palavra) values ('cintilaras');
 insert into palavras(palavra) values ('cinzeladoras');
 insert into palavras(palavra) values ('cinzelando');
 insert into palavras(palavra) values ('circuitarmos');
 insert into palavras(palavra) values ('circuitara');
 insert into palavras(palavra) values ('circuitaste');
 insert into palavras(palavra) values ('circulem');
 insert into palavras(palavra) values ('circuncida');
 insert into palavras(palavra) values ('circundeis');
 insert into palavras(palavra) values ('cisalpinos');
 insert into palavras(palavra) values ('ciscaramos');
 insert into palavras(palavra) values ('clamemos');
 insert into palavras(palavra) values ('clamores');
 insert into palavras(palavra) values ('clareardes');
 insert into palavras(palavra) values ('clareemo');
 insert into palavras(palavra) values ('claudica');
 insert into palavras(palavra) values ('claudiqueis');
 insert into palavras(palavra) values ('climatizes');
 insert into palavras(palavra) values ('clinicareis');
 insert into palavras(palavra) values ('clinicas');
 insert into palavras(palavra) values ('cloridricos');
 insert into palavras(palavra) values ('clerigos');
 insert into palavras(palavra) values ('coabitarei');
 insert into palavras(palavra) values ('coagirdes');
 insert into palavras(palavra) values ('coagirieis');
 insert into palavras(palavra) values ('cobertores');
 insert into palavras(palavra) values ('cobicaras');
 insert into palavras(palavra) values ('cobicava');
 insert into palavras(palavra) values ('cobicavamos');
 insert into palavras(palavra) values ('cobriras');
 insert into palavras(palavra) values ('cobrireis');
 insert into palavras(palavra) values ('cochichardes');
 insert into palavras(palavra) values ('cochilarieis');
 insert into palavras(palavra) values ('cocoricassem');
 insert into palavras(palavra) values ('coelhinho');
 insert into palavras(palavra) values ('coerente');
 insert into palavras(palavra) values ('coexistir');
 insert into palavras(palavra) values ('cogelariamos');
 insert into palavras(palavra) values ('coibirieis');
 insert into palavras(palavra) values ('coibiste');
 insert into palavras(palavra) values ('coincidem');
 insert into palavras(palavra) values ('coincidentes');
 insert into palavras(palavra) values ('coincido');
 insert into palavras(palavra) values ('coitados');
 insert into palavras(palavra) values ('colaboraremo');
 insert into palavras(palavra) values ('colecionaria');
 insert into palavras(palavra) values ('coleciono');
 insert into palavras(palavra) values ('coletarei');
 insert into palavras(palavra) values ('coletaremo');
 insert into palavras(palavra) values ('coletaria');
 insert into palavras(palavra) values ('coletivismo');
 insert into palavras(palavra) values ('coletivizem');
 insert into palavras(palavra) values ('coletoras');
 insert into palavras(palavra) values ('colhemos');
 insert into palavras(palavra) values ('colidindo');
 insert into palavras(palavra) values ('colidiremo');
 insert into palavras(palavra) values ('colonizado');
 insert into palavras(palavra) values ('colericas');
 insert into palavras(palavra) values ('colerico');
 insert into palavras(palavra) values ('combalira');
 insert into palavras(palavra) values ('combalires');
 insert into palavras(palavra) values ('combalissem');
 insert into palavras(palavra) values ('combateis');
 insert into palavras(palavra) values ('combateremo');
 insert into palavras(palavra) values ('combatesses');
 insert into palavras(palavra) values ('combatasseis');
 insert into palavras(palavra) values ('combinaram');
 insert into palavras(palavra) values ('comboiareis');
 insert into palavras(palavra) values ('comecemos');
 insert into palavras(palavra) values ('comedida');
 insert into palavras(palavra) values ('comemorassem');
 insert into palavras(palavra) values ('comensurado');
 insert into palavras(palavra) values ('comentarei');
 insert into palavras(palavra) values ('comentem');
 insert into palavras(palavra) values ('cometermos');
 insert into palavras(palavra) values ('cometiam');
 insert into palavras(palavra) values ('comissionas');
 insert into palavras(palavra) values ('comovestes');
 insert into palavras(palavra) values ('compadeceras');
 insert into palavras(palavra) values ('compareci');
 insert into palavras(palavra) values ('comparemos');
 insert into palavras(palavra) values ('compendiara');
 insert into palavras(palavra) values ('competira');
 insert into palavras(palavra) values ('compilarem');
 insert into palavras(palavra) values ('compilavam');
 insert into palavras(palavra) values ('compilaveis');
 insert into palavras(palavra) values ('complementem');
 insert into palavras(palavra) values ('completara');
 insert into palavras(palavra) values ('completareis');
 insert into palavras(palavra) values ('completastes');
 insert into palavras(palavra) values ('completareis');
 insert into palavras(palavra) values ('complicou');
 insert into palavras(palavra) values ('comportei');
 insert into palavras(palavra) values ('compositores');
 insert into palavras(palavra) values ('comprazestes');
 insert into palavras(palavra) values ('compreendamo');
 insert into palavras(palavra) values ('compreendia');
 insert into palavras(palavra) values ('comprimiam');
 insert into palavras(palavra) values ('comprimiamos');
 insert into palavras(palavra) values ('comprovadas');
 insert into palavras(palavra) values ('comprovara');
 insert into palavras(palavra) values ('comprovardes');
 insert into palavras(palavra) values ('comprovavam');
 insert into palavras(palavra) values ('comprove');
 insert into palavras(palavra) values ('computaste');
 insert into palavras(palavra) values ('comungasse');
 insert into palavras(palavra) values ('concedem');
 insert into palavras(palavra) values ('concentraras');
 insert into palavras(palavra) values ('concertarem');
 insert into palavras(palavra) values ('concertistas');
 insert into palavras(palavra) values ('conchavaria');
 insert into palavras(palavra) values ('conchavemos');
 insert into palavras(palavra) values ('conciliai');
 insert into palavras(palavra) values ('concilias');
 insert into palavras(palavra) values ('conclusao');
 insert into palavras(palavra) values ('concluias');
 insert into palavras(palavra) values ('concluido');
 insert into palavras(palavra) values ('concretiza');
 insert into palavras(palavra) values ('concursem');
 insert into palavras(palavra) values ('condenastes');
 insert into palavras(palavra) values ('condenei');
 insert into palavras(palavra) values ('condescender');
 insert into palavras(palavra) values ('condicionara');
 insert into palavras(palavra) values ('condicionou');
 insert into palavras(palavra) values ('condiscipula');
 insert into palavras(palavra) values ('condissesses');
 insert into palavras(palavra) values ('condizer');
 insert into palavras(palavra) values ('condoestes');
 insert into palavras(palavra) values ('conduzirem');
 insert into palavras(palavra) values ('conduziria');
 insert into palavras(palavra) values ('conectas');
 insert into palavras(palavra) values ('confabulam');
 insert into palavras(palavra) values ('confabular');
 insert into palavras(palavra) values ('confabuleis');
 insert into palavras(palavra) values ('conferimos');
 insert into palavras(palavra) values ('confessarmo');
 insert into palavras(palavra) values ('confessaras');
 insert into palavras(palavra) values ('confessasse');
 insert into palavras(palavra) values ('configurai');
 insert into palavras(palavra) values ('configures');
 insert into palavras(palavra) values ('confinardes');
 insert into palavras(palavra) values ('confinava');
 insert into palavras(palavra) values ('confiscarmos');
 insert into palavras(palavra) values ('confisques');
 insert into palavras(palavra) values ('conformistas');
 insert into palavras(palavra) values ('confortarei');
 insert into palavras(palavra) values ('conforte');
 insert into palavras(palavra) values ('conforto');
 insert into palavras(palavra) values ('confronto');
 insert into palavras(palavra) values ('confundiremo');
 insert into palavras(palavra) values ('congelamo');
 insert into palavras(palavra) values ('congelarmos');
 insert into palavras(palavra) values ('congelassem');
 insert into palavras(palavra) values ('congelasses');
 insert into palavras(palavra) values ('conglomerava');
 insert into palavras(palavra) values ('conglomera');
 insert into palavras(palavra) values ('congraca');
 insert into palavras(palavra) values ('congregamos');
 insert into palavras(palavra) values ('congregares');
 insert into palavras(palavra) values ('congreguei');
 insert into palavras(palavra) values ('conheceram');
 insert into palavras(palavra) values ('conjeturares');
 insert into palavras(palavra) values ('conjeturaste');
 insert into palavras(palavra) values ('conjeturava');
 insert into palavras(palavra) values ('conjugasse');
 insert into palavras(palavra) values ('conjugacao');
 insert into palavras(palavra) values ('conjurarmo');
 insert into palavras(palavra) values ('conjuravam');
 insert into palavras(palavra) values ('consagrara');
 insert into palavras(palavra) values ('conseguirias');
 insert into palavras(palavra) values ('conseguirmo');
 insert into palavras(palavra) values ('conselhos');
 insert into palavras(palavra) values ('consertemo');
 insert into palavras(palavra) values ('conservares');
 insert into palavras(palavra) values ('consigais');
 insert into palavras(palavra) values ('consignai');
 insert into palavras(palavra) values ('consignaste');
 insert into palavras(palavra) values ('consistimo');
 insert into palavras(palavra) values ('consolei');
 insert into palavras(palavra) values ('consolemos');
 insert into palavras(palavra) values ('consolidemos');
 insert into palavras(palavra) values ('conspirarao');
 insert into palavras(palavra) values ('conspurcarmo');
 insert into palavras(palavra) values ('conspurcasse');
 insert into palavras(palavra) values ('conspurques');
 insert into palavras(palavra) values ('consternadas');
 insert into palavras(palavra) values ('consternacao');
 insert into palavras(palavra) values ('constipardes');
 insert into palavras(palavra) values ('constipassem');
 insert into palavras(palavra) values ('constituais');
 insert into palavras(palavra) values ('constituiria');
 insert into palavras(palavra) values ('constrangida');
 insert into palavras(palavra) values ('constranjais');
 insert into palavras(palavra) values ('consultor');
 insert into palavras(palavra) values ('consumirias');
 insert into palavras(palavra) values ('consumirieis');
 insert into palavras(palavra) values ('consumis');
 insert into palavras(palavra) values ('consumireis');
 insert into palavras(palavra) values ('contabilizou');
 insert into palavras(palavra) values ('contactados');
 insert into palavras(palavra) values ('contaminarao');
 insert into palavras(palavra) values ('contendesses');
 insert into palavras(palavra) values ('contendia');
 insert into palavras(palavra) values ('contentou');
 insert into palavras(palavra) values ('conterem');
 insert into palavras(palavra) values ('contestem');
 insert into palavras(palavra) values ('contestemo');
 insert into palavras(palavra) values ('continuarias');
 insert into palavras(palavra) values ('continuas');
 insert into palavras(palavra) values ('continuava');
 insert into palavras(palavra) values ('continuacoes');
 insert into palavras(palavra) values ('contorceram');
 insert into palavras(palavra) values ('contorcerem');
 insert into palavras(palavra) values ('contorcereis');
 insert into palavras(palavra) values ('contrabandos');
 insert into palavras(palavra) values ('contrafazes');
 insert into palavras(palavra) values ('contrairdes');
 insert into palavras(palavra) values ('contraltos');
 insert into palavras(palavra) values ('contramarcha');
 insert into palavras(palavra) values ('contrariado');
 insert into palavras(palavra) values ('contrariasse');
 insert into palavras(palavra) values ('contrariemos');
 insert into palavras(palavra) values ('contrastaras');
 insert into palavras(palavra) values ('contratadas');
 insert into palavras(palavra) values ('contraisse');
 insert into palavras(palavra) values ('contraistes');
 insert into palavras(palavra) values ('contristai');
 insert into palavras(palavra) values ('contristamos');
 insert into palavras(palavra) values ('contristaras');
 insert into palavras(palavra) values ('contrarias');
 insert into palavras(palavra) values ('contundas');
 insert into palavras(palavra) values ('contavamos');
 insert into palavras(palavra) values ('convalesce');
 insert into palavras(palavra) values ('convenceres');
 insert into palavras(palavra) values ('convenho');
 insert into palavras(palavra) values ('convencamos');
 insert into palavras(palavra) values ('convergiremo');
 insert into palavras(palavra) values ('converseis');
 insert into palavras(palavra) values ('conversoras');
 insert into palavras(palavra) values ('convidadas');
 insert into palavras(palavra) values ('convidaremo');
 insert into palavras(palavra) values ('convidarieis');
 insert into palavras(palavra) values ('convides');
 insert into palavras(palavra) values ('convieras');
 insert into palavras(palavra) values ('convinha');
 insert into palavras(palavra) values ('convocares');
 insert into palavras(palavra) values ('cooperarias');
 insert into palavras(palavra) values ('cooperarieis');
 insert into palavras(palavra) values ('cooperativo');
 insert into palavras(palavra) values ('cooperacoes');
 insert into palavras(palavra) values ('cooptara');
 insert into palavras(palavra) values ('coordenativo');
 insert into palavras(palavra) values ('copiaremo');
 insert into palavras(palavra) values ('copiariamos');
 insert into palavras(palavra) values ('corajoso');
 insert into palavras(palavra) values ('corcovas');
 insert into palavras(palavra) values ('corespondemo');
 insert into palavras(palavra) values ('coreografa');
 insert into palavras(palavra) values ('coriscaremos');
 insert into palavras(palavra) values ('coriscou');
 insert into palavras(palavra) values ('cornetas');
 insert into palavras(palavra) values ('corpulento');
 insert into palavras(palavra) values ('corredimieis');
 insert into palavras(palavra) values ('correicional');
 insert into palavras(palavra) values ('correlativo');
 insert into palavras(palavra) values ('correspondi');
 insert into palavras(palavra) values ('corrompais');
 insert into palavras(palavra) values ('corromperdes');
 insert into palavras(palavra) values ('corrosivos');
 insert into palavras(palavra) values ('corrosao');
 insert into palavras(palavra) values ('corroias');
 insert into palavras(palavra) values ('cortasse');
 insert into palavras(palavra) values ('cortejara');
 insert into palavras(palavra) values ('cortaveis');
 insert into palavras(palavra) values ('cosmopolita');
 insert into palavras(palavra) values ('costumaremo');
 insert into palavras(palavra) values ('costurasseis');
 insert into palavras(palavra) values ('cotejaram');
 insert into palavras(palavra) values ('cotizando');
 insert into palavras(palavra) values ('cotizassem');
 insert into palavras(palavra) values ('cotizacao');
 insert into palavras(palavra) values ('cozeriam');
 insert into palavras(palavra) values ('cozinhais');
 insert into palavras(palavra) values ('cozesseis');
 insert into palavras(palavra) values ('cocareis');
 insert into palavras(palavra) values ('cravarem');
 insert into palavras(palavra) values ('cravejam');
 insert into palavras(palavra) values ('cravejarias');
 insert into palavras(palavra) values ('creditas');
 insert into palavras(palavra) values ('cremardes');
 insert into palavras(palavra) values ('cremariamos');
 insert into palavras(palavra) values ('cremassem');
 insert into palavras(palavra) values ('crepitarias');
 insert into palavras(palavra) values ('crepitaste');
 insert into palavras(palavra) values ('cresceras');
 insert into palavras(palavra) values ('criptograma');
 insert into palavras(palavra) values ('crismemo');
 insert into palavras(palavra) values ('cristalizava');
 insert into palavras(palavra) values ('crisalidas');
 insert into palavras(palavra) values ('critiquei');
 insert into palavras(palavra) values ('crivaras');
 insert into palavras(palavra) values ('crucificacao');
 insert into palavras(palavra) values ('crucifixam');
 insert into palavras(palavra) values ('crucifixamo');
 insert into palavras(palavra) values ('criticas');
 insert into palavras(palavra) values ('cuidando');
 insert into palavras(palavra) values ('cuidassem');
 insert into palavras(palavra) values ('culminaras');
 insert into palavras(palavra) values ('culminardes');
 insert into palavras(palavra) values ('cultivado');
 insert into palavras(palavra) values ('cultuarieis');
 insert into palavras(palavra) values ('cultuavas');
 insert into palavras(palavra) values ('cumprimentam');
 insert into palavras(palavra) values ('cumprirmo');
 insert into palavras(palavra) values ('cumpriste');
 insert into palavras(palavra) values ('cumulando');
 insert into palavras(palavra) values ('cumularas');
 insert into palavras(palavra) values ('cunhariamos');
 insert into palavras(palavra) values ('cunhavamos');
 insert into palavras(palavra) values ('cunhaveis');
 insert into palavras(palavra) values ('curtiste');
 insert into palavras(palavra) values ('curvareis');
 insert into palavras(palavra) values ('curvarmo');
 insert into palavras(palavra) values ('cuspiremo');
 insert into palavras(palavra) values ('cuspiras');
 insert into palavras(palavra) values ('custando');
 insert into palavras(palavra) values ('custardes');
 insert into palavras(palavra) values ('custearieis');
 insert into palavras(palavra) values ('custeava');
 insert into palavras(palavra) values ('cutelarias');
 insert into palavras(palavra) values ('cutucaram');
 insert into palavras(palavra) values ('cutucassemos');
 insert into palavras(palavra) values ('danificamos');
 insert into palavras(palavra) values ('danificarem');
 insert into palavras(palavra) values ('danificaremo');
 insert into palavras(palavra) values ('danifique');
 insert into palavras(palavra) values ('darwiniana');
 insert into palavras(palavra) values ('debandardes');
 insert into palavras(palavra) values ('debandara');
 insert into palavras(palavra) values ('debandavamos');
 insert into palavras(palavra) values ('debateste');
 insert into palavras(palavra) values ('debeladora');
 insert into palavras(palavra) values ('debelarieis');
 insert into palavras(palavra) values ('debelaveis');
 insert into palavras(palavra) values ('debilitam');
 insert into palavras(palavra) values ('debilitamos');
 insert into palavras(palavra) values ('debilitaras');
 insert into palavras(palavra) values ('debitadas');
 insert into palavras(palavra) values ('debochasses');
 insert into palavras(palavra) values ('debochavam');
 insert into palavras(palavra) values ('debochemos');
 insert into palavras(palavra) values ('debrucava');
 insert into palavras(palavra) values ('debulhado');
 insert into palavras(palavra) values ('debulharmos');
 insert into palavras(palavra) values ('debutassemos');
 insert into palavras(palavra) values ('decadencias');
 insert into palavras(palavra) values ('decalcarao');
 insert into palavras(palavra) values ('decalcaramos');
 insert into palavras(palavra) values ('decalitros');
 insert into palavras(palavra) values ('decanias');
 insert into palavras(palavra) values ('decantei');
 insert into palavras(palavra) values ('decapitamo');
 insert into palavras(palavra) values ('decepcionara');
 insert into palavras(palavra) values ('decepassemos');
 insert into palavras(palavra) values ('decepcoes');
 insert into palavras(palavra) values ('declamado');
 insert into palavras(palavra) values ('declarem');
 insert into palavras(palavra) values ('declinaveis');
 insert into palavras(palavra) values ('decolaras');
 insert into palavras(palavra) values ('decolasseis');
 insert into palavras(palavra) values ('decoraras');
 insert into palavras(palavra) values ('decrementado');
 insert into palavras(palavra) values ('decrementara');
 insert into palavras(palavra) values ('decrementeis');
 insert into palavras(palavra) values ('decresce');
 insert into palavras(palavra) values ('decrescera');
 insert into palavras(palavra) values ('decresceras');
 insert into palavras(palavra) values ('decresceste');
 insert into palavras(palavra) values ('decretarmos');
 insert into palavras(palavra) values ('decretes');
 insert into palavras(palavra) values ('decuplicavam');
 insert into palavras(palavra) values ('decupliqueis');
 insert into palavras(palavra) values ('decagonos');
 insert into palavras(palavra) values ('dedicassemos');
 insert into palavras(palavra) values ('dedilharem');
 insert into palavras(palavra) values ('dedilhara');
 insert into palavras(palavra) values ('dedurara');
 insert into palavras(palavra) values ('deduremos');
 insert into palavras(palavra) values ('deduraveis');
 insert into palavras(palavra) values ('deduzira');
 insert into palavras(palavra) values ('deduzira');
 insert into palavras(palavra) values ('deduziamos');
 insert into palavras(palavra) values ('defasaremo');
 insert into palavras(palavra) values ('defasaste');
 insert into palavras(palavra) values ('defeccao');
 insert into palavras(palavra) values ('defendei');
 insert into palavras(palavra) values ('defendereis');
 insert into palavras(palavra) values ('defensivas');
 insert into palavras(palavra) values ('defeririamos');
 insert into palavras(palavra) values ('definhas');
 insert into palavras(palavra) values ('definhemo');
 insert into palavras(palavra) values ('definhareis');
 insert into palavras(palavra) values ('deflagrassem');
 insert into palavras(palavra) values ('deformarieis');
 insert into palavras(palavra) values ('deformavamos');
 insert into palavras(palavra) values ('deformaveis');
 insert into palavras(palavra) values ('defraudardes');
 insert into palavras(palavra) values ('defraudasse');
 insert into palavras(palavra) values ('defraudemos');
 insert into palavras(palavra) values ('defumares');
 insert into palavras(palavra) values ('defumava');
 insert into palavras(palavra) values ('deglutimos');
 insert into palavras(palavra) values ('degolamo');
 insert into palavras(palavra) values ('degolara');
 insert into palavras(palavra) values ('degradaremo');
 insert into palavras(palavra) values ('degredamo');
 insert into palavras(palavra) values ('degredasse');
 insert into palavras(palavra) values ('degredou');
 insert into palavras(palavra) values ('degringolara');
 insert into palavras(palavra) values ('degustassem');
 insert into palavras(palavra) values ('degustava');
 insert into palavras(palavra) values ('deificareis');
 insert into palavras(palavra) values ('deixarem');
 insert into palavras(palavra) values ('deixariamos');
 insert into palavras(palavra) values ('delegamo');
 insert into palavras(palavra) values ('deleitamento');
 insert into palavras(palavra) values ('deliciariam');
 insert into palavras(palavra) values ('delicies');
 insert into palavras(palavra) values ('delimitasses');
 insert into palavras(palavra) values ('delimitem');
 insert into palavras(palavra) values ('delinquira');
 insert into palavras(palavra) values ('delirastes');
 insert into palavras(palavra) values ('delongarieis');
 insert into palavras(palavra) values ('delongues');
 insert into palavras(palavra) values ('demandarem');
 insert into palavras(palavra) values ('demandarias');
 insert into palavras(palavra) values ('demarcareis');
 insert into palavras(palavra) values ('demonstre');
 insert into palavras(palavra) values ('demorasseis');
 insert into palavras(palavra) values ('denigramo');
 insert into palavras(palavra) values ('denominardes');
 insert into palavras(palavra) values ('denominarem');
 insert into palavras(palavra) values ('denominei');
 insert into palavras(palavra) values ('dentados');
 insert into palavras(palavra) values ('denudemos');
 insert into palavras(palavra) values ('denunciaremo');
 insert into palavras(palavra) values ('denunciarmos');
 insert into palavras(palavra) values ('denunciassem');
 insert into palavras(palavra) values ('denunciasses');
 insert into palavras(palavra) values ('denuncies');
 insert into palavras(palavra) values ('depauperando');
 insert into palavras(palavra) values ('dependeriam');
 insert into palavras(palavra) values ('dependerieis');
 insert into palavras(palavra) values ('dependurarei');
 insert into palavras(palavra) values ('depilatorias');
 insert into palavras(palavra) values ('deploram');
 insert into palavras(palavra) values ('deplorarmo');
 insert into palavras(palavra) values ('deponhamos');
 insert into palavras(palavra) values ('deportaste');
 insert into palavras(palavra) values ('depravarieis');
 insert into palavras(palavra) values ('depreciou');
 insert into palavras(palavra) values ('depusereis');
 insert into palavras(palavra) values ('deputarmos');
 insert into palavras(palavra) values ('deputeis');
 insert into palavras(palavra) values ('derivarieis');
 insert into palavras(palavra) values ('derivaveis');
 insert into palavras(palavra) values ('derramou');
 insert into palavras(palavra) values ('derraparao');
 insert into palavras(palavra) values ('derrapareis');
 insert into palavras(palavra) values ('derretermos');
 insert into palavras(palavra) values ('derribando');
 insert into palavras(palavra) values ('derribara');
 insert into palavras(palavra) values ('derribas');
 insert into palavras(palavra) values ('derribaste');
 insert into palavras(palavra) values ('derrogavamos');
 insert into palavras(palavra) values ('derrotistas');
 insert into palavras(palavra) values ('desabafastes');
 insert into palavras(palavra) values ('desabareis');
 insert into palavras(palavra) values ('desabaras');
 insert into palavras(palavra) values ('desabitada');
 insert into palavras(palavra) values ('desabonando');
 insert into palavras(palavra) values ('desabonara');
 insert into palavras(palavra) values ('desabonaria');
 insert into palavras(palavra) values ('desabotoamo');
 insert into palavras(palavra) values ('desabotoaram');
 insert into palavras(palavra) values ('desabrocha');
 insert into palavras(palavra) values ('desabusada');
 insert into palavras(palavra) values ('desacordada');
 insert into palavras(palavra) values ('desacordadas');
 insert into palavras(palavra) values ('desafiaremo');
 insert into palavras(palavra) values ('desafiarieis');
 insert into palavras(palavra) values ('desafinado');
 insert into palavras(palavra) values ('desafinando');
 insert into palavras(palavra) values ('desagrave');
 insert into palavras(palavra) values ('desagregais');
 insert into palavras(palavra) values ('desagregar');
 insert into palavras(palavra) values ('desaguaram');
 insert into palavras(palavra) values ('desalenta');
 insert into palavras(palavra) values ('desalentados');
 insert into palavras(palavra) values ('desalentara');
 insert into palavras(palavra) values ('desalojaras');
 insert into palavras(palavra) values ('desamarrado');
 insert into palavras(palavra) values ('desamarraras');
 insert into palavras(palavra) values ('desamarreis');
 insert into palavras(palavra) values ('desamparamo');
 insert into palavras(palavra) values ('desampararao');
 insert into palavras(palavra) values ('desandasse');
 insert into palavras(palavra) values ('desanimam');
 insert into palavras(palavra) values ('desanimemo');
 insert into palavras(palavra) values ('desanuviasse');
 insert into palavras(palavra) values ('desanuviava');
 insert into palavras(palavra) values ('desapegardes');
 insert into palavras(palavra) values ('desapegues');
 insert into palavras(palavra) values ('desapontemos');
 insert into palavras(palavra) values ('desaprove');
 insert into palavras(palavra) values ('desaprumo');
 insert into palavras(palavra) values ('desarmonica');
 insert into palavras(palavra) values ('desarraigai');
 insert into palavras(palavra) values ('desarranjava');
 insert into palavras(palavra) values ('desarranjemo');
 insert into palavras(palavra) values ('desatarmo');
 insert into palavras(palavra) values ('desatarieis');
 insert into palavras(palavra) values ('desatencao');
 insert into palavras(palavra) values ('desativavam');
 insert into palavras(palavra) values ('desativa');
 insert into palavras(palavra) values ('desavierdes');
 insert into palavras(palavra) values ('desbarataras');
 insert into palavras(palavra) values ('desbocado');
 insert into palavras(palavra) values ('desbravareis');
 insert into palavras(palavra) values ('desbravarmos');
 insert into palavras(palavra) values ('descabelarmo');
 insert into palavras(palavra) values ('descabeles');
 insert into palavras(palavra) values ('descairiamos');
 insert into palavras(palavra) values ('descairieis');
 insert into palavras(palavra) values ('descalcasses');
 insert into palavras(palavra) values ('descalcareis');
 insert into palavras(palavra) values ('descambara');
 insert into palavras(palavra) values ('descansaremo');
 insert into palavras(palavra) values ('descansastes');
 insert into palavras(palavra) values ('descansei');
 insert into palavras(palavra) values ('descansemos');
 insert into palavras(palavra) values ('descarregou');
 insert into palavras(palavra) values ('descarrilado');
 insert into palavras(palavra) values ('descascando');
 insert into palavras(palavra) values ('descascaras');
 insert into palavras(palavra) values ('descascastes');
 insert into palavras(palavra) values ('descasco');
 insert into palavras(palavra) values ('descasquemos');
 insert into palavras(palavra) values ('descobertas');
 insert into palavras(palavra) values ('descogelas');
 insert into palavras(palavra) values ('descolorarmo');
 insert into palavras(palavra) values ('descolorara');
 insert into palavras(palavra) values ('descomplica');
 insert into palavras(palavra) values ('desconfortos');
 insert into palavras(palavra) values ('descontassem');
 insert into palavras(palavra) values ('descortinava');
 insert into palavras(palavra) values ('descortines');
 insert into palavras(palavra) values ('descosturo');
 insert into palavras(palavra) values ('descreio');
 insert into palavras(palavra) values ('descrevem');
 insert into palavras(palavra) values ('descreveres');
 insert into palavras(palavra) values ('descuidava');
 insert into palavras(palavra) values ('desculpasses');
 insert into palavras(palavra) values ('desculpou');
 insert into palavras(palavra) values ('desdenhamos');
 insert into palavras(palavra) values ('desdenhassem');
 insert into palavras(palavra) values ('desejaremo');
 insert into palavras(palavra) values ('desembainhar');
 insert into palavras(palavra) values ('desembarquei');
 insert into palavras(palavra) values ('desemboquei');
 insert into palavras(palavra) values ('desempacaram');
 insert into palavras(palavra) values ('desempenes');
 insert into palavras(palavra) values ('desencostem');
 insert into palavras(palavra) values ('desenfaixem');
 insert into palavras(palavra) values ('desenfrearam');
 insert into palavras(palavra) values ('desenfreeis');
 insert into palavras(palavra) values ('desengomarem');
 insert into palavras(palavra) values ('desengonces');
 insert into palavras(palavra) values ('desengoncara');
 insert into palavras(palavra) values ('desengraxar');
 insert into palavras(palavra) values ('desengraxei');
 insert into palavras(palavra) values ('desenguicara');
 insert into palavras(palavra) values ('desenguicara');
 insert into palavras(palavra) values ('desenrole');
 insert into palavras(palavra) values ('desenroscara');
 insert into palavras(palavra) values ('desenroscara');
 insert into palavras(palavra) values ('desentalai');
 insert into palavras(palavra) values ('desesperares');
 insert into palavras(palavra) values ('desfalecesse');
 insert into palavras(palavra) values ('desfarieis');
 insert into palavras(palavra) values ('desfechareis');
 insert into palavras(palavra) values ('desfechem');
 insert into palavras(palavra) values ('desferes');
 insert into palavras(palavra) values ('desferirmo');
 insert into palavras(palavra) values ('desfiaras');
 insert into palavras(palavra) values ('desfiemo');
 insert into palavras(palavra) values ('desfilarem');
 insert into palavras(palavra) values ('desforrarias');
 insert into palavras(palavra) values ('desforrarmo');
 insert into palavras(palavra) values ('desgarrado');
 insert into palavras(palavra) values ('desgarrares');
 insert into palavras(palavra) values ('desgastarem');
 insert into palavras(palavra) values ('desgastaremo');
 insert into palavras(palavra) values ('desgastaste');
 insert into palavras(palavra) values ('desgracioso');
 insert into palavras(palavra) values ('designara');
 insert into palavras(palavra) values ('designas');
 insert into palavras(palavra) values ('designasse');
 insert into palavras(palavra) values ('desiludem');
 insert into palavras(palavra) values ('desiludisses');
 insert into palavras(palavra) values ('desimpedirei');
 insert into palavras(palavra) values ('desinchastes');
 insert into palavras(palavra) values ('desinibido');
 insert into palavras(palavra) values ('desintegrais');
 insert into palavras(palavra) values ('desintegrar');
 insert into palavras(palavra) values ('desintegre');
 insert into palavras(palavra) values ('desinteresse');
 insert into palavras(palavra) values ('desistindo');
 insert into palavras(palavra) values ('desistirei');
 insert into palavras(palavra) values ('desligarao');
 insert into palavras(palavra) values ('desligavas');
 insert into palavras(palavra) values ('deslizamos');
 insert into palavras(palavra) values ('deslocara');
 insert into palavras(palavra) values ('deslumbrando');
 insert into palavras(palavra) values ('deslustrei');
 insert into palavras(palavra) values ('deslustra');
 insert into palavras(palavra) values ('desmaiavas');
 insert into palavras(palavra) values ('desmaios');
 insert into palavras(palavra) values ('desmanchando');
 insert into palavras(palavra) values ('desmanchara');
 insert into palavras(palavra) values ('desmandareis');
 insert into palavras(palavra) values ('desmandavam');
 insert into palavras(palavra) values ('desmantela');
 insert into palavras(palavra) values ('desmantelo');
 insert into palavras(palavra) values ('desmascarai');
 insert into palavras(palavra) values ('desmedidos');
 insert into palavras(palavra) values ('desmediamos');
 insert into palavras(palavra) values ('desmembrares');
 insert into palavras(palavra) values ('desmentindo');
 insert into palavras(palavra) values ('desminta');
 insert into palavras(palavra) values ('desmobilizo');
 insert into palavras(palavra) values ('desmontarem');
 insert into palavras(palavra) values ('desmontarias');
 insert into palavras(palavra) values ('desmontaras');
 insert into palavras(palavra) values ('desmontarao');
 insert into palavras(palavra) values ('desmontei');
 insert into palavras(palavra) values ('desmoronas');
 insert into palavras(palavra) values ('desmunheca');
 insert into palavras(palavra) values ('desnorteiem');
 insert into palavras(palavra) values ('desnortea');
 insert into palavras(palavra) values ('desnudarias');
 insert into palavras(palavra) values ('desobedecera');
 insert into palavras(palavra) values ('desobrigarem');
 insert into palavras(palavra) values ('desocupa');
 insert into palavras(palavra) values ('desocupasse');
 insert into palavras(palavra) values ('desodorizo');
 insert into palavras(palavra) values ('desonera');
 insert into palavras(palavra) values ('desonrou');
 insert into palavras(palavra) values ('desoprimias');
 insert into palavras(palavra) values ('desovavas');
 insert into palavras(palavra) values ('desovemo');
 insert into palavras(palavra) values ('desparziu');
 insert into palavras(palavra) values ('despedacarao');
 insert into palavras(palavra) values ('despedacas');
 insert into palavras(palavra) values ('despedira');
 insert into palavras(palavra) values ('despejastes');
 insert into palavras(palavra) values ('despejava');
 insert into palavras(palavra) values ('despencareis');
 insert into palavras(palavra) values ('despencarias');
 insert into palavras(palavra) values ('despencarmos');
 insert into palavras(palavra) values ('despendeu');
 insert into palavras(palavra) values ('despentearas');
 insert into palavras(palavra) values ('despenteei');
 insert into palavras(palavra) values ('despercebam');
 insert into palavras(palavra) values ('despercebei');
 insert into palavras(palavra) values ('despercebias');
 insert into palavras(palavra) values ('despirias');
 insert into palavras(palavra) values ('despistara');
 insert into palavras(palavra) values ('despistarao');
 insert into palavras(palavra) values ('despojar');
 insert into palavras(palavra) values ('despoluicao');
 insert into palavras(palavra) values ('despontasse');
 insert into palavras(palavra) values ('despontes');
 insert into palavras(palavra) values ('desposastes');
 insert into palavras(palavra) values ('desprezareis');
 insert into palavras(palavra) values ('desratizarei');
 insert into palavras(palavra) values ('desregrara');
 insert into palavras(palavra) values ('desrespeito');
 insert into palavras(palavra) values ('dessalinizei');
 insert into palavras(palavra) values ('dessedentamo');
 insert into palavras(palavra) values ('dessedentar');
 insert into palavras(palavra) values ('destacamo');
 insert into palavras(palavra) values ('destacaria');
 insert into palavras(palavra) values ('destampadas');
 insert into palavras(palavra) values ('destelhara');
 insert into palavras(palavra) values ('desterrasse');
 insert into palavras(palavra) values ('desterremos');
 insert into palavras(palavra) values ('destiladora');
 insert into palavras(palavra) values ('destilai');
 insert into palavras(palavra) values ('destilarmos');
 insert into palavras(palavra) values ('destilasses');
 insert into palavras(palavra) values ('destinamo');
 insert into palavras(palavra) values ('destituia');
 insert into palavras(palavra) values ('destoassem');
 insert into palavras(palavra) values ('destratamo');
 insert into palavras(palavra) values ('destratar');
 insert into palavras(palavra) values ('destratemos');
 insert into palavras(palavra) values ('destrincheis');
 insert into palavras(palavra) values ('destrona');
 insert into palavras(palavra) values ('destronarmo');
 insert into palavras(palavra) values ('destroncaram');
 insert into palavras(palavra) values ('destronei');
 insert into palavras(palavra) values ('destrona');
 insert into palavras(palavra) values ('destrocaram');
 insert into palavras(palavra) values ('destrocas');
 insert into palavras(palavra) values ('destrocasse');
 insert into palavras(palavra) values ('desunindo');
 insert into palavras(palavra) values ('desunira');
 insert into palavras(palavra) values ('desvaliamos');
 insert into palavras(palavra) values ('desvanecei');
 insert into palavras(palavra) values ('desvanecemos');
 insert into palavras(palavra) values ('desvaneceras');
 insert into palavras(palavra) values ('desvanecerei');
 insert into palavras(palavra) values ('desvaneci');
 insert into palavras(palavra) values ('desvelado');
 insert into palavras(palavra) values ('desvendo');
 insert into palavras(palavra) values ('desvinculem');
 insert into palavras(palavra) values ('desvirtuar');
 insert into palavras(palavra) values ('desvirtuarei');
 insert into palavras(palavra) values ('detectarmos');
 insert into palavras(palavra) values ('detectes');
 insert into palavras(palavra) values ('detectores');
 insert into palavras(palavra) values ('determinara');
 insert into palavras(palavra) values ('detetara');
 insert into palavras(palavra) values ('detivermo');
 insert into palavras(palavra) values ('detonado');
 insert into palavras(palavra) values ('detonariam');
 insert into palavras(palavra) values ('detonara');
 insert into palavras(palavra) values ('deturpai');
 insert into palavras(palavra) values ('devaneares');
 insert into palavras(palavra) values ('devassados');
 insert into palavras(palavra) values ('deveremo');
 insert into palavras(palavra) values ('devolvas');
 insert into palavras(palavra) values ('devorasseis');
 insert into palavras(palavra) values ('devotariamos');
 insert into palavras(palavra) values ('devotasse');
 insert into palavras(palavra) values ('devotastes');
 insert into palavras(palavra) values ('diabolico');
 insert into palavras(palavra) values ('diagnostica');
 insert into palavras(palavra) values ('diagramastes');
 insert into palavras(palavra) values ('dialoguemo');
 insert into palavras(palavra) values ('dialogaveis');
 insert into palavras(palavra) values ('dialetico');
 insert into palavras(palavra) values ('diariamente');
 insert into palavras(palavra) values ('didatico');
 insert into palavras(palavra) values ('difamamo');
 insert into palavras(palavra) values ('difamariam');
 insert into palavras(palavra) values ('difamassemos');
 insert into palavras(palavra) values ('diferimo');
 insert into palavras(palavra) values ('dificultais');
 insert into palavras(palavra) values ('dificultemos');
 insert into palavras(palavra) values ('difrataremos');
 insert into palavras(palavra) values ('difrataria');
 insert into palavras(palavra) values ('difundieis');
 insert into palavras(palavra) values ('digeriras');
 insert into palavras(palavra) values ('digitadora');
 insert into palavras(palavra) values ('digitamo');
 insert into palavras(palavra) values ('digitara');
 insert into palavras(palavra) values ('digitarmo');
 insert into palavras(palavra) values ('digitara');
 insert into palavras(palavra) values ('digitaras');
 insert into palavras(palavra) values ('dignavam');
 insert into palavras(palavra) values ('dignificas');
 insert into palavras(palavra) values ('dignificava');
 insert into palavras(palavra) values ('digressao');
 insert into palavras(palavra) values ('dilacera');
 insert into palavras(palavra) values ('dilatarei');
 insert into palavras(palavra) values ('dilatarem');
 insert into palavras(palavra) values ('dilatarmos');
 insert into palavras(palavra) values ('dilatasseis');
 insert into palavras(palavra) values ('diligencies');
 insert into palavras(palavra) values ('diminuam');
 insert into palavras(palavra) values ('diminuiria');
 insert into palavras(palavra) values ('diminuira');
 insert into palavras(palavra) values ('diminuidos');
 insert into palavras(palavra) values ('diminuisse');
 insert into palavras(palavra) values ('dinamita');
 insert into palavras(palavra) values ('dinamitaveis');
 insert into palavras(palavra) values ('diplomado');
 insert into palavras(palavra) values ('diplomaram');
 insert into palavras(palavra) values ('direcionado');
 insert into palavras(palavra) values ('diretivo');
 insert into palavras(palavra) values ('dirigiamos');
 insert into palavras(palavra) values ('dirimemo');
 insert into palavras(palavra) values ('dirimiam');
 insert into palavras(palavra) values ('dirimirdes');
 insert into palavras(palavra) values ('dirimira');
 insert into palavras(palavra) values ('dirimiamos');
 insert into palavras(palavra) values ('dirimieis');
 insert into palavras(palavra) values ('dirimireis');
 insert into palavras(palavra) values ('discerne');
 insert into palavras(palavra) values ('discerniria');
 insert into palavras(palavra) values ('discernisse');
 insert into palavras(palavra) values ('disciplina');
 insert into palavras(palavra) values ('discorre');
 insert into palavras(palavra) values ('discorreremo');
 insert into palavras(palavra) values ('discorressem');
 insert into palavras(palavra) values ('discorro');
 insert into palavras(palavra) values ('discrimina');
 insert into palavras(palavra) values ('discursaram');
 insert into palavras(palavra) values ('discursastes');
 insert into palavras(palavra) values ('discutirmos');
 insert into palavras(palavra) values ('discutisses');
 insert into palavras(palavra) values ('disfarcando');
 insert into palavras(palavra) values ('disfarcassem');
 insert into palavras(palavra) values ('disparavas');
 insert into palavras(palavra) values ('dispararamos');
 insert into palavras(palavra) values ('dispensario');
 insert into palavras(palavra) values ('dispersavas');
 insert into palavras(palavra) values ('disporias');
 insert into palavras(palavra) values ('disputavel');
 insert into palavras(palavra) values ('dissertamo');
 insert into palavras(palavra) values ('dissertarem');
 insert into palavras(palavra) values ('dissertasses');
 insert into palavras(palavra) values ('dissimulem');
 insert into palavras(palavra) values ('dissociam');
 insert into palavras(palavra) values ('dissociando');
 insert into palavras(palavra) values ('dissociares');
 insert into palavras(palavra) values ('dissociarmos');
 insert into palavras(palavra) values ('dissolveu');
 insert into palavras(palavra) values ('dissuadais');
 insert into palavras(palavra) values ('dissuadamos');
 insert into palavras(palavra) values ('dissuadia');
 insert into palavras(palavra) values ('distanciai');
 insert into palavras(palavra) values ('distanciamo');
 insert into palavras(palavra) values ('distanciaras');
 insert into palavras(palavra) values ('distasse');
 insert into palavras(palavra) values ('distendendo');
 insert into palavras(palavra) values ('distenderas');
 insert into palavras(palavra) values ('distendermos');
 insert into palavras(palavra) values ('distingua');
 insert into palavras(palavra) values ('distinguiras');
 insert into palavras(palavra) values ('distinta');
 insert into palavras(palavra) values ('distinto');
 insert into palavras(palavra) values ('distorceras');
 insert into palavras(palavra) values ('distorcereis');
 insert into palavras(palavra) values ('distareis');
 insert into palavras(palavra) values ('ditadora');
 insert into palavras(palavra) values ('ditasseis');
 insert into palavras(palavra) values ('divagava');
 insert into palavras(palavra) values ('divertes');
 insert into palavras(palavra) values ('divertistes');
 insert into palavras(palavra) values ('dividimo');
 insert into palavras(palavra) values ('divinize');
 insert into palavras(palavra) values ('divinizes');
 insert into palavras(palavra) values ('divisarmos');
 insert into palavras(palavra) values ('divisara');
 insert into palavras(palavra) values ('divisemo');
 insert into palavras(palavra) values ('divulgados');
 insert into palavras(palavra) values ('divulgarei');
 insert into palavras(palavra) values ('divulgasses');
 insert into palavras(palavra) values ('dizimareis');
 insert into palavras(palavra) values ('dogmatizaram');
 insert into palavras(palavra) values ('dogmatizares');
 insert into palavras(palavra) values ('dogmatica');
 insert into palavras(palavra) values ('domarieis');
 insert into palavras(palavra) values ('doparias');
 insert into palavras(palavra) values ('dormitasses');
 insert into palavras(palavra) values ('dormitava');
 insert into palavras(palavra) values ('dotavamos');
 insert into palavras(palavra) values ('doutorasse');
 insert into palavras(palavra) values ('doutrina');
 insert into palavras(palavra) values ('doutrinacao');
 insert into palavras(palavra) values ('doutrinacoes');
 insert into palavras(palavra) values ('dramatizar');
 insert into palavras(palavra) values ('dramatizacao');
 insert into palavras(palavra) values ('dramaturgias');
 insert into palavras(palavra) values ('drenastes');
 insert into palavras(palavra) values ('drenavam');
 insert into palavras(palavra) values ('drenavamos');
 insert into palavras(palavra) values ('drogariam');
 insert into palavras(palavra) values ('droguemo');
 insert into palavras(palavra) values ('dublastes');
 insert into palavras(palavra) values ('dulcificamo');
 insert into palavras(palavra) values ('dulcifico');
 insert into palavras(palavra) values ('durarmos');
 insert into palavras(palavra) values ('durasses');
 insert into palavras(palavra) values ('eclipses');
 insert into palavras(palavra) values ('ecoarieis');
 insert into palavras(palavra) values ('economizaste');
 insert into palavras(palavra) values ('edemaciara');
 insert into palavras(palavra) values ('edificarmo');
 insert into palavras(palavra) values ('edificasses');
 insert into palavras(palavra) values ('editaste');
 insert into palavras(palavra) values ('editorasse');
 insert into palavras(palavra) values ('efeminai');
 insert into palavras(palavra) values ('efeminasseis');
 insert into palavras(palavra) values ('efetivado');
 insert into palavras(palavra) values ('efetivarieis');
 insert into palavras(palavra) values ('efetivem');
 insert into palavras(palavra) values ('efetivasseis');
 insert into palavras(palavra) values ('efetuarias');
 insert into palavras(palavra) values ('eflorescas');
 insert into palavras(palavra) values ('elaboraveis');
 insert into palavras(palavra) values ('elefanta');
 insert into palavras(palavra) values ('elegantes');
 insert into palavras(palavra) values ('eleitora');
 insert into palavras(palavra) values ('eletrificam');
 insert into palavras(palavra) values ('eletrizando');
 insert into palavras(palavra) values ('eletrizar');
 insert into palavras(palavra) values ('eletrocuto');
 insert into palavras(palavra) values ('elevassem');
 insert into palavras(palavra) values ('elevaste');
 insert into palavras(palavra) values ('elevacao');
 insert into palavras(palavra) values ('elevavamos');
 insert into palavras(palavra) values ('eliminaramos');
 insert into palavras(palavra) values ('elixiram');
 insert into palavras(palavra) values ('elixirao');
 insert into palavras(palavra) values ('elogiamo');
 insert into palavras(palavra) values ('elucidaria');
 insert into palavras(palavra) values ('elucidassem');
 insert into palavras(palavra) values ('elipticos');
 insert into palavras(palavra) values ('emagrecestes');
 insert into palavras(palavra) values ('emanarem');
 insert into palavras(palavra) values ('emanarieis');
 insert into palavras(palavra) values ('emanasses');
 insert into palavras(palavra) values ('emanemos');
 insert into palavras(palavra) values ('emanareis');
 insert into palavras(palavra) values ('embainhavam');
 insert into palavras(palavra) values ('embaracam');
 insert into palavras(palavra) values ('embaracarmo');
 insert into palavras(palavra) values ('embarcais');
 insert into palavras(palavra) values ('embarcaras');
 insert into palavras(palavra) values ('embarcareis');
 insert into palavras(palavra) values ('embarcavamos');
 insert into palavras(palavra) values ('embargastes');
 insert into palavras(palavra) values ('embarqueis');
 insert into palavras(palavra) values ('embarrique');
 insert into palavras(palavra) values ('embatera');
 insert into palavras(palavra) values ('embatestes');
 insert into palavras(palavra) values ('embacais');
 insert into palavras(palavra) values ('embevecereis');
 insert into palavras(palavra) values ('embeveceres');
 insert into palavras(palavra) values ('embolavam');
 insert into palavras(palavra) values ('embolsas');
 insert into palavras(palavra) values ('embolsasseis');
 insert into palavras(palavra) values ('embolsavamos');
 insert into palavras(palavra) values ('embonecavam');
 insert into palavras(palavra) values ('embonequeis');
 insert into palavras(palavra) values ('emboscadas');
 insert into palavras(palavra) values ('emboscaste');
 insert into palavras(palavra) values ('embotaras');
 insert into palavras(palavra) values ('embotavam');
 insert into palavras(palavra) values ('embranquecei');
 insert into palavras(palavra) values ('embravecida');
 insert into palavras(palavra) values ('embrenhado');
 insert into palavras(palavra) values ('embrenhamo');
 insert into palavras(palavra) values ('embriagaras');
 insert into palavras(palavra) values ('embriaguem');
 insert into palavras(palavra) values ('embromassem');
 insert into palavras(palavra) values ('emburraram');
 insert into palavras(palavra) values ('emburravamos');
 insert into palavras(palavra) values ('emendaremos');
 insert into palavras(palavra) values ('emendassem');
 insert into palavras(palavra) values ('emergissem');
 insert into palavras(palavra) values ('emigrara');
 insert into palavras(palavra) values ('emigrarmo');
 insert into palavras(palavra) values ('emigrariamos');
 insert into palavras(palavra) values ('emitirmo');
 insert into palavras(palavra) values ('emocioneis');
 insert into palavras(palavra) values ('emociones');
 insert into palavras(palavra) values ('emocionou');
 insert into palavras(palavra) values ('emoldurar');
 insert into palavras(palavra) values ('emolduro');
 insert into palavras(palavra) values ('empacotar');
 insert into palavras(palavra) values ('empalhadas');
 insert into palavras(palavra) values ('empalideces');
 insert into palavras(palavra) values ('empanturrara');
 insert into palavras(palavra) values ('empanturrava');
 insert into palavras(palavra) values ('empanturreis');
 insert into palavras(palavra) values ('empaqueis');
 insert into palavras(palavra) values ('empaquemo');
 insert into palavras(palavra) values ('emparedaras');
 insert into palavras(palavra) values ('empastelem');
 insert into palavras(palavra) values ('empastela');
 insert into palavras(palavra) values ('empedernira');
 insert into palavras(palavra) values ('empenarmos');
 insert into palavras(palavra) values ('empenhara');
 insert into palavras(palavra) values ('empertigarem');
 insert into palavras(palavra) values ('empesteado');
 insert into palavras(palavra) values ('empilharemos');
 insert into palavras(palavra) values ('empilhes');
 insert into palavras(palavra) values ('empipocareis');
 insert into palavras(palavra) values ('empipoquei');
 insert into palavras(palavra) values ('emplacaria');
 insert into palavras(palavra) values ('emplacaramos');
 insert into palavras(palavra) values ('emplastrais');
 insert into palavras(palavra) values ('emplastrarem');
 insert into palavras(palavra) values ('emplumardes');
 insert into palavras(palavra) values ('emplumaremo');
 insert into palavras(palavra) values ('empobrecendo');
 insert into palavras(palavra) values ('empobreceres');
 insert into palavras(palavra) values ('empolemos');
 insert into palavras(palavra) values ('empocariam');
 insert into palavras(palavra) values ('empocavam');
 insert into palavras(palavra) values ('empreenderei');
 insert into palavras(palavra) values ('empreendias');
 insert into palavras(palavra) values ('empregadoras');
 insert into palavras(palavra) values ('emprestaras');
 insert into palavras(palavra) values ('emprestem');
 insert into palavras(palavra) values ('empurrarem');
 insert into palavras(palavra) values ('empurres');
 insert into palavras(palavra) values ('emulardes');
 insert into palavras(palavra) values ('emularei');
 insert into palavras(palavra) values ('emulassemos');
 insert into palavras(palavra) values ('enaltecera');
 insert into palavras(palavra) values ('enamoramos');
 insert into palavras(palavra) values ('enamoraremo');
 insert into palavras(palavra) values ('enamorou');
 insert into palavras(palavra) values ('encabelarem');
 insert into palavras(palavra) values ('encabecarmo');
 insert into palavras(palavra) values ('encadernai');
 insert into palavras(palavra) values ('encafifarmos');
 insert into palavras(palavra) values ('encaixariam');
 insert into palavras(palavra) values ('encaixavam');
 insert into palavras(palavra) values ('encalharao');
 insert into palavras(palavra) values ('encaminhemo');
 insert into palavras(palavra) values ('encamparei');
 insert into palavras(palavra) values ('encampareis');
 insert into palavras(palavra) values ('encantavam');
 insert into palavras(palavra) values ('encaparas');
 insert into palavras(palavra) values ('encapsulada');
 insert into palavras(palavra) values ('encapsulo');
 insert into palavras(palavra) values ('encapuzardes');
 insert into palavras(palavra) values ('encapuzaras');
 insert into palavras(palavra) values ('encararas');
 insert into palavras(palavra) values ('encareca');
 insert into palavras(palavra) values ('encarregares');
 insert into palavras(palavra) values ('encarreguei');
 insert into palavras(palavra) values ('encararamos');
 insert into palavras(palavra) values ('encarasseis');
 insert into palavras(palavra) values ('encastelarem');
 insert into palavras(palavra) values ('encastele');
 insert into palavras(palavra) values ('encastelem');
 insert into palavras(palavra) values ('encasulado');
 insert into palavras(palavra) values ('encefalicos');
 insert into palavras(palavra) values ('encenaras');
 insert into palavras(palavra) values ('encerariamos');
 insert into palavras(palavra) values ('encerrai');
 insert into palavras(palavra) values ('encerrou');
 insert into palavras(palavra) values ('encharcara');
 insert into palavras(palavra) values ('encharcareis');
 insert into palavras(palavra) values ('enchourices');
 insert into palavras(palavra) values ('enchouricara');
 insert into palavras(palavra) values ('encimada');
 insert into palavras(palavra) values ('encobristes');
 insert into palavras(palavra) values ('encolheremo');
 insert into palavras(palavra) values ('encontrei');
 insert into palavras(palavra) values ('encorajam');
 insert into palavras(palavra) values ('encorajaras');
 insert into palavras(palavra) values ('encorajaste');
 insert into palavras(palavra) values ('encostasses');
 insert into palavras(palavra) values ('encostavas');
 insert into palavras(palavra) values ('encosteis');
 insert into palavras(palavra) values ('encravara');
 insert into palavras(palavra) values ('encravaremos');
 insert into palavras(palavra) values ('encravasseis');
 insert into palavras(palavra) values ('encrenquemos');
 insert into palavras(palavra) values ('encrespavam');
 insert into palavras(palavra) values ('encrespe');
 insert into palavras(palavra) values ('encubarei');
 insert into palavras(palavra) values ('encubaveis');
 insert into palavras(palavra) values ('encurralaria');
 insert into palavras(palavra) values ('enderecareis');
 insert into palavras(palavra) values ('enderecares');
 insert into palavras(palavra) values ('enderecasse');
 insert into palavras(palavra) values ('endeusarao');
 insert into palavras(palavra) values ('endeusastes');
 insert into palavras(palavra) values ('endeuseis');
 insert into palavras(palavra) values ('endeusaveis');
 insert into palavras(palavra) values ('endivido');
 insert into palavras(palavra) values ('endoidecamo');
 insert into palavras(palavra) values ('endossai');
 insert into palavras(palavra) values ('endossardes');
 insert into palavras(palavra) values ('endossarem');
 insert into palavras(palavra) values ('endossou');
 insert into palavras(palavra) values ('endurecermos');
 insert into palavras(palavra) values ('endemicos');
 insert into palavras(palavra) values ('enervados');
 insert into palavras(palavra) values ('enervasse');
 insert into palavras(palavra) values ('enervava');
 insert into palavras(palavra) values ('enevoavamos');
 insert into palavras(palavra) values ('enfaixou');
 insert into palavras(palavra) values ('enfardara');
 insert into palavras(palavra) values ('enfartas');
 insert into palavras(palavra) values ('enfartes');
 insert into palavras(palavra) values ('enfatizam');
 insert into palavras(palavra) values ('enfatizarmo');
 insert into palavras(palavra) values ('enfatizem');
 insert into palavras(palavra) values ('enfeiadas');
 insert into palavras(palavra) values ('enfeitemos');
 insert into palavras(palavra) values ('enfeixamo');
 insert into palavras(palavra) values ('enfermagem');
 insert into palavras(palavra) values ('enfermarias');
 insert into palavras(palavra) values ('enferrujamo');
 insert into palavras(palavra) values ('enferrujamos');
 insert into palavras(palavra) values ('enferrujarmo');
 insert into palavras(palavra) values ('enferrujes');
 insert into palavras(palavra) values ('enfezadas');
 insert into palavras(palavra) values ('enfezando');
 insert into palavras(palavra) values ('enfezarei');
 insert into palavras(palavra) values ('enfiasses');
 insert into palavras(palavra) values ('enfocando');
 insert into palavras(palavra) values ('enfocassem');
 insert into palavras(palavra) values ('enfocaveis');
 insert into palavras(palavra) values ('enforcara');
 insert into palavras(palavra) values ('enforquemos');
 insert into palavras(palavra) values ('enfurecerias');
 insert into palavras(palavra) values ('engabelaram');
 insert into palavras(palavra) values ('engaiolareis');
 insert into palavras(palavra) values ('engajemos');
 insert into palavras(palavra) values ('engalana');
 insert into palavras(palavra) values ('engalanemos');
 insert into palavras(palavra) values ('engambelemo');
 insert into palavras(palavra) values ('engambelemos');
 insert into palavras(palavra) values ('enganchamo');
 insert into palavras(palavra) values ('enganchasses');
 insert into palavras(palavra) values ('enganchaste');
 insert into palavras(palavra) values ('enganchastes');
 insert into palavras(palavra) values ('engarrafara');
 insert into palavras(palavra) values ('engarupasses');
 insert into palavras(palavra) values ('engastara');
 insert into palavras(palavra) values ('engastaremo');
 insert into palavras(palavra) values ('engatilhadas');
 insert into palavras(palavra) values ('engatilheis');
 insert into palavras(palavra) values ('engatinhava');
 insert into palavras(palavra) values ('engatinhe');
 insert into palavras(palavra) values ('engavetardes');
 insert into palavras(palavra) values ('engavetou');
 insert into palavras(palavra) values ('engendrai');
 insert into palavras(palavra) values ('engendrara');
 insert into palavras(palavra) values ('engendravam');
 insert into palavras(palavra) values ('engenharia');
 insert into palavras(palavra) values ('engessado');
 insert into palavras(palavra) values ('engessar');
 insert into palavras(palavra) values ('engoliras');
 insert into palavras(palavra) values ('engomando');
 insert into palavras(palavra) values ('engomaremos');
 insert into palavras(palavra) values ('engordureis');
 insert into palavras(palavra) values ('engrandeco');
 insert into palavras(palavra) values ('engraxais');
 insert into palavras(palavra) values ('engracarmo');
 insert into palavras(palavra) values ('engrenarmo');
 insert into palavras(palavra) values ('enguiceis');
 insert into palavras(palavra) values ('engulira');
 insert into palavras(palavra) values ('enigmatico');
 insert into palavras(palavra) values ('enjaulares');
 insert into palavras(palavra) values ('enjaulavamos');
 insert into palavras(palavra) values ('enlameasse');
 insert into palavras(palavra) values ('enlameastes');
 insert into palavras(palavra) values ('enlatamos');
 insert into palavras(palavra) values ('enlatardes');
 insert into palavras(palavra) values ('enlacarias');
 insert into palavras(palavra) values ('enlouquecera');
 insert into palavras(palavra) values ('enlouquecia');
 insert into palavras(palavra) values ('enlouqueciam');
 insert into palavras(palavra) values ('enobrecamos');
 insert into palavras(palavra) values ('enojavam');
 insert into palavras(palavra) values ('enojaveis');
 insert into palavras(palavra) values ('enquadrarmo');
 insert into palavras(palavra) values ('enrabicha');
 insert into palavras(palavra) values ('enrabicham');
 insert into palavras(palavra) values ('enraivecermo');
 insert into palavras(palavra) values ('enregeladas');
 insert into palavras(palavra) values ('enregelam');
 insert into palavras(palavra) values ('enregelei');
 insert into palavras(palavra) values ('enriqueceis');
 insert into palavras(palavra) values ('enriquecerei');
 insert into palavras(palavra) values ('enrolais');
 insert into palavras(palavra) values ('enroscam');
 insert into palavras(palavra) values ('enroscaremo');
 insert into palavras(palavra) values ('enroscaste');
 insert into palavras(palavra) values ('enrubesceram');
 insert into palavras(palavra) values ('enrubesceria');
 insert into palavras(palavra) values ('enrugasseis');
 insert into palavras(palavra) values ('ensaboaveis');
 insert into palavras(palavra) values ('ensacados');
 insert into palavras(palavra) values ('ensacaram');
 insert into palavras(palavra) values ('ensacaremo');
 insert into palavras(palavra) values ('ensacarao');
 insert into palavras(palavra) values ('ensaiaste');
 insert into palavras(palavra) values ('ensaquem');
 insert into palavras(palavra) values ('ensaista');
 insert into palavras(palavra) values ('ensinassem');
 insert into palavras(palavra) values ('ensopariam');
 insert into palavras(palavra) values ('ensoparieis');
 insert into palavras(palavra) values ('ensopeis');
 insert into palavras(palavra) values ('entabules');
 insert into palavras(palavra) values ('entalhai');
 insert into palavras(palavra) values ('entalhamo');
 insert into palavras(palavra) values ('entalhes');
 insert into palavras(palavra) values ('entendamo');
 insert into palavras(palavra) values ('entenderao');
 insert into palavras(palavra) values ('enterradas');
 insert into palavras(palavra) values ('enterrareis');
 insert into palavras(palavra) values ('enterrarem');
 insert into palavras(palavra) values ('entoaste');
 insert into palavras(palavra) values ('entorpeceste');
 insert into palavras(palavra) values ('entortados');
 insert into palavras(palavra) values ('entortais');
 insert into palavras(palavra) values ('entranhassem');
 insert into palavras(palavra) values ('entravei');
 insert into palavras(palavra) values ('entravasseis');
 insert into palavras(palavra) values ('entreabriam');
 insert into palavras(palavra) values ('entrecruza');
 insert into palavras(palavra) values ('entregando');
 insert into palavras(palavra) values ('entrelacamo');
 insert into palavras(palavra) values ('entrelacaste');
 insert into palavras(palavra) values ('entreouvira');
 insert into palavras(palavra) values ('entreouviram');
 insert into palavras(palavra) values ('entretecemos');
 insert into palavras(palavra) values ('entretecam');
 insert into palavras(palavra) values ('entrevedes');
 insert into palavras(palavra) values ('entrevejas');
 insert into palavras(palavra) values ('entroncara');
 insert into palavras(palavra) values ('entroncaras');
 insert into palavras(palavra) values ('entronizarem');
 insert into palavras(palavra) values ('entrosaste');
 insert into palavras(palavra) values ('entravamos');
 insert into palavras(palavra) values ('entumescermo');
 insert into palavras(palavra) values ('entupireis');
 insert into palavras(palavra) values ('enumeracao');
 insert into palavras(palavra) values ('enunciaste');
 insert into palavras(palavra) values ('envelhecida');
 insert into palavras(palavra) values ('envelhecido');
 insert into palavras(palavra) values ('envelheca');
 insert into palavras(palavra) values ('envenenarei');
 insert into palavras(palavra) values ('envenenou');
 insert into palavras(palavra) values ('enveredam');
 insert into palavras(palavra) values ('enveredeis');
 insert into palavras(palavra) values ('envergadura');
 insert into palavras(palavra) values ('enverniza');
 insert into palavras(palavra) values ('envernizaram');
 insert into palavras(palavra) values ('envernizem');
 insert into palavras(palavra) values ('enviarmos');
 insert into palavras(palavra) values ('envidraces');
 insert into palavras(palavra) values ('enviemos');
 insert into palavras(palavra) values ('enviesar');
 insert into palavras(palavra) values ('envileceis');
 insert into palavras(palavra) values ('envilecia');
 insert into palavras(palavra) values ('envolveres');
 insert into palavras(palavra) values ('envolveramos');
 insert into palavras(palavra) values ('enxaguaras');
 insert into palavras(palavra) values ('enxamearias');
 insert into palavras(palavra) values ('enxamearieis');
 insert into palavras(palavra) values ('enxertaram');
 insert into palavras(palavra) values ('enxertaremo');
 insert into palavras(palavra) values ('enxertaste');
 insert into palavras(palavra) values ('enxotareis');
 insert into palavras(palavra) values ('enxotasseis');
 insert into palavras(palavra) values ('enxugares');
 insert into palavras(palavra) values ('epidemias');
 insert into palavras(palavra) values ('epistolarias');
 insert into palavras(palavra) values ('epitafios');
 insert into palavras(palavra) values ('equacionando');
 insert into palavras(palavra) values ('equilibravam');
 insert into palavras(palavra) values ('equilibrio');
 insert into palavras(palavra) values ('equiparastes');
 insert into palavras(palavra) values ('equipariamos');
 insert into palavras(palavra) values ('equipeis');
 insert into palavras(palavra) values ('equipemo');
 insert into palavras(palavra) values ('equivaleste');
 insert into palavras(palavra) values ('equivalhamos');
 insert into palavras(palavra) values ('equivalhas');
 insert into palavras(palavra) values ('equivalia');
 insert into palavras(palavra) values ('equivocados');
 insert into palavras(palavra) values ('equivoque');
 insert into palavras(palavra) values ('equidistais');
 insert into palavras(palavra) values ('equidistasse');
 insert into palavras(palavra) values ('erguendo');
 insert into palavras(palavra) values ('ergueriamos');
 insert into palavras(palavra) values ('erigirias');
 insert into palavras(palavra) values ('erradicara');
 insert into palavras(palavra) values ('erraticas');
 insert into palavras(palavra) values ('esbaforistes');
 insert into palavras(palavra) values ('esbanjamento');
 insert into palavras(palavra) values ('esbanjaras');
 insert into palavras(palavra) values ('esbarrarem');
 insert into palavras(palavra) values ('esbarrarmo');
 insert into palavras(palavra) values ('esbarrem');
 insert into palavras(palavra) values ('esbofetearas');
 insert into palavras(palavra) values ('esbocareis');
 insert into palavras(palavra) values ('esbocassem');
 insert into palavras(palavra) values ('esbranquica');
 insert into palavras(palavra) values ('esbugalhavam');
 insert into palavras(palavra) values ('esbugalho');
 insert into palavras(palavra) values ('esburaqueis');
 insert into palavras(palavra) values ('escalarias');
 insert into palavras(palavra) values ('escaldarias');
 insert into palavras(palavra) values ('escaldeis');
 insert into palavras(palavra) values ('escaleis');
 insert into palavras(palavra) values ('escalonarmos');
 insert into palavras(palavra) values ('escalpelavam');
 insert into palavras(palavra) values ('escancara');
 insert into palavras(palavra) values ('escangalhara');
 insert into palavras(palavra) values ('escangalhou');
 insert into palavras(palavra) values ('escanhoam');
 insert into palavras(palavra) values ('escanhoaste');
 insert into palavras(palavra) values ('escapulis');
 insert into palavras(palavra) values ('escapareis');
 insert into palavras(palavra) values ('escapassemos');
 insert into palavras(palavra) values ('escarravam');
 insert into palavras(palavra) values ('escasseara');
 insert into palavras(palavra) values ('escassez');
 insert into palavras(palavra) values ('escaveis');
 insert into palavras(palavra) values ('esclareceu');
 insert into palavras(palavra) values ('escolada');
 insert into palavras(palavra) values ('escoltaremo');
 insert into palavras(palavra) values ('escombro');
 insert into palavras(palavra) values ('esconderiam');
 insert into palavras(palavra) values ('escondestes');
 insert into palavras(palavra) values ('escondiam');
 insert into palavras(palavra) values ('escondesseis');
 insert into palavras(palavra) values ('esconjurais');
 insert into palavras(palavra) values ('esconjurava');
 insert into palavras(palavra) values ('escoriamo');
 insert into palavras(palavra) values ('escories');
 insert into palavras(palavra) values ('escorrereis');
 insert into palavras(palavra) values ('escravizaria');
 insert into palavras(palavra) values ('escravizavam');
 insert into palavras(palavra) values ('escravizou');
 insert into palavras(palavra) values ('escreveremo');
 insert into palavras(palavra) values ('escriturarei');
 insert into palavras(palavra) values ('escrutinarao');
 insert into palavras(palavra) values ('escrutinemos');
 insert into palavras(palavra) values ('esculhamba');
 insert into palavras(palavra) values ('esculpirem');
 insert into palavras(palavra) values ('escurecida');
 insert into palavras(palavra) values ('escusara');
 insert into palavras(palavra) values ('escusaremo');
 insert into palavras(palavra) values ('escutais');
 insert into palavras(palavra) values ('esfacelavam');
 insert into palavras(palavra) values ('esfaquea');
 insert into palavras(palavra) values ('esfarelamo');
 insert into palavras(palavra) values ('esfarelemos');
 insert into palavras(palavra) values ('esfarrapara');
 insert into palavras(palavra) values ('esfarrape');
 insert into palavras(palavra) values ('esfiapadas');
 insert into palavras(palavra) values ('esfolardes');
 insert into palavras(palavra) values ('esfomeou');
 insert into palavras(palavra) values ('esforcado');
 insert into palavras(palavra) values ('esforcaras');
 insert into palavras(palavra) values ('esforcava');
 insert into palavras(palavra) values ('esfregada');
 insert into palavras(palavra) values ('esfriaras');
 insert into palavras(palavra) values ('esganarias');
 insert into palavras(palavra) values ('esganarao');
 insert into palavras(palavra) values ('esganavas');
 insert into palavras(palavra) values ('esgotavam');
 insert into palavras(palavra) values ('esgotavas');
 insert into palavras(palavra) values ('esguicharam');
 insert into palavras(palavra) values ('eslovenos');
 insert into palavras(palavra) values ('esmagariamos');
 insert into palavras(palavra) values ('esmaltaram');
 insert into palavras(palavra) values ('esmeraria');
 insert into palavras(palavra) values ('esmigalhares');
 insert into palavras(palavra) values ('esmiuces');
 insert into palavras(palavra) values ('esmurram');
 insert into palavras(palavra) values ('esnobarmos');
 insert into palavras(palavra) values ('esnobaste');
 insert into palavras(palavra) values ('espaireceram');
 insert into palavras(palavra) values ('espaireceria');
 insert into palavras(palavra) values ('espaireces');
 insert into palavras(palavra) values ('espaireceu');
 insert into palavras(palavra) values ('espalmamos');
 insert into palavras(palavra) values ('espalmaremo');
 insert into palavras(palavra) values ('espancaram');
 insert into palavras(palavra) values ('espancou');
 insert into palavras(palavra) values ('espancavamos');
 insert into palavras(palavra) values ('espantarias');
 insert into palavras(palavra) values ('espantara');
 insert into palavras(palavra) values ('espargira');
 insert into palavras(palavra) values ('esparjamo');
 insert into palavras(palavra) values ('esparzira');
 insert into palavras(palavra) values ('espatifara');
 insert into palavras(palavra) values ('espacando');
 insert into palavras(palavra) values ('especiais');
 insert into palavras(palavra) values ('espectros');
 insert into palavras(palavra) values ('especularem');
 insert into palavras(palavra) values ('especulasse');
 insert into palavras(palavra) values ('especulasses');
 insert into palavras(palavra) values ('especifico');
 insert into palavras(palavra) values ('esperais');
 insert into palavras(palavra) values ('esperarei');
 insert into palavras(palavra) values ('esperaremos');
 insert into palavras(palavra) values ('espetariam');
 insert into palavras(palavra) values ('espetara');
 insert into palavras(palavra) values ('espezinhando');
 insert into palavras(palavra) values ('espiardes');
 insert into palavras(palavra) values ('espichando');
 insert into palavras(palavra) values ('espichar');
 insert into palavras(palavra) values ('espigados');
 insert into palavras(palavra) values ('espinafrar');
 insert into palavras(palavra) values ('espinafraras');
 insert into palavras(palavra) values ('espiralada');
 insert into palavras(palavra) values ('espirituoso');
 insert into palavras(palavra) values ('espirassemos');
 insert into palavras(palavra) values ('esporaremos');
 insert into palavras(palavra) values ('esporeava');
 insert into palavras(palavra) values ('espraiarei');
 insert into palavras(palavra) values ('espraiaremo');
 insert into palavras(palavra) values ('espreitarmo');
 insert into palavras(palavra) values ('espremia');
 insert into palavras(palavra) values ('espumejei');
 insert into palavras(palavra) values ('esquadro');
 insert into palavras(palavra) values ('esquecerao');
 insert into palavras(palavra) values ('esquecestes');
 insert into palavras(palavra) values ('esquentei');
 insert into palavras(palavra) values ('esqualida');
 insert into palavras(palavra) values ('estabeleciam');
 insert into palavras(palavra) values ('estabelecido');
 insert into palavras(palavra) values ('estabilize');
 insert into palavras(palavra) values ('estacionaram');
 insert into palavras(palavra) values ('estacavamos');
 insert into palavras(palavra) values ('estafarieis');
 insert into palavras(palavra) values ('estagiarem');
 insert into palavras(palavra) values ('estagiarmos');
 insert into palavras(palavra) values ('estagias');
 insert into palavras(palavra) values ('estalamo');
 insert into palavras(palavra) values ('estalariam');
 insert into palavras(palavra) values ('estamparei');
 insert into palavras(palavra) values ('estamparamos');
 insert into palavras(palavra) values ('estanharias');
 insert into palavras(palavra) values ('estanhemo');
 insert into palavras(palavra) values ('estatelassem');
 insert into palavras(palavra) values ('estatizamo');
 insert into palavras(palavra) values ('estatizas');
 insert into palavras(palavra) values ('estatizemo');
 insert into palavras(palavra) values ('estatutarias');
 insert into palavras(palavra) values ('estelionato');
 insert into palavras(palavra) values ('estenderam');
 insert into palavras(palavra) values ('estercaram');
 insert into palavras(palavra) values ('esterilizada');
 insert into palavras(palavra) values ('estiagens');
 insert into palavras(palavra) values ('esticareis');
 insert into palavras(palavra) values ('estigmatiza');
 insert into palavras(palavra) values ('estilizar');
 insert into palavras(palavra) values ('estilisticas');
 insert into palavras(palavra) values ('estimulemos');
 insert into palavras(palavra) values ('estimavamos');
 insert into palavras(palavra) values ('estiolem');
 insert into palavras(palavra) values ('estipulavas');
 insert into palavras(palavra) values ('estiramento');
 insert into palavras(palavra) values ('estiverem');
 insert into palavras(palavra) values ('estofamos');
 insert into palavras(palavra) values ('estofando');
 insert into palavras(palavra) values ('estornes');
 insert into palavras(palavra) values ('estorvamos');
 insert into palavras(palavra) values ('estorvavas');
 insert into palavras(palavra) values ('estorvem');
 insert into palavras(palavra) values ('estourasses');
 insert into palavras(palavra) values ('estrados');
 insert into palavras(palavra) values ('estragaram');
 insert into palavras(palavra) values ('estralaramos');
 insert into palavras(palavra) values ('estranhardes');
 insert into palavras(palavra) values ('estranharia');
 insert into palavras(palavra) values ('estranhariam');
 insert into palavras(palavra) values ('estreiem');
 insert into palavras(palavra) values ('estreiteza');
 insert into palavras(palavra) values ('estreitaveis');
 insert into palavras(palavra) values ('estremecera');
 insert into palavras(palavra) values ('estremecesse');
 insert into palavras(palavra) values ('estrepai');
 insert into palavras(palavra) values ('estrepara');
 insert into palavras(palavra) values ('estrepasses');
 insert into palavras(palavra) values ('estrepitaras');
 insert into palavras(palavra) values ('estressei');
 insert into palavras(palavra) values ('estribasses');
 insert into palavras(palavra) values ('estribes');
 insert into palavras(palavra) values ('estribaramos');
 insert into palavras(palavra) values ('estrilasse');
 insert into palavras(palavra) values ('estritos');
 insert into palavras(palavra) values ('estropiares');
 insert into palavras(palavra) values ('estrutura');
 insert into palavras(palavra) values ('estufarao');
 insert into palavras(palavra) values ('estupidifica');
 insert into palavras(palavra) values ('estuprado');
 insert into palavras(palavra) values ('estuprardes');
 insert into palavras(palavra) values ('estuprarao');
 insert into palavras(palavra) values ('estuprarieis');
 insert into palavras(palavra) values ('esturricamos');
 insert into palavras(palavra) values ('esturricaras');
 insert into palavras(palavra) values ('esvanecerei');
 insert into palavras(palavra) values ('esvanecessem');
 insert into palavras(palavra) values ('esvaziamos');
 insert into palavras(palavra) values ('esvaziaste');
 insert into palavras(palavra) values ('esvaziemos');
 insert into palavras(palavra) values ('esvaiamos');
 insert into palavras(palavra) values ('esvoacemo');
 insert into palavras(palavra) values ('eternizas');
 insert into palavras(palavra) values ('etimologista');
 insert into palavras(palavra) values ('etiquetares');
 insert into palavras(palavra) values ('eucaristica');
 insert into palavras(palavra) values ('eucaristico');
 insert into palavras(palavra) values ('evacuarem');
 insert into palavras(palavra) values ('evacuarieis');
 insert into palavras(palavra) values ('evadirieis');
 insert into palavras(palavra) values ('evadisses');
 insert into palavras(palavra) values ('evangelista');
 insert into palavras(palavra) values ('evaporassem');
 insert into palavras(palavra) values ('evidencie');
 insert into palavras(palavra) values ('evocarmo');
 insert into palavras(palavra) values ('evocaramos');
 insert into palavras(palavra) values ('evolutivo');
 insert into palavras(palavra) values ('exacerbam');
 insert into palavras(palavra) values ('exacerbe');
 insert into palavras(palavra) values ('exagerais');
 insert into palavras(palavra) values ('exageram');
 insert into palavras(palavra) values ('exageraramos');
 insert into palavras(palavra) values ('exalaras');
 insert into palavras(palavra) values ('exararieis');
 insert into palavras(palavra) values ('exarasse');
 insert into palavras(palavra) values ('exaraveis');
 insert into palavras(palavra) values ('exasperaria');
 insert into palavras(palavra) values ('exauriremos');
 insert into palavras(palavra) values ('excessivos');
 insert into palavras(palavra) values ('excetuamo');
 insert into palavras(palavra) values ('excetuara');
 insert into palavras(palavra) values ('excetuavam');
 insert into palavras(palavra) values ('excitadoras');
 insert into palavras(palavra) values ('excitasses');
 insert into palavras(palavra) values ('exclamativas');
 insert into palavras(palavra) values ('excluidos');
 insert into palavras(palavra) values ('exconjuram');
 insert into palavras(palavra) values ('execrarei');
 insert into palavras(palavra) values ('execraremos');
 insert into palavras(palavra) values ('execravamos');
 insert into palavras(palavra) values ('executavamos');
 insert into palavras(palavra) values ('exemplificou');
 insert into palavras(palavra) values ('exemplareis');
 insert into palavras(palavra) values ('exercitaram');
 insert into palavras(palavra) values ('exercitara');
 insert into palavras(palavra) values ('exercito');
 insert into palavras(palavra) values ('exibamos');
 insert into palavras(palavra) values ('exibieis');
 insert into palavras(palavra) values ('exigirdes');
 insert into palavras(palavra) values ('exigieis');
 insert into palavras(palavra) values ('exilaram');
 insert into palavras(palavra) values ('exilarao');
 insert into palavras(palavra) values ('existirmo');
 insert into palavras(palavra) values ('exoneramo');
 insert into palavras(palavra) values ('exonerarmo');
 insert into palavras(palavra) values ('exorbitando');
 insert into palavras(palavra) values ('exorcizou');
 insert into palavras(palavra) values ('exorcizaveis');
 insert into palavras(palavra) values ('exortado');
 insert into palavras(palavra) values ('exortarmo');
 insert into palavras(palavra) values ('expandindo');
 insert into palavras(palavra) values ('expansivas');
 insert into palavras(palavra) values ('expectorar');
 insert into palavras(palavra) values ('expectorem');
 insert into palavras(palavra) values ('expelais');
 insert into palavras(palavra) values ('experimentou');
 insert into palavras(palavra) values ('expiaste');
 insert into palavras(palavra) values ('expiravas');
 insert into palavras(palavra) values ('explanadas');
 insert into palavras(palavra) values ('explicites');
 insert into palavras(palavra) values ('expliquemos');
 insert into palavras(palavra) values ('explodirao');
 insert into palavras(palavra) values ('exponenciais');
 insert into palavras(palavra) values ('exportava');
 insert into palavras(palavra) values ('expressara');
 insert into palavras(palavra) values ('exprimimos');
 insert into palavras(palavra) values ('expropriaria');
 insert into palavras(palavra) values ('exproprio');
 insert into palavras(palavra) values ('expugnara');
 insert into palavras(palavra) values ('expugnava');
 insert into palavras(palavra) values ('expulsao');
 insert into palavras(palavra) values ('extenuadas');
 insert into palavras(palavra) values ('extenuarei');
 insert into palavras(palavra) values ('exterminais');
 insert into palavras(palavra) values ('exterminarem');
 insert into palavras(palavra) values ('externais');
 insert into palavras(palavra) values ('externarmos');
 insert into palavras(palavra) values ('externara');
 insert into palavras(palavra) values ('externarao');
 insert into palavras(palavra) values ('extinguia');
 insert into palavras(palavra) values ('extorquirei');
 insert into palavras(palavra) values ('extorquirias');
 insert into palavras(palavra) values ('extraditado');
 insert into palavras(palavra) values ('extrairemo');
 insert into palavras(palavra) values ('extrangeira');
 insert into palavras(palavra) values ('extrangeiro');
 insert into palavras(palavra) values ('extrapolamos');
 insert into palavras(palavra) values ('extrapolar');
 insert into palavras(palavra) values ('extrapolara');
 insert into palavras(palavra) values ('extravasarem');
 insert into palavras(palavra) values ('extravasa');
 insert into palavras(palavra) values ('extraviam');
 insert into palavras(palavra) values ('extravias');
 insert into palavras(palavra) values ('extraviava');
 insert into palavras(palavra) values ('extraisseis');
 insert into palavras(palavra) values ('extremariam');
 insert into palavras(palavra) values ('extatica');
 insert into palavras(palavra) values ('exuberareis');
 insert into palavras(palavra) values ('exuberaremos');
 insert into palavras(palavra) values ('exuberassem');
 insert into palavras(palavra) values ('exuberareis');
 insert into palavras(palavra) values ('exultaras');
 insert into palavras(palavra) values ('exultareis');
 insert into palavras(palavra) values ('exultariam');
 insert into palavras(palavra) values ('exultareis');
 insert into palavras(palavra) values ('exultassemos');
 insert into palavras(palavra) values ('exumareis');
 insert into palavras(palavra) values ('exumarias');
 insert into palavras(palavra) values ('exumariamos');
 insert into palavras(palavra) values ('exumareis');
 insert into palavras(palavra) values ('exumasseis');
 insert into palavras(palavra) values ('fabricou');
 insert into palavras(palavra) values ('facilitemo');
 insert into palavras(palavra) values ('facultemos');
 insert into palavras(palavra) values ('faiscadoras');
 insert into palavras(palavra) values ('faiscarao');
 insert into palavras(palavra) values ('faiscassemos');
 insert into palavras(palavra) values ('falarieis');
 insert into palavras(palavra) values ('faleceria');
 insert into palavras(palavra) values ('falecerias');
 insert into palavras(palavra) values ('falirias');
 insert into palavras(palavra) values ('falsificaras');
 insert into palavras(palavra) values ('familiara');
 insert into palavras(palavra) values ('familiariam');
 insert into palavras(palavra) values ('familiarizem');
 insert into palavras(palavra) values ('familiariza');
 insert into palavras(palavra) values ('familiavas');
 insert into palavras(palavra) values ('familiei');
 insert into palavras(palavra) values ('fanatizai');
 insert into palavras(palavra) values ('fanfarreei');
 insert into palavras(palavra) values ('fanfarronam');
 insert into palavras(palavra) values ('fantasiam');
 insert into palavras(palavra) values ('fantasiardes');
 insert into palavras(palavra) values ('fantasiasses');
 insert into palavras(palavra) values ('fantasticas');
 insert into palavras(palavra) values ('fantasticos');
 insert into palavras(palavra) values ('faqueiro');
 insert into palavras(palavra) values ('farejamo');
 insert into palavras(palavra) values ('farejavam');
 insert into palavras(palavra) values ('farinhenta');
 insert into palavras(palavra) values ('faroleiras');
 insert into palavras(palavra) values ('farreassem');
 insert into palavras(palavra) values ('fartaremo');
 insert into palavras(palavra) values ('fartavam');
 insert into palavras(palavra) values ('fascista');
 insert into palavras(palavra) values ('fatalidade');
 insert into palavras(palavra) values ('fatiaram');
 insert into palavras(palavra) values ('favorecerias');
 insert into palavras(palavra) values ('favorecermo');
 insert into palavras(palavra) values ('favorecereis');
 insert into palavras(palavra) values ('favorito');
 insert into palavras(palavra) values ('fecundando');
 insert into palavras(palavra) values ('federais');
 insert into palavras(palavra) values ('felizarda');
 insert into palavras(palavra) values ('fenderao');
 insert into palavras(palavra) values ('fermentada');
 insert into palavras(palavra) values ('fermentarei');
 insert into palavras(palavra) values ('fermentarmos');
 insert into palavras(palavra) values ('ferocissimos');
 insert into palavras(palavra) values ('festejais');
 insert into palavras(palavra) values ('festejares');
 insert into palavras(palavra) values ('festejeis');
 insert into palavras(palavra) values ('festejemo');
 insert into palavras(palavra) values ('fetichistas');
 insert into palavras(palavra) values ('fichariamos');
 insert into palavras(palavra) values ('figurardes');
 insert into palavras(palavra) values ('filipino');
 insert into palavras(palavra) values ('filipinos');
 insert into palavras(palavra) values ('filmamos');
 insert into palavras(palavra) values ('finalizariam');
 insert into palavras(palavra) values ('finalizes');
 insert into palavras(palavra) values ('financeiros');
 insert into palavras(palavra) values ('financiemos');
 insert into palavras(palavra) values ('fincaramos');
 insert into palavras(palavra) values ('findasse');
 insert into palavras(palavra) values ('fingirei');
 insert into palavras(palavra) values ('fingistes');
 insert into palavras(palavra) values ('fintasseis');
 insert into palavras(palavra) values ('firmavas');
 insert into palavras(palavra) values ('firmassemos');
 insert into palavras(palavra) values ('fiscalizacao');
 insert into palavras(palavra) values ('flacidez');
 insert into palavras(palavra) values ('flagelares');
 insert into palavras(palavra) values ('flagrais');
 insert into palavras(palavra) values ('flagrariam');
 insert into palavras(palavra) values ('flamejarei');
 insert into palavras(palavra) values ('flamejes');
 insert into palavras(palavra) values ('flamenga');
 insert into palavras(palavra) values ('flanelas');
 insert into palavras(palavra) values ('flauteou');
 insert into palavras(palavra) values ('flechemo');
 insert into palavras(palavra) values ('flexionasse');
 insert into palavras(palavra) values ('flexionaste');
 insert into palavras(palavra) values ('florearao');
 insert into palavras(palavra) values ('floreies');
 insert into palavras(palavra) values ('florescermo');
 insert into palavras(palavra) values ('floreaveis');
 insert into palavras(palavra) values ('florirmo');
 insert into palavras(palavra) values ('focariamos');
 insert into palavras(palavra) values ('focastes');
 insert into palavras(palavra) values ('fofocariam');
 insert into palavras(palavra) values ('foguetorios');
 insert into palavras(palavra) values ('folgaria');
 insert into palavras(palavra) values ('folgazao');
 insert into palavras(palavra) values ('folheariamos');
 insert into palavras(palavra) values ('folheastes');
 insert into palavras(palavra) values ('foragirei');
 insert into palavras(palavra) values ('forcejaras');
 insert into palavras(palavra) values ('formalidade');
 insert into palavras(palavra) values ('formandas');
 insert into palavras(palavra) values ('formassem');
 insert into palavras(palavra) values ('formataste');
 insert into palavras(palavra) values ('formates');
 insert into palavras(palavra) values ('formatareis');
 insert into palavras(palavra) values ('formigou');
 insert into palavras(palavra) values ('formigue');
 insert into palavras(palavra) values ('formiguinha');
 insert into palavras(palavra) values ('formulariam');
 insert into palavras(palavra) values ('formulemo');
 insert into palavras(palavra) values ('fornalhas');
 insert into palavras(palavra) values ('forneceres');
 insert into palavras(palavra) values ('forneciam');
 insert into palavras(palavra) values ('forniquemos');
 insert into palavras(palavra) values ('forragearias');
 insert into palavras(palavra) values ('forrageias');
 insert into palavras(palavra) values ('forrastes');
 insert into palavras(palavra) values ('fortificaram');
 insert into palavras(palavra) values ('fortuitos');
 insert into palavras(palavra) values ('forcares');
 insert into palavras(palavra) values ('fossilizavas');
 insert into palavras(palavra) values ('fossilize');
 insert into palavras(palavra) values ('fotolito');
 insert into palavras(palavra) values ('fragilidade');
 insert into palavras(palavra) values ('fragorosas');
 insert into palavras(palavra) values ('franzires');
 insert into palavras(palavra) values ('fraquejassem');
 insert into palavras(palavra) values ('frasearei');
 insert into palavras(palavra) values ('frasearem');
 insert into palavras(palavra) values ('fraseariam');
 insert into palavras(palavra) values ('fraseologica');
 insert into palavras(palavra) values ('fraseavamos');
 insert into palavras(palavra) values ('fraturastes');
 insert into palavras(palavra) values ('fraudaram');
 insert into palavras(palavra) values ('fraudarias');
 insert into palavras(palavra) values ('frequentas');
 insert into palavras(palavra) values ('fretarem');
 insert into palavras(palavra) values ('friccionada');
 insert into palavras(palavra) values ('frigirei');
 insert into palavras(palavra) values ('frigiste');
 insert into palavras(palavra) values ('fritavam');
 insert into palavras(palavra) values ('frondosa');
 insert into palavras(palavra) values ('frondosos');
 insert into palavras(palavra) values ('frutuoso');
 insert into palavras(palavra) values ('fulgiras');
 insert into palavras(palavra) values ('fulminais');
 insert into palavras(palavra) values ('fulminaria');
 insert into palavras(palavra) values ('fulminaras');
 insert into palavras(palavra) values ('fumadora');
 insert into palavras(palavra) values ('fumegavamos');
 insert into palavras(palavra) values ('funcionava');
 insert into palavras(palavra) values ('fundacional');
 insert into palavras(palavra) values ('fundamental');
 insert into palavras(palavra) values ('fundamentamo');
 insert into palavras(palavra) values ('fundamentara');
 insert into palavras(palavra) values ('fundando');
 insert into palavras(palavra) values ('fundareis');
 insert into palavras(palavra) values ('fundeara');
 insert into palavras(palavra) values ('fundeiem');
 insert into palavras(palavra) values ('fundiremos');
 insert into palavras(palavra) values ('fundiarias');
 insert into palavras(palavra) values ('fundiarios');
 insert into palavras(palavra) values ('funileiro');
 insert into palavras(palavra) values ('furasseis');
 insert into palavras(palavra) values ('fuxiquemo');
 insert into palavras(palavra) values ('fucardes');
 insert into palavras(palavra) values ('gabariamos');
 insert into palavras(palavra) values ('gaguejado');
 insert into palavras(palavra) values ('galanteando');
 insert into palavras(palavra) values ('galanteio');
 insert into palavras(palavra) values ('galgares');
 insert into palavras(palavra) values ('galinaceas');
 insert into palavras(palavra) values ('galoparam');
 insert into palavras(palavra) values ('galvanizavam');
 insert into palavras(palavra) values ('gandaiai');
 insert into palavras(palavra) values ('gandaiaremos');
 insert into palavras(palavra) values ('gandaiavamos');
 insert into palavras(palavra) values ('gangrenareis');
 insert into palavras(palavra) values ('ganharmos');
 insert into palavras(palavra) values ('ganharamos');
 insert into palavras(palavra) values ('garantidas');
 insert into palavras(palavra) values ('garantirias');
 insert into palavras(palavra) values ('gargalhado');
 insert into palavras(palavra) values ('gargalhardes');
 insert into palavras(palavra) values ('gargalharao');
 insert into palavras(palavra) values ('gargarejarem');
 insert into palavras(palavra) values ('garimpavas');
 insert into palavras(palavra) values ('garimpemos');
 insert into palavras(palavra) values ('garotinhas');
 insert into palavras(palavra) values ('gasometria');
 insert into palavras(palavra) values ('gastares');
 insert into palavras(palavra) values ('gazeteastes');
 insert into palavras(palavra) values ('gazeteavamos');
 insert into palavras(palavra) values ('gelatinosa');
 insert into palavras(palavra) values ('generalizada');
 insert into palavras(palavra) values ('generalizar');
 insert into palavras(palavra) values ('geologico');
 insert into palavras(palavra) values ('gerassem');
 insert into palavras(palavra) values ('gerenciada');
 insert into palavras(palavra) values ('geriatrico');
 insert into palavras(palavra) values ('germinas');
 insert into palavras(palavra) values ('germinemo');
 insert into palavras(palavra) values ('geraramos');
 insert into palavras(palavra) values ('geranios');
 insert into palavras(palavra) values ('gesticularam');
 insert into palavras(palavra) values ('girassois');
 insert into palavras(palavra) values ('glorificacao');
 insert into palavras(palavra) values ('glosaste');
 insert into palavras(palavra) values ('gonorreia');
 insert into palavras(palavra) values ('gordurenta');
 insert into palavras(palavra) values ('gorjeares');
 insert into palavras(palavra) values ('gorjeeis');
 insert into palavras(palavra) values ('gostarao');
 insert into palavras(palavra) values ('gotejardes');
 insert into palavras(palavra) values ('gotejavamos');
 insert into palavras(palavra) values ('governamo');
 insert into palavras(palavra) values ('governaras');
 insert into palavras(palavra) values ('grafarias');
 insert into palavras(palavra) values ('grafasseis');
 insert into palavras(palavra) values ('gravitado');
 insert into palavras(palavra) values ('gravitardes');
 insert into palavras(palavra) values ('gravitaveis');
 insert into palavras(palavra) values ('grevistas');
 insert into palavras(palavra) values ('grifarmos');
 insert into palavras(palavra) values ('grilarieis');
 insert into palavras(palavra) values ('grileiro');
 insert into palavras(palavra) values ('gritariamos');
 insert into palavras(palavra) values ('gritareis');
 insert into palavras(palavra) values ('grudasseis');
 insert into palavras(palavra) values ('grulhareis');
 insert into palavras(palavra) values ('grulhaveis');
 insert into palavras(palavra) values ('guarnecei');
 insert into palavras(palavra) values ('guarneceras');
 insert into palavras(palavra) values ('guarnecerao');
 insert into palavras(palavra) values ('guerreasse');
 insert into palavras(palavra) values ('guerrilheiro');
 insert into palavras(palavra) values ('guilhotinai');
 insert into palavras(palavra) values ('guinchando');
 insert into palavras(palavra) values ('guincharemo');
 insert into palavras(palavra) values ('habilitei');
 insert into palavras(palavra) values ('habilissimo');
 insert into palavras(palavra) values ('habituais');
 insert into palavras(palavra) values ('habituarao');
 insert into palavras(palavra) values ('harmonizar');
 insert into palavras(palavra) values ('hauriras');
 insert into palavras(palavra) values ('havaianas');
 insert into palavras(palavra) values ('havereis');
 insert into palavras(palavra) values ('hemofilico');
 insert into palavras(palavra) values ('hemorragica');
 insert into palavras(palavra) values ('hemorragicos');
 insert into palavras(palavra) values ('herbivoros');
 insert into palavras(palavra) values ('herculeas');
 insert into palavras(palavra) values ('herdadas');
 insert into palavras(palavra) values ('hereditarias');
 insert into palavras(palavra) values ('heraldica');
 insert into palavras(palavra) values ('heterozigoto');
 insert into palavras(palavra) values ('hibernareis');
 insert into palavras(palavra) values ('hibernas');
 insert into palavras(palavra) values ('hibridizaria');
 insert into palavras(palavra) values ('hibridizarao');
 insert into palavras(palavra) values ('hibridizem');
 insert into palavras(palavra) values ('hibridizo');
 insert into palavras(palavra) values ('hierarquizam');
 insert into palavras(palavra) values ('higienicos');
 insert into palavras(palavra) values ('hipnotizaras');
 insert into palavras(palavra) values ('hipnotizavam');
 insert into palavras(palavra) values ('hipotecando');
 insert into palavras(palavra) values ('hipotecareis');
 insert into palavras(palavra) values ('hodierna');
 insert into palavras(palavra) values ('homenagem');
 insert into palavras(palavra) values ('homologaram');
 insert into palavras(palavra) values ('homologaria');
 insert into palavras(palavra) values ('homologa');
 insert into palavras(palavra) values ('honorificos');
 insert into palavras(palavra) values ('honrosas');
 insert into palavras(palavra) values ('horizontinas');
 insert into palavras(palavra) values ('horrorize');
 insert into palavras(palavra) values ('horrorizemos');
 insert into palavras(palavra) values ('hortelaos');
 insert into palavras(palavra) values ('hospedasses');
 insert into palavras(palavra) values ('hospedastes');
 insert into palavras(palavra) values ('humanizarias');
 insert into palavras(palavra) values ('humanizeis');
 insert into palavras(palavra) values ('humilharmo');
 insert into palavras(palavra) values ('humorismo');
 insert into palavras(palavra) values ('humoristicas');
 insert into palavras(palavra) values ('idealizou');
 insert into palavras(palavra) values ('identifica');
 insert into palavras(palavra) values ('idolatrais');
 insert into palavras(palavra) values ('idolatraste');
 insert into palavras(palavra) values ('idolatravas');
 insert into palavras(palavra) values ('ignorara');
 insert into palavras(palavra) values ('igualaras');
 insert into palavras(palavra) values ('igualzinho');
 insert into palavras(palavra) values ('iluminasse');
 insert into palavras(palavra) values ('iluminasses');
 insert into palavras(palavra) values ('ilustrardes');
 insert into palavras(palavra) values ('ilustrareis');
 insert into palavras(palavra) values ('imantarmos');
 insert into palavras(palavra) values ('imantaveis');
 insert into palavras(palavra) values ('imigrarmo');
 insert into palavras(palavra) values ('imigraveis');
 insert into palavras(palavra) values ('imobilizada');
 insert into palavras(palavra) values ('imobilizaras');
 insert into palavras(palavra) values ('imobilizava');
 insert into palavras(palavra) values ('imortalizado');
 insert into palavras(palavra) values ('impactavam');
 insert into palavras(palavra) values ('impelires');
 insert into palavras(palavra) values ('imperativo');
 insert into palavras(palavra) values ('imperemos');
 insert into palavras(palavra) values ('imperfeicao');
 insert into palavras(palavra) values ('impetrarmos');
 insert into palavras(palavra) values ('impetravamos');
 insert into palavras(palavra) values ('impingisse');
 insert into palavras(palavra) values ('implantares');
 insert into palavras(palavra) values ('implementais');
 insert into palavras(palavra) values ('implementeis');
 insert into palavras(palavra) values ('implementou');
 insert into palavras(palavra) values ('implicarem');
 insert into palavras(palavra) values ('implicaremo');
 insert into palavras(palavra) values ('implicacoes');
 insert into palavras(palavra) values ('imploraria');
 insert into palavras(palavra) values ('implosao');
 insert into palavras(palavra) values ('importais');
 insert into palavras(palavra) values ('imposicao');
 insert into palavras(palavra) values ('imprecasses');
 insert into palavras(palavra) values ('impregnarao');
 insert into palavras(palavra) values ('impreques');
 insert into palavras(palavra) values ('impressoras');
 insert into palavras(palavra) values ('imprevistas');
 insert into palavras(palavra) values ('imprudentes');
 insert into palavras(palavra) values ('impropria');
 insert into palavras(palavra) values ('impugnativas');
 insert into palavras(palavra) values ('imputarao');
 insert into palavras(palavra) values ('imputavam');
 insert into palavras(palavra) values ('imunizares');
 insert into palavras(palavra) values ('inadequada');
 insert into palavras(palavra) values ('inadequado');
 insert into palavras(palavra) values ('inalaremos');
 insert into palavras(palavra) values ('inauguram');
 insert into palavras(palavra) values ('inaugurasse');
 insert into palavras(palavra) values ('incendiaras');
 insert into palavras(palavra) values ('incendiavam');
 insert into palavras(palavra) values ('incensava');
 insert into palavras(palavra) values ('incensaramos');
 insert into palavras(palavra) values ('incentivei');
 insert into palavras(palavra) values ('inchariam');
 insert into palavras(palavra) values ('incharieis');
 insert into palavras(palavra) values ('inchacos');
 insert into palavras(palavra) values ('inchacoes');
 insert into palavras(palavra) values ('incidirmo');
 insert into palavras(palavra) values ('incitassemos');
 insert into palavras(palavra) values ('inclinarem');
 insert into palavras(palavra) values ('incluiria');
 insert into palavras(palavra) values ('incoemos');
 insert into palavras(palavra) values ('incomodai');
 insert into palavras(palavra) values ('incomodam');
 insert into palavras(palavra) values ('incorporamos');
 insert into palavras(palavra) values ('incorria');
 insert into palavras(palavra) values ('incrementamo');
 insert into palavras(palavra) values ('incriada');
 insert into palavras(palavra) values ('incrustaras');
 insert into palavras(palavra) values ('inculcaria');
 insert into palavras(palavra) values ('inculpavam');
 insert into palavras(palavra) values ('incutiria');
 insert into palavras(palavra) values ('indagacao');
 insert into palavras(palavra) values ('indeferias');
 insert into palavras(palavra) values ('indeferira');
 insert into palavras(palavra) values ('indenizavas');
 insert into palavras(palavra) values ('independeste');
 insert into palavras(palavra) values ('independia');
 insert into palavras(palavra) values ('indicaste');
 insert into palavras(palavra) values ('indicavas');
 insert into palavras(palavra) values ('indiciaram');
 insert into palavras(palavra) values ('indiciassem');
 insert into palavras(palavra) values ('indiciem');
 insert into palavras(palavra) values ('indicavamos');
 insert into palavras(palavra) values ('indisponde');
 insert into palavras(palavra) values ('indispuserem');
 insert into palavras(palavra) values ('individuam');
 insert into palavras(palavra) values ('indiziveis');
 insert into palavras(palavra) values ('induzirmo');
 insert into palavras(palavra) values ('induzirieis');
 insert into palavras(palavra) values ('inexista');
 insert into palavras(palavra) values ('inexististe');
 insert into palavras(palavra) values ('inexpertas');
 insert into palavras(palavra) values ('infectara');
 insert into palavras(palavra) values ('infectaremo');
 insert into palavras(palavra) values ('infectariam');
 insert into palavras(palavra) values ('infestacao');
 insert into palavras(palavra) values ('infiltrastes');
 insert into palavras(palavra) values ('infiltre');
 insert into palavras(palavra) values ('infiltrou');
 insert into palavras(palavra) values ('inflacionamo');
 insert into palavras(palavra) values ('inflamaras');
 insert into palavras(palavra) values ('inflamastes');
 insert into palavras(palavra) values ('inflavas');
 insert into palavras(palavra) values ('inflexao');
 insert into palavras(palavra) values ('infligieis');
 insert into palavras(palavra) values ('influenciou');
 insert into palavras(palavra) values ('influente');
 insert into palavras(palavra) values ('informantes');
 insert into palavras(palavra) values ('informaras');
 insert into palavras(palavra) values ('informarieis');
 insert into palavras(palavra) values ('informatizam');
 insert into palavras(palavra) values ('informatizem');
 insert into palavras(palavra) values ('infortunio');
 insert into palavras(palavra) values ('infrutuosos');
 insert into palavras(palavra) values ('infundem');
 insert into palavras(palavra) values ('infundindo');
 insert into palavras(palavra) values ('iniciarias');
 insert into palavras(palavra) values ('injetaram');
 insert into palavras(palavra) values ('injuriaremo');
 insert into palavras(palavra) values ('inocularei');
 insert into palavras(palavra) values ('inovarao');
 insert into palavras(palavra) values ('inquerir');
 insert into palavras(palavra) values ('inqueriremos');
 insert into palavras(palavra) values ('inqueriras');
 insert into palavras(palavra) values ('inquietamos');
 insert into palavras(palavra) values ('inquietaras');
 insert into palavras(palavra) values ('inquirir');
 insert into palavras(palavra) values ('inquirisses');
 insert into palavras(palavra) values ('insanaveis');
 insert into palavras(palavra) values ('insatisfeito');
 insert into palavras(palavra) values ('inscritas');
 insert into palavras(palavra) values ('inseminamo');
 insert into palavras(palavra) values ('inseminara');
 insert into palavras(palavra) values ('insensatez');
 insert into palavras(palavra) values ('inserisses');
 insert into palavras(palavra) values ('insidiai');
 insert into palavras(palavra) values ('insidiarmo');
 insert into palavras(palavra) values ('insistires');
 insert into palavras(palavra) values ('insofridas');
 insert into palavras(palavra) values ('instalacoes');
 insert into palavras(palavra) values ('instaleis');
 insert into palavras(palavra) values ('instantaneos');
 insert into palavras(palavra) values ('instaremo');
 insert into palavras(palavra) values ('instigamo');
 insert into palavras(palavra) values ('instigarao');
 insert into palavras(palavra) values ('instigavam');
 insert into palavras(palavra) values ('institui');
 insert into palavras(palavra) values ('instasseis');
 insert into palavras(palavra) values ('insularia');
 insert into palavras(palavra) values ('insulastes');
 insert into palavras(palavra) values ('insultaria');
 insert into palavras(palavra) values ('insultariam');
 insert into palavras(palavra) values ('integramo');
 insert into palavras(palavra) values ('integrarias');
 insert into palavras(palavra) values ('integravam');
 insert into palavras(palavra) values ('integreis');
 insert into palavras(palavra) values ('inteiram');
 insert into palavras(palavra) values ('inteirassem');
 insert into palavras(palavra) values ('inteiracoes');
 insert into palavras(palavra) values ('intensifique');
 insert into palavras(palavra) values ('intentas');
 insert into palavras(palavra) values ('intentemos');
 insert into palavras(palavra) values ('intentaveis');
 insert into palavras(palavra) values ('interagirao');
 insert into palavras(palavra) values ('intercalaste');
 insert into palavras(palavra) values ('intercalava');
 insert into palavras(palavra) values ('intercalou');
 insert into palavras(palavra) values ('interceda');
 insert into palavras(palavra) values ('intercedermo');
 insert into palavras(palavra) values ('intercedo');
 insert into palavras(palavra) values ('interessares');
 insert into palavras(palavra) values ('interesseiro');
 insert into palavras(palavra) values ('interferiu');
 insert into palavras(palavra) values ('interligaste');
 insert into palavras(palavra) values ('interliguemo');
 insert into palavras(palavra) values ('intermeavam');
 insert into palavras(palavra) values ('intermedia');
 insert into palavras(palavra) values ('internamos');
 insert into palavras(palavra) values ('internemo');
 insert into palavras(palavra) values ('internemos');
 insert into palavras(palavra) values ('interpunheis');
 insert into palavras(palavra) values ('interromper');
 insert into palavras(palavra) values ('interviemos');
 insert into palavras(palavra) values ('intimidai');
 insert into palavras(palavra) values ('intrigara');
 insert into palavras(palavra) values ('introduzem');
 insert into palavras(palavra) values ('introduzida');
 insert into palavras(palavra) values ('intrometamo');
 insert into palavras(palavra) values ('intromete');
 insert into palavras(palavra) values ('intrometerem');
 insert into palavras(palavra) values ('intuindo');
 insert into palavras(palavra) values ('intuitivo');
 insert into palavras(palavra) values ('intumescera');
 insert into palavras(palavra) values ('intuires');
 insert into palavras(palavra) values ('inundarem');
 insert into palavras(palavra) values ('inutilizarao');
 insert into palavras(palavra) values ('invadiamos');
 insert into palavras(palavra) values ('invalidada');
 insert into palavras(palavra) values ('invalidamo');
 insert into palavras(palavra) values ('invalidem');
 insert into palavras(palavra) values ('invejamo');
 insert into palavras(palavra) values ('invejaremo');
 insert into palavras(palavra) values ('invejava');
 insert into palavras(palavra) values ('invejoso');
 insert into palavras(palavra) values ('invejaveis');
 insert into palavras(palavra) values ('inverteres');
 insert into palavras(palavra) values ('investigue');
 insert into palavras(palavra) values ('investirei');
 insert into palavras(palavra) values ('investistes');
 insert into palavras(palavra) values ('iracundos');
 insert into palavras(palavra) values ('irmanaram');
 insert into palavras(palavra) values ('ironizarei');
 insert into palavras(palavra) values ('ironizaremo');
 insert into palavras(palavra) values ('ironizou');
 insert into palavras(palavra) values ('irrespiravel');
 insert into palavras(palavra) values ('irrigamo');
 insert into palavras(palavra) values ('irrigaste');
 insert into palavras(palavra) values ('irritados');
 insert into palavras(palavra) values ('irritavas');
 insert into palavras(palavra) values ('irrompesseis');
 insert into palavras(palavra) values ('isentando');
 insert into palavras(palavra) values ('isentarmos');
 insert into palavras(palavra) values ('isentarieis');
 insert into palavras(palavra) values ('isentassemos');
 insert into palavras(palavra) values ('isolasses');
 insert into palavras(palavra) values ('isometricos');
 insert into palavras(palavra) values ('iterarem');
 insert into palavras(palavra) values ('iterarmos');
 insert into palavras(palavra) values ('iterarieis');
 insert into palavras(palavra) values ('joaninhas');
 insert into palavras(palavra) values ('joeirais');
 insert into palavras(palavra) values ('joeirariamos');
 insert into palavras(palavra) values ('jorrassem');
 insert into palavras(palavra) values ('jorravamos');
 insert into palavras(palavra) values ('jubilaremos');
 insert into palavras(palavra) values ('jubilassem');
 insert into palavras(palavra) values ('julgasseis');
 insert into palavras(palavra) values ('juntarao');
 insert into palavras(palavra) values ('juntasses');
 insert into palavras(palavra) values ('jurassicos');
 insert into palavras(palavra) values ('juravamos');
 insert into palavras(palavra) values ('justificas');
 insert into palavras(palavra) values ('justificacao');
 insert into palavras(palavra) values ('laborardes');
 insert into palavras(palavra) values ('laboraras');
 insert into palavras(palavra) values ('laboravamos');
 insert into palavras(palavra) values ('labutarei');
 insert into palavras(palavra) values ('labutarao');
 insert into palavras(palavra) values ('lacrassem');
 insert into palavras(palavra) values ('ladrilharem');
 insert into palavras(palavra) values ('ladrilhemo');
 insert into palavras(palavra) values ('lamberiamos');
 insert into palavras(palavra) values ('lamentamo');
 insert into palavras(palavra) values ('lamentarmos');
 insert into palavras(palavra) values ('laminasseis');
 insert into palavras(palavra) values ('laminavamos');
 insert into palavras(palavra) values ('lampioes');
 insert into palavras(palavra) values ('lancemos');
 insert into palavras(palavra) values ('lancaremo');
 insert into palavras(palavra) values ('lancasseis');
 insert into palavras(palavra) values ('laniferos');
 insert into palavras(palavra) values ('lapiseira');
 insert into palavras(palavra) values ('largariamos');
 insert into palavras(palavra) values ('lastimar');
 insert into palavras(palavra) values ('lastimarmos');
 insert into palavras(palavra) values ('lastrearieis');
 insert into palavras(palavra) values ('lastreasses');
 insert into palavras(palavra) values ('lastreavas');
 insert into palavras(palavra) values ('lastreei');
 insert into palavras(palavra) values ('latinizado');
 insert into palavras(palavra) values ('lavrando');
 insert into palavras(palavra) values ('lecionarmo');
 insert into palavras(palavra) values ('legalizadas');
 insert into palavras(palavra) values ('legalizarmos');
 insert into palavras(palavra) values ('legalizei');
 insert into palavras(palavra) values ('legareis');
 insert into palavras(palavra) values ('legariamos');
 insert into palavras(palavra) values ('legionarias');
 insert into palavras(palavra) values ('legisladoras');
 insert into palavras(palavra) values ('legislaras');
 insert into palavras(palavra) values ('legitimai');
 insert into palavras(palavra) values ('legitimarao');
 insert into palavras(palavra) values ('legitimasses');
 insert into palavras(palavra) values ('lesardes');
 insert into palavras(palavra) values ('levantadoras');
 insert into palavras(palavra) values ('levantamos');
 insert into palavras(palavra) values ('levantasses');
 insert into palavras(palavra) values ('levantaste');
 insert into palavras(palavra) values ('levitando');
 insert into palavras(palavra) values ('levitaramos');
 insert into palavras(palavra) values ('liberados');
 insert into palavras(palavra) values ('liberalizamo');
 insert into palavras(palavra) values ('liberalizar');
 insert into palavras(palavra) values ('libertarei');
 insert into palavras(palavra) values ('libertara');
 insert into palavras(palavra) values ('libertavas');
 insert into palavras(palavra) values ('libertei');
 insert into palavras(palavra) values ('libertinos');
 insert into palavras(palavra) values ('libertareis');
 insert into palavras(palavra) values ('liberavamos');
 insert into palavras(palavra) values ('licenciem');
 insert into palavras(palavra) values ('licenciou');
 insert into palavras(palavra) values ('licitara');
 insert into palavras(palavra) values ('lideranca');
 insert into palavras(palavra) values ('limoeiro');
 insert into palavras(palavra) values ('limparei');
 insert into palavras(palavra) values ('limpaveis');
 insert into palavras(palavra) values ('linearizara');
 insert into palavras(palavra) values ('linguetas');
 insert into palavras(palavra) values ('linhagens');
 insert into palavras(palavra) values ('liofilizacao');
 insert into palavras(palavra) values ('liquefizemos');
 insert into palavras(palavra) values ('lisonjearem');
 insert into palavras(palavra) values ('lisonjearao');
 insert into palavras(palavra) values ('lisonjeastes');
 insert into palavras(palavra) values ('lisonjeareis');
 insert into palavras(palavra) values ('listarmos');
 insert into palavras(palavra) values ('litografico');
 insert into palavras(palavra) values ('lixassemos');
 insert into palavras(palavra) values ('localizaria');
 insert into palavras(palavra) values ('localizasse');
 insert into palavras(palavra) values ('locassemos');
 insert into palavras(palavra) values ('logicismos');
 insert into palavras(palavra) values ('lograres');
 insert into palavras(palavra) values ('loterica');
 insert into palavras(palavra) values ('lucrativa');
 insert into palavras(palavra) values ('luxuriantes');
 insert into palavras(palavra) values ('luzireis');
 insert into palavras(palavra) values ('limpidos');
 insert into palavras(palavra) values ('macedonia');
 insert into palavras(palavra) values ('macieira');
 insert into palavras(palavra) values ('maculareis');
 insert into palavras(palavra) values ('madeireiro');
 insert into palavras(palavra) values ('madrugam');
 insert into palavras(palavra) values ('madrugando');
 insert into palavras(palavra) values ('maduraremos');
 insert into palavras(palavra) values ('maduravam');
 insert into palavras(palavra) values ('magnetizais');
 insert into palavras(palavra) values ('magoavamos');
 insert into palavras(palavra) values ('magricelos');
 insert into palavras(palavra) values ('magrissimas');
 insert into palavras(palavra) values ('majorariam');
 insert into palavras(palavra) values ('majorasse');
 insert into palavras(palavra) values ('malavieres');
 insert into palavras(palavra) values ('malaviestes');
 insert into palavras(palavra) values ('malavinheis');
 insert into palavras(palavra) values ('malbaratamos');
 insert into palavras(palavra) values ('malbarataras');
 insert into palavras(palavra) values ('maldizei');
 insert into palavras(palavra) values ('malfadado');
 insert into palavras(palavra) values ('malograram');
 insert into palavras(palavra) values ('malogras');
 insert into palavras(palavra) values ('malogravamos');
 insert into palavras(palavra) values ('maltrateis');
 insert into palavras(palavra) values ('malvadas');
 insert into palavras(palavra) values ('malefico');
 insert into palavras(palavra) values ('mamareis');
 insert into palavras(palavra) values ('manchara');
 insert into palavras(palavra) values ('mandemos');
 insert into palavras(palavra) values ('maneirado');
 insert into palavras(palavra) values ('maneiraras');
 insert into palavras(palavra) values ('maneiras');
 insert into palavras(palavra) values ('manejareis');
 insert into palavras(palavra) values ('manejarias');
 insert into palavras(palavra) values ('manejasseis');
 insert into palavras(palavra) values ('manietavam');
 insert into palavras(palavra) values ('manipulada');
 insert into palavras(palavra) values ('manipulai');
 insert into palavras(palavra) values ('manipulo');
 insert into palavras(palavra) values ('manobraremos');
 insert into palavras(palavra) values ('manquemos');
 insert into palavras(palavra) values ('manualmente');
 insert into palavras(palavra) values ('manufaturemo');
 insert into palavras(palavra) values ('manufatures');
 insert into palavras(palavra) values ('manuseada');
 insert into palavras(palavra) values ('manusearmo');
 insert into palavras(palavra) values ('mapeadas');
 insert into palavras(palavra) values ('maquiaria');
 insert into palavras(palavra) values ('maquilariam');
 insert into palavras(palavra) values ('maravilharmo');
 insert into palavras(palavra) values ('maravilhas');
 insert into palavras(palavra) values ('marcariam');
 insert into palavras(palavra) values ('marejareis');
 insert into palavras(palavra) values ('marejaveis');
 insert into palavras(palavra) values ('marginalizo');
 insert into palavras(palavra) values ('marretada');
 insert into palavras(palavra) values ('martelai');
 insert into palavras(palavra) values ('martirizavam');
 insert into palavras(palavra) values ('marulhavam');
 insert into palavras(palavra) values ('marxistas');
 insert into palavras(palavra) values ('mascaramos');
 insert into palavras(palavra) values ('mascararem');
 insert into palavras(palavra) values ('massacrares');
 insert into palavras(palavra) values ('massacraria');
 insert into palavras(palavra) values ('massacrareis');
 insert into palavras(palavra) values ('massagearas');
 insert into palavras(palavra) values ('massageava');
 insert into palavras(palavra) values ('mastigares');
 insert into palavras(palavra) values ('mastigacao');
 insert into palavras(palavra) values ('matadoras');
 insert into palavras(palavra) values ('matareis');
 insert into palavras(palavra) values ('mataremos');
 insert into palavras(palavra) values ('matematizar');
 insert into palavras(palavra) values ('matematizara');
 insert into palavras(palavra) values ('matematizava');
 insert into palavras(palavra) values ('maturaremo');
 insert into palavras(palavra) values ('maturassemos');
 insert into palavras(palavra) values ('matutassem');
 insert into palavras(palavra) values ('macaricos');
 insert into palavras(palavra) values ('mecanizavas');
 insert into palavras(palavra) values ('medeiros');
 insert into palavras(palavra) values ('medianas');
 insert into palavras(palavra) values ('mediarias');
 insert into palavras(palavra) values ('mediarao');
 insert into palavras(palavra) values ('medicamentem');
 insert into palavras(palavra) values ('medicaveis');
 insert into palavras(palavra) values ('meditavam');
 insert into palavras(palavra) values ('meditacao');
 insert into palavras(palavra) values ('meditassemos');
 insert into palavras(palavra) values ('medrareis');
 insert into palavras(palavra) values ('medrares');
 insert into palavras(palavra) values ('medrarmo');
 insert into palavras(palavra) values ('medrastes');
 insert into palavras(palavra) values ('melancolica');
 insert into palavras(palavra) values ('melanina');
 insert into palavras(palavra) values ('melhorada');
 insert into palavras(palavra) values ('melindrares');
 insert into palavras(palavra) values ('melodicas');
 insert into palavras(palavra) values ('mencionarmos');
 insert into palavras(palavra) values ('mentalizavam');
 insert into palavras(palavra) values ('mentalmente');
 insert into palavras(palavra) values ('mentirei');
 insert into palavras(palavra) values ('mentirosa');
 insert into palavras(palavra) values ('mercantiliza');
 insert into palavras(palavra) values ('merendam');
 insert into palavras(palavra) values ('merendeis');
 insert into palavras(palavra) values ('mergulharei');
 insert into palavras(palavra) values ('mergulharao');
 insert into palavras(palavra) values ('mergulhava');
 insert into palavras(palavra) values ('mergulhaveis');
 insert into palavras(palavra) values ('mesclarieis');
 insert into palavras(palavra) values ('metralhadas');
 insert into palavras(palavra) values ('metroviario');
 insert into palavras(palavra) values ('metesseis');
 insert into palavras(palavra) values ('mexessem');
 insert into palavras(palavra) values ('mexicanos');
 insert into palavras(palavra) values ('migrares');
 insert into palavras(palavra) values ('migrassemos');
 insert into palavras(palavra) values ('milionarios');
 insert into palavras(palavra) values ('militamo');
 insert into palavras(palavra) values ('militemo');
 insert into palavras(palavra) values ('minastes');
 insert into palavras(palavra) values ('minguada');
 insert into palavras(palavra) values ('ministramos');
 insert into palavras(palavra) values ('minorais');
 insert into palavras(palavra) values ('minoraramos');
 insert into palavras(palavra) values ('minuciosas');
 insert into palavras(palavra) values ('minassemos');
 insert into palavras(palavra) values ('minaveis');
 insert into palavras(palavra) values ('miolinho');
 insert into palavras(palavra) values ('mirarieis');
 insert into palavras(palavra) values ('mistificaras');
 insert into palavras(palavra) values ('mistificas');
 insert into palavras(palavra) values ('misturarieis');
 insert into palavras(palavra) values ('misturas');
 insert into palavras(palavra) values ('mitigavas');
 insert into palavras(palavra) values ('mobiliaremos');
 insert into palavras(palavra) values ('mochilas');
 insert into palavras(palavra) values ('modelarmo');
 insert into palavras(palavra) values ('moderadoras');
 insert into palavras(palavra) values ('moderarao');
 insert into palavras(palavra) values ('moderavam');
 insert into palavras(palavra) values ('modificais');
 insert into palavras(palavra) values ('modificas');
 insert into palavras(palavra) values ('modifiquem');
 insert into palavras(palavra) values ('modulava');
 insert into palavras(palavra) values ('moldassem');
 insert into palavras(palavra) values ('moldemos');
 insert into palavras(palavra) values ('molestai');
 insert into palavras(palavra) values ('molharas');
 insert into palavras(palavra) values ('molhassemos');
 insert into palavras(palavra) values ('monopolizamo');
 insert into palavras(palavra) values ('monoteismo');
 insert into palavras(palavra) values ('moquecas');
 insert into palavras(palavra) values ('moralizai');
 insert into palavras(palavra) values ('mordereis');
 insert into palavras(palavra) values ('morramos');
 insert into palavras(palavra) values ('morrereis');
 insert into palavras(palavra) values ('moscarei');
 insert into palavras(palavra) values ('moscariamos');
 insert into palavras(palavra) values ('moscassemos');
 insert into palavras(palavra) values ('mosquitos');
 insert into palavras(palavra) values ('motivara');
 insert into palavras(palavra) values ('motivariam');
 insert into palavras(palavra) values ('motivavas');
 insert into palavras(palavra) values ('motivemos');
 insert into palavras(palavra) values ('movedica');
 insert into palavras(palavra) values ('movimentada');
 insert into palavras(palavra) values ('mocambicanas');
 insert into palavras(palavra) values ('multipliques');
 insert into palavras(palavra) values ('mumificada');
 insert into palavras(palavra) values ('mumificamo');
 insert into palavras(palavra) values ('mumifiqueis');
 insert into palavras(palavra) values ('municiareis');
 insert into palavras(palavra) values ('municipio');
 insert into palavras(palavra) values ('munireis');
 insert into palavras(palavra) values ('murcharias');
 insert into palavras(palavra) values ('murchavam');
 insert into palavras(palavra) values ('murmureis');
 insert into palavras(palavra) values ('musculaturas');
 insert into palavras(palavra) values ('musculosas');
 insert into palavras(palavra) values ('musicarmos');
 insert into palavras(palavra) values ('musicaramos');
 insert into palavras(palavra) values ('mutilaras');
 insert into palavras(palavra) values ('mutileis');
 insert into palavras(palavra) values ('nadadoros');
 insert into palavras(palavra) values ('nadareis');
 insert into palavras(palavra) values ('narravam');
 insert into palavras(palavra) values ('narrassemos');
 insert into palavras(palavra) values ('nascieis');
 insert into palavras(palavra) values ('naufragardes');
 insert into palavras(palavra) values ('naufragara');
 insert into palavras(palavra) values ('naufragassem');
 insert into palavras(palavra) values ('navegarem');
 insert into palavras(palavra) values ('necrosasseis');
 insert into palavras(palavra) values ('nefastos');
 insert into palavras(palavra) values ('negligencia');
 insert into palavras(palavra) values ('nenhures');
 insert into palavras(palavra) values ('neuralgia');
 insert into palavras(palavra) values ('neutralizara');
 insert into palavras(palavra) values ('nevariamos');
 insert into palavras(palavra) values ('nevaramos');
 insert into palavras(palavra) values ('ninasseis');
 insert into palavras(palavra) values ('niquelaremos');
 insert into palavras(palavra) values ('niquelaveis');
 insert into palavras(palavra) values ('nitrogenadas');
 insert into palavras(palavra) values ('nivelamo');
 insert into palavras(palavra) values ('nivelaste');
 insert into palavras(palavra) values ('noivarias');
 insert into palavras(palavra) values ('nomeariam');
 insert into palavras(palavra) values ('nomearmos');
 insert into palavras(palavra) values ('nomearas');
 insert into palavras(palavra) values ('nominativos');
 insert into palavras(palavra) values ('norteias');
 insert into palavras(palavra) values ('notabiliza');
 insert into palavras(palavra) values ('notaremo');
 insert into palavras(palavra) values ('noticiareis');
 insert into palavras(palavra) values ('noticiaveis');
 insert into palavras(palavra) values ('notificaras');
 insert into palavras(palavra) values ('noviciais');
 insert into palavras(palavra) values ('nudistas');
 insert into palavras(palavra) values ('numeracoes');
 insert into palavras(palavra) values ('obcecara');
 insert into palavras(palavra) values ('obcecareis');
 insert into palavras(palavra) values ('obcecarem');
 insert into palavras(palavra) values ('obcecava');
 insert into palavras(palavra) values ('obedecia');
 insert into palavras(palavra) values ('objetiva');
 insert into palavras(palavra) values ('objetivaras');
 insert into palavras(palavra) values ('objetivara');
 insert into palavras(palavra) values ('objetivou');
 insert into palavras(palavra) values ('obliteram');
 insert into palavras(palavra) values ('obliteraras');
 insert into palavras(palavra) values ('obsediarei');
 insert into palavras(palavra) values ('obsediaramos');
 insert into palavras(palavra) values ('obsequiar');
 insert into palavras(palavra) values ('obsequiares');
 insert into palavras(palavra) values ('obsequiaria');
 insert into palavras(palavra) values ('obsequiei');
 insert into palavras(palavra) values ('observados');
 insert into palavras(palavra) values ('observarieis');
 insert into palavras(palavra) values ('observem');
 insert into palavras(palavra) values ('obstarias');
 insert into palavras(palavra) values ('obstinara');
 insert into palavras(palavra) values ('obstinas');
 insert into palavras(palavra) values ('obstineis');
 insert into palavras(palavra) values ('obstringir');
 insert into palavras(palavra) values ('obstringira');
 insert into palavras(palavra) values ('obstringisse');
 insert into palavras(palavra) values ('obtivermo');
 insert into palavras(palavra) values ('obturaremos');
 insert into palavras(palavra) values ('obturacao');
 insert into palavras(palavra) values ('obtinheis');
 insert into palavras(palavra) values ('ocasionasse');
 insert into palavras(palavra) values ('ocasionavam');
 insert into palavras(palavra) values ('octogenario');
 insert into palavras(palavra) values ('ocupares');
 insert into palavras(palavra) values ('ocupaste');
 insert into palavras(palavra) values ('odiarias');
 insert into palavras(palavra) values ('ofendiamos');
 insert into palavras(palavra) values ('oferecei');
 insert into palavras(palavra) values ('oferecem');
 insert into palavras(palavra) values ('oferecidas');
 insert into palavras(palavra) values ('oferecas');
 insert into palavras(palavra) values ('oficiaria');
 insert into palavras(palavra) values ('oficiasse');
 insert into palavras(palavra) values ('oficiavas');
 insert into palavras(palavra) values ('ofuscamos');
 insert into palavras(palavra) values ('olvidaras');
 insert into palavras(palavra) values ('olvidavamos');
 insert into palavras(palavra) values ('ombrearia');
 insert into palavras(palavra) values ('ombreeis');
 insert into palavras(palavra) values ('omitieis');
 insert into palavras(palavra) values ('ondularemo');
 insert into palavras(palavra) values ('ondulatoria');
 insert into palavras(palavra) values ('oneravas');
 insert into palavras(palavra) values ('onerosas');
 insert into palavras(palavra) values ('onerareis');
 insert into palavras(palavra) values ('opinarmos');
 insert into palavras(palavra) values ('opinaras');
 insert into palavras(palavra) values ('opressiva');
 insert into palavras(palavra) values ('optasses');
 insert into palavras(palavra) values ('ordenhar');
 insert into palavras(palavra) values ('ordenharieis');
 insert into palavras(palavra) values ('ordenhavas');
 insert into palavras(palavra) values ('ordenhaveis');
 insert into palavras(palavra) values ('organizacoes');
 insert into palavras(palavra) values ('orgulharemos');
 insert into palavras(palavra) values ('orgulhemo');
 insert into palavras(palavra) values ('oriental');
 insert into palavras(palavra) values ('originaras');
 insert into palavras(palavra) values ('ornamentando');
 insert into palavras(palavra) values ('ornamentavas');
 insert into palavras(palavra) values ('orquestramo');
 insert into palavras(palavra) values ('orquestrando');
 insert into palavras(palavra) values ('orquideas');
 insert into palavras(palavra) values ('orvalharei');
 insert into palavras(palavra) values ('orcaremos');
 insert into palavras(palavra) values ('orcarmos');
 insert into palavras(palavra) values ('oscilaram');
 insert into palavras(palavra) values ('oscilaria');
 insert into palavras(palavra) values ('ostentai');
 insert into palavras(palavra) values ('otomanos');
 insert into palavras(palavra) values ('ousastes');
 insert into palavras(palavra) values ('outorgaras');
 insert into palavras(palavra) values ('outorguemo');
 insert into palavras(palavra) values ('ovacionaste');
 insert into palavras(palavra) values ('oxidastes');
 insert into palavras(palavra) values ('oxidasseis');
 insert into palavras(palavra) values ('pacificaras');
 insert into palavras(palavra) values ('pacifiquemos');
 insert into palavras(palavra) values ('pacifiques');
 insert into palavras(palavra) values ('paganizassem');
 insert into palavras(palavra) values ('paginardes');
 insert into palavras(palavra) values ('paginavamos');
 insert into palavras(palavra) values ('paixoezinhas');
 insert into palavras(palavra) values ('pajeariam');
 insert into palavras(palavra) values ('pajearmo');
 insert into palavras(palavra) values ('pajeariamos');
 insert into palavras(palavra) values ('paleozoica');
 insert into palavras(palavra) values ('palestrando');
 insert into palavras(palavra) values ('palestrasse');
 insert into palavras(palavra) values ('palitariam');
 insert into palavras(palavra) values ('palitarmos');
 insert into palavras(palavra) values ('palpiteira');
 insert into palavras(palavra) values ('palpiteiros');
 insert into palavras(palavra) values ('palpitaveis');
 insert into palavras(palavra) values ('panfletos');
 insert into palavras(palavra) values ('papagueado');
 insert into palavras(palavra) values ('paparicares');
 insert into palavras(palavra) values ('paralelizas');
 insert into palavras(palavra) values ('paralelizem');
 insert into palavras(palavra) values ('paraliticos');
 insert into palavras(palavra) values ('paramentara');
 insert into palavras(palavra) values ('paramentarem');
 insert into palavras(palavra) values ('paramentavam');
 insert into palavras(palavra) values ('paraplegia');
 insert into palavras(palavra) values ('parasitado');
 insert into palavras(palavra) values ('parasitais');
 insert into palavras(palavra) values ('parasitastes');
 insert into palavras(palavra) values ('parasita');
 insert into palavras(palavra) values ('parcelassem');
 insert into palavras(palavra) values ('parcelava');
 insert into palavras(palavra) values ('pareavas');
 insert into palavras(palavra) values ('parecera');
 insert into palavras(palavra) values ('pareceremo');
 insert into palavras(palavra) values ('parecera');
 insert into palavras(palavra) values ('parentes');
 insert into palavras(palavra) values ('parodiavas');
 insert into palavras(palavra) values ('parquimetro');
 insert into palavras(palavra) values ('parreiras');
 insert into palavras(palavra) values ('partilhai');
 insert into palavras(palavra) values ('partilhara');
 insert into palavras(palavra) values ('pasmavam');
 insert into palavras(palavra) values ('passariam');
 insert into palavras(palavra) values ('passearamos');
 insert into palavras(palavra) values ('passaramos');
 insert into palavras(palavra) values ('passaveis');
 insert into palavras(palavra) values ('pastagem');
 insert into palavras(palavra) values ('pastelao');
 insert into palavras(palavra) values ('pasteurizara');
 insert into palavras(palavra) values ('pasteuriza');
 insert into palavras(palavra) values ('patentearemo');
 insert into palavras(palavra) values ('paternalismo');
 insert into palavras(palavra) values ('paternalista');
 insert into palavras(palavra) values ('patinharei');
 insert into palavras(palavra) values ('patologia');
 insert into palavras(palavra) values ('patriarcais');
 insert into palavras(palavra) values ('paulistana');
 insert into palavras(palavra) values ('pautaremos');
 insert into palavras(palavra) values ('pavoneares');
 insert into palavras(palavra) values ('pavonearao');
 insert into palavras(palavra) values ('pecaminosas');
 insert into palavras(palavra) values ('pechinchar');
 insert into palavras(palavra) values ('pechincharem');
 insert into palavras(palavra) values ('pechincho');
 insert into palavras(palavra) values ('pechinchou');
 insert into palavras(palavra) values ('peculatos');
 insert into palavras(palavra) values ('pecassemos');
 insert into palavras(palavra) values ('pedalada');
 insert into palavras(palavra) values ('pedalado');
 insert into palavras(palavra) values ('pegariam');
 insert into palavras(palavra) values ('pegaramos');
 insert into palavras(palavra) values ('peidarem');
 insert into palavras(palavra) values ('peidarmos');
 insert into palavras(palavra) values ('peidasse');
 insert into palavras(palavra) values ('peixarias');
 insert into palavras(palavra) values ('pelejaria');
 insert into palavras(palavra) values ('pelejava');
 insert into palavras(palavra) values ('penalizareis');
 insert into palavras(palavra) values ('peneirara');
 insert into palavras(palavra) values ('penetramo');
 insert into palavras(palavra) values ('penetrardes');
 insert into palavras(palavra) values ('penetremo');
 insert into palavras(palavra) values ('penhoraremos');
 insert into palavras(palavra) values ('penhorarmo');
 insert into palavras(palavra) values ('penicilina');
 insert into palavras(palavra) values ('perambularem');
 insert into palavras(palavra) values ('perambulares');
 insert into palavras(palavra) values ('percebeu');
 insert into palavras(palavra) values ('percorreras');
 insert into palavras(palavra) values ('percutiu');
 insert into palavras(palavra) values ('perderias');
 insert into palavras(palavra) values ('perdidico');
 insert into palavras(palavra) values ('perdoaria');
 insert into palavras(palavra) values ('perdoaramos');
 insert into palavras(palavra) values ('perduramo');
 insert into palavras(palavra) values ('perdurares');
 insert into palavras(palavra) values ('perdures');
 insert into palavras(palavra) values ('perecerdes');
 insert into palavras(palavra) values ('perfazia');
 insert into palavras(palavra) values ('perfumaras');
 insert into palavras(palavra) values ('perfumasses');
 insert into palavras(palavra) values ('perfurardes');
 insert into palavras(palavra) values ('pergaminho');
 insert into palavras(palavra) values ('pergaminhos');
 insert into palavras(palavra) values ('periciarieis');
 insert into palavras(palavra) values ('perifericas');
 insert into palavras(palavra) values ('permanecerem');
 insert into palavras(palavra) values ('permitia');
 insert into palavras(palavra) values ('permitiria');
 insert into palavras(palavra) values ('permitirmos');
 insert into palavras(palavra) values ('permitisseis');
 insert into palavras(palavra) values ('permutais');
 insert into palavras(palavra) values ('permutara');
 insert into palavras(palavra) values ('permutavam');
 insert into palavras(palavra) values ('pernambuco');
 insert into palavras(palavra) values ('pernoitarmo');
 insert into palavras(palavra) values ('perpetuaras');
 insert into palavras(palavra) values ('perscrutais');
 insert into palavras(palavra) values ('perseguimos');
 insert into palavras(palavra) values ('perseguis');
 insert into palavras(palavra) values ('perseveramo');
 insert into palavras(palavra) values ('persigamos');
 insert into palavras(palavra) values ('persignai');
 insert into palavras(palavra) values ('persistirdes');
 insert into palavras(palavra) values ('persistiria');
 insert into palavras(palavra) values ('perspicuo');
 insert into palavras(palavra) values ('persuasivo');
 insert into palavras(palavra) values ('pertencais');
 insert into palavras(palavra) values ('perverteras');
 insert into palavras(palavra) values ('pervertidos');
 insert into palavras(palavra) values ('pesariam');
 insert into palavras(palavra) values ('pesquisado');
 insert into palavras(palavra) values ('pesquisarmo');
 insert into palavras(palavra) values ('pesquisemo');
 insert into palavras(palavra) values ('pesquisaveis');
 insert into palavras(palavra) values ('pestanejaras');
 insert into palavras(palavra) values ('petiscavas');
 insert into palavras(palavra) values ('petrificar');
 insert into palavras(palavra) values ('petrificarem');
 insert into palavras(palavra) values ('petrificaste');
 insert into palavras(palavra) values ('picaretarei');
 insert into palavras(palavra) values ('picaretareis');
 insert into palavras(palavra) values ('picaretarem');
 insert into palavras(palavra) values ('picaretei');
 insert into palavras(palavra) values ('pichastes');
 insert into palavras(palavra) values ('pigarreie');
 insert into palavras(palavra) values ('pigmentando');
 insert into palavras(palavra) values ('pigmentaveis');
 insert into palavras(palavra) values ('pilheriai');
 insert into palavras(palavra) values ('pilheriara');
 insert into palavras(palavra) values ('pilotaste');
 insert into palavras(palavra) values ('pincelada');
 insert into palavras(palavra) values ('pincelais');
 insert into palavras(palavra) values ('pincelarias');
 insert into palavras(palavra) values ('pincelemos');
 insert into palavras(palavra) values ('pincelzinho');
 insert into palavras(palavra) values ('pingarem');
 insert into palavras(palavra) values ('pingariam');
 insert into palavras(palavra) values ('pintariamos');
 insert into palavras(palavra) values ('pincaras');
 insert into palavras(palavra) values ('pipocarei');
 insert into palavras(palavra) values ('pipocavamos');
 insert into palavras(palavra) values ('piquenique');
 insert into palavras(palavra) values ('pirassununga');
 insert into palavras(palavra) values ('pisotearei');
 insert into palavras(palavra) values ('plagiaste');
 insert into palavras(palavra) values ('planejarao');
 insert into palavras(palavra) values ('planificaste');
 insert into palavras(palavra) values ('planificava');
 insert into palavras(palavra) values ('plantemos');
 insert into palavras(palavra) values ('plasmavas');
 insert into palavras(palavra) values ('platonicos');
 insert into palavras(palavra) values ('plotardes');
 insert into palavras(palavra) values ('plugasse');
 insert into palavras(palavra) values ('plugasseis');
 insert into palavras(palavra) values ('pluralista');
 insert into palavras(palavra) values ('poetizamo');
 insert into palavras(palavra) values ('poetizaste');
 insert into palavras(palavra) values ('poetizeis');
 insert into palavras(palavra) values ('polarizando');
 insert into palavras(palavra) values ('polarizarmo');
 insert into palavras(palavra) values ('polarizas');
 insert into palavras(palavra) values ('policiaremo');
 insert into palavras(palavra) values ('polinizando');
 insert into palavras(palavra) values ('polinizaras');
 insert into palavras(palavra) values ('politizares');
 insert into palavras(palavra) values ('politizasse');
 insert into palavras(palavra) values ('politizavam');
 insert into palavras(palavra) values ('politizavas');
 insert into palavras(palavra) values ('politiza');
 insert into palavras(palavra) values ('pombinhos');
 insert into palavras(palavra) values ('ponderada');
 insert into palavras(palavra) values ('ponderamo');
 insert into palavras(palavra) values ('ponderarei');
 insert into palavras(palavra) values ('pontificaram');
 insert into palavras(palavra) values ('pontificaria');
 insert into palavras(palavra) values ('pontificara');
 insert into palavras(palavra) values ('pontifiquemo');
 insert into palavras(palavra) values ('pontilhando');
 insert into palavras(palavra) values ('pontilhar');
 insert into palavras(palavra) values ('pontilhara');
 insert into palavras(palavra) values ('pontilharas');
 insert into palavras(palavra) values ('populosas');
 insert into palavras(palavra) values ('populosos');
 insert into palavras(palavra) values ('porfiassemos');
 insert into palavras(palavra) values ('pormenorizo');
 insert into palavras(palavra) values ('pornografias');
 insert into palavras(palavra) values ('portaremos');
 insert into palavras(palavra) values ('portemos');
 insert into palavras(palavra) values ('posporas');
 insert into palavras(palavra) values ('pospusesses');
 insert into palavras(palavra) values ('possuiras');
 insert into palavras(palavra) values ('postergai');
 insert into palavras(palavra) values ('postergardes');
 insert into palavras(palavra) values ('postularao');
 insert into palavras(palavra) values ('potestade');
 insert into palavras(palavra) values ('potencias');
 insert into palavras(palavra) values ('pousarmos');
 insert into palavras(palavra) values ('pousassem');
 insert into palavras(palavra) values ('povoadores');
 insert into palavras(palavra) values ('povoamos');
 insert into palavras(palavra) values ('povoavamos');
 insert into palavras(palavra) values ('pracinha');
 insert into palavras(palavra) values ('praguejasses');
 insert into palavras(palavra) values ('pranteaveis');
 insert into palavras(palavra) values ('praticamo');
 insert into palavras(palavra) values ('praticidade');
 insert into palavras(palavra) values ('pratique');
 insert into palavras(palavra) values ('precavidas');
 insert into palavras(palavra) values ('precederia');
 insert into palavras(palavra) values ('precedermos');
 insert into palavras(palavra) values ('precedidos');
 insert into palavras(palavra) values ('precipitarmo');
 insert into palavras(palavra) values ('precisamos');
 insert into palavras(palavra) values ('preconiza');
 insert into palavras(palavra) values ('predestinem');
 insert into palavras(palavra) values ('predicasses');
 insert into palavras(palavra) values ('predicasseis');
 insert into palavras(palavra) values ('predigais');
 insert into palavras(palavra) values ('predispunhas');
 insert into palavras(palavra) values ('predispo');
 insert into palavras(palavra) values ('predissestes');
 insert into palavras(palavra) values ('preencha');
 insert into palavras(palavra) values ('preenchem');
 insert into palavras(palavra) values ('preenchesse');
 insert into palavras(palavra) values ('preferecial');
 insert into palavras(palavra) values ('preferimo');
 insert into palavras(palavra) values ('preferirmos');
 insert into palavras(palavra) values ('preferisses');
 insert into palavras(palavra) values ('prefigurem');
 insert into palavras(palavra) values ('pregueares');
 insert into palavras(palavra) values ('preguinhos');
 insert into palavras(palavra) values ('preguicaram');
 insert into palavras(palavra) values ('pregavamos');
 insert into palavras(palavra) values ('prejudicamo');
 insert into palavras(palavra) values ('preludio');
 insert into palavras(palavra) values ('premiardes');
 insert into palavras(palavra) values ('premiaremos');
 insert into palavras(palavra) values ('premiemo');
 insert into palavras(palavra) values ('prensarias');
 insert into palavras(palavra) values ('preocupando');
 insert into palavras(palavra) values ('preocuparias');
 insert into palavras(palavra) values ('preocupavam');
 insert into palavras(palavra) values ('preporao');
 insert into palavras(palavra) values ('prepositiva');
 insert into palavras(palavra) values ('prerrogativa');
 insert into palavras(palavra) values ('prescritas');
 insert into palavras(palavra) values ('presenciaria');
 insert into palavras(palavra) values ('presentearam');
 insert into palavras(palavra) values ('preservariam');
 insert into palavras(palavra) values ('preservem');
 insert into palavras(palavra) values ('presidiam');
 insert into palavras(palavra) values ('presidirias');
 insert into palavras(palavra) values ('pressentimos');
 insert into palavras(palavra) values ('pressentindo');
 insert into palavras(palavra) values ('pressentiras');
 insert into palavras(palavra) values ('pressionarem');
 insert into palavras(palavra) values ('pressionasse');
 insert into palavras(palavra) values ('pressupordes');
 insert into palavras(palavra) values ('pressuposto');
 insert into palavras(palavra) values ('prestigiarmo');
 insert into palavras(palavra) values ('prestigiavas');
 insert into palavras(palavra) values ('presumamos');
 insert into palavras(palavra) values ('pretendemos');
 insert into palavras(palavra) values ('pretendia');
 insert into palavras(palavra) values ('pretextado');
 insert into palavras(palavra) values ('pretexte');
 insert into palavras(palavra) values ('prevalecas');
 insert into palavras(palavra) values ('prevaricou');
 insert into palavras(palavra) values ('preveniremo');
 insert into palavras(palavra) values ('previmos');
 insert into palavras(palavra) values ('preambulos');
 insert into palavras(palavra) values ('primeira');
 insert into palavras(palavra) values ('principesca');
 insert into palavras(palavra) values ('principiavam');
 insert into palavras(palavra) values ('privares');
 insert into palavras(palavra) values ('privativo');
 insert into palavras(palavra) values ('privilegiemo');
 insert into palavras(palavra) values ('probabilista');
 insert into palavras(palavra) values ('probidades');
 insert into palavras(palavra) values ('procederas');
 insert into palavras(palavra) values ('procedurais');
 insert into palavras(palavra) values ('processardes');
 insert into palavras(palavra) values ('processarias');
 insert into palavras(palavra) values ('proclamados');
 insert into palavras(palavra) values ('procriaremos');
 insert into palavras(palavra) values ('procriara');
 insert into palavras(palavra) values ('procurarao');
 insert into palavras(palavra) values ('procurareis');
 insert into palavras(palavra) values ('prodigalizar');
 insert into palavras(palavra) values ('produzias');
 insert into palavras(palavra) values ('produziamos');
 insert into palavras(palavra) values ('profanes');
 insert into palavras(palavra) values ('profanou');
 insert into palavras(palavra) values ('proferimos');
 insert into palavras(palavra) values ('professai');
 insert into palavras(palavra) values ('professar');
 insert into palavras(palavra) values ('profetizar');
 insert into palavras(palavra) values ('profetizou');
 insert into palavras(palavra) values ('proibicoes');
 insert into palavras(palavra) values ('projetaras');
 insert into palavras(palavra) values ('projetasse');
 insert into palavras(palavra) values ('prolifero');
 insert into palavras(palavra) values ('prolifera');
 insert into palavras(palavra) values ('prolongamos');
 insert into palavras(palavra) values ('promanados');
 insert into palavras(palavra) values ('prometera');
 insert into palavras(palavra) values ('prometerdes');
 insert into palavras(palavra) values ('promissoria');
 insert into palavras(palavra) values ('promulgardes');
 insert into palavras(palavra) values ('promulgas');
 insert into palavras(palavra) values ('prontifica');
 insert into palavras(palavra) values ('prontificara');
 insert into palavras(palavra) values ('prontuarios');
 insert into palavras(palavra) values ('pronunciavas');
 insert into palavras(palavra) values ('pronunciemo');
 insert into palavras(palavra) values ('pronuncias');
 insert into palavras(palavra) values ('propagas');
 insert into palavras(palavra) values ('propagou');
 insert into palavras(palavra) values ('propalam');
 insert into palavras(palavra) values ('propalarem');
 insert into palavras(palavra) values ('propordes');
 insert into palavras(palavra) values ('propulsemo');
 insert into palavras(palavra) values ('prorrogados');
 insert into palavras(palavra) values ('prorrogaste');
 insert into palavras(palavra) values ('prospectaras');
 insert into palavras(palavra) values ('prosperaras');
 insert into palavras(palavra) values ('prosperardes');
 insert into palavras(palavra) values ('prosternarmo');
 insert into palavras(palavra) values ('prosternas');
 insert into palavras(palavra) values ('prostituirei');
 insert into palavras(palavra) values ('prostituiria');
 insert into palavras(palavra) values ('protelara');
 insert into palavras(palavra) values ('protelares');
 insert into palavras(palavra) values ('protelavamos');
 insert into palavras(palavra) values ('proteina');
 insert into palavras(palavra) values ('provares');
 insert into palavras(palavra) values ('provariam');
 insert into palavras(palavra) values ('provarmo');
 insert into palavras(palavra) values ('provastes');
 insert into palavras(palavra) values ('proveitosa');
 insert into palavras(palavra) values ('proveriamos');
 insert into palavras(palavra) values ('providencia');
 insert into palavras(palavra) values ('provindos');
 insert into palavras(palavra) values ('proviriam');
 insert into palavras(palavra) values ('provocado');
 insert into palavras(palavra) values ('provocamo');
 insert into palavras(palavra) values ('provocarao');
 insert into palavras(palavra) values ('provocasse');
 insert into palavras(palavra) values ('provocavas');
 insert into palavras(palavra) values ('prudentes');
 insert into palavras(palavra) values ('profugas');
 insert into palavras(palavra) values ('prosperas');
 insert into palavras(palavra) values ('psicologicas');
 insert into palavras(palavra) values ('psicopata');
 insert into palavras(palavra) values ('pudessem');
 insert into palavras(palavra) values ('pulariam');
 insert into palavras(palavra) values ('pulastes');
 insert into palavras(palavra) values ('pulseamo');
 insert into palavras(palavra) values ('pulularemo');
 insert into palavras(palavra) values ('pulularao');
 insert into palavras(palavra) values ('pululemos');
 insert into palavras(palavra) values ('pulverizado');
 insert into palavras(palavra) values ('pulverizasse');
 insert into palavras(palavra) values ('puniremos');
 insert into palavras(palavra) values ('purgasse');
 insert into palavras(palavra) values ('purgatorio');
 insert into palavras(palavra) values ('purificado');
 insert into palavras(palavra) values ('purificarem');
 insert into palavras(palavra) values ('pantanos');
 insert into palavras(palavra) values ('pendulos');
 insert into palavras(palavra) values ('qualificado');
 insert into palavras(palavra) values ('qualificarem');
 insert into palavras(palavra) values ('quantidade');
 insert into palavras(palavra) values ('quartzolito');
 insert into palavras(palavra) values ('quebrara');
 insert into palavras(palavra) values ('quedarmos');
 insert into palavras(palavra) values ('quedariamos');
 insert into palavras(palavra) values ('queimarieis');
 insert into palavras(palavra) values ('quererem');
 insert into palavras(palavra) values ('quereriamos');
 insert into palavras(palavra) values ('quimericas');
 insert into palavras(palavra) values ('quitassem');
 insert into palavras(palavra) values ('quixotesca');
 insert into palavras(palavra) values ('quixotescas');
 insert into palavras(palavra) values ('rabiscastes');
 insert into palavras(palavra) values ('rabisque');
 insert into palavras(palavra) values ('raciocinarao');
 insert into palavras(palavra) values ('racionaremo');
 insert into palavras(palavra) values ('radicarei');
 insert into palavras(palavra) values ('radiquemos');
 insert into palavras(palavra) values ('radiavamos');
 insert into palavras(palavra) values ('ralaremos');
 insert into palavras(palavra) values ('ralariam');
 insert into palavras(palavra) values ('ralhareis');
 insert into palavras(palavra) values ('ralasseis');
 insert into palavras(palavra) values ('ramificamo');
 insert into palavras(palavra) values ('ramificareis');
 insert into palavras(palavra) values ('rancoroso');
 insert into palavras(palavra) values ('rangeremos');
 insert into palavras(palavra) values ('rangermo');
 insert into palavras(palavra) values ('raptaremos');
 insert into palavras(palavra) values ('raptaria');
 insert into palavras(palavra) values ('raptavamos');
 insert into palavras(palavra) values ('raquitico');
 insert into palavras(palavra) values ('rareareis');
 insert into palavras(palavra) values ('rarearemos');
 insert into palavras(palavra) values ('rarefizeras');
 insert into palavras(palavra) values ('raspareis');
 insert into palavras(palavra) values ('rasparao');
 insert into palavras(palavra) values ('raspasse');
 insert into palavras(palavra) values ('rastejai');
 insert into palavras(palavra) values ('rastejasseis');
 insert into palavras(palavra) values ('rastilhos');
 insert into palavras(palavra) values ('rastrear');
 insert into palavras(palavra) values ('rastreasse');
 insert into palavras(palavra) values ('rasurardes');
 insert into palavras(palavra) values ('rasurareis');
 insert into palavras(palavra) values ('rasuraremos');
 insert into palavras(palavra) values ('rateamos');
 insert into palavras(palavra) values ('ratificai');
 insert into palavras(palavra) values ('ratificando');
 insert into palavras(palavra) values ('ratificaste');
 insert into palavras(palavra) values ('ratificavam');
 insert into palavras(palavra) values ('reabasteceis');
 insert into palavras(palavra) values ('reabilitaras');
 insert into palavras(palavra) values ('reabramo');
 insert into palavras(palavra) values ('reabriras');
 insert into palavras(palavra) values ('reabrisse');
 insert into palavras(palavra) values ('reabsorcoes');
 insert into palavras(palavra) values ('readmissoes');
 insert into palavras(palavra) values ('readmitimos');
 insert into palavras(palavra) values ('readmitir');
 insert into palavras(palavra) values ('readmitirmos');
 insert into palavras(palavra) values ('readmitisses');
 insert into palavras(palavra) values ('reagirias');
 insert into palavras(palavra) values ('reajusta');
 insert into palavras(palavra) values ('reajustado');
 insert into palavras(palavra) values ('reajustariam');
 insert into palavras(palavra) values ('realimenta');
 insert into palavras(palavra) values ('realizarao');
 insert into palavras(palavra) values ('realizemo');
 insert into palavras(palavra) values ('realcara');
 insert into palavras(palavra) values ('realcareis');
 insert into palavras(palavra) values ('rearrumarao');
 insert into palavras(palavra) values ('rearrumeis');
 insert into palavras(palavra) values ('reassumiam');
 insert into palavras(palavra) values ('reatemos');
 insert into palavras(palavra) values ('reativacoes');
 insert into palavras(palavra) values ('reavaliasses');
 insert into palavras(palavra) values ('reaveres');
 insert into palavras(palavra) values ('reavivemos');
 insert into palavras(palavra) values ('rebaixardes');
 insert into palavras(palavra) values ('rebaixareis');
 insert into palavras(palavra) values ('rebelarem');
 insert into palavras(palavra) values ('rebentaras');
 insert into palavras(palavra) values ('rebentaremo');
 insert into palavras(palavra) values ('rebentassem');
 insert into palavras(palavra) values ('rebentacoes');
 insert into palavras(palavra) values ('rebitaremos');
 insert into palavras(palavra) values ('rebitasseis');
 insert into palavras(palavra) values ('rebitaveis');
 insert into palavras(palavra) values ('rebocariamos');
 insert into palavras(palavra) values ('rebocaste');
 insert into palavras(palavra) values ('rebrilha');
 insert into palavras(palavra) values ('rebrilhava');
 insert into palavras(palavra) values ('recadastro');
 insert into palavras(palavra) values ('recaindo');
 insert into palavras(palavra) values ('recalcarem');
 insert into palavras(palavra) values ('recalcarias');
 insert into palavras(palavra) values ('recalcarieis');
 insert into palavras(palavra) values ('recalcasses');
 insert into palavras(palavra) values ('recalculai');
 insert into palavras(palavra) values ('recalibrado');
 insert into palavras(palavra) values ('recapturamos');
 insert into palavras(palavra) values ('recarregava');
 insert into palavras(palavra) values ('recaisse');
 insert into palavras(palavra) values ('recearas');
 insert into palavras(palavra) values ('recebera');
 insert into palavras(palavra) values ('receberas');
 insert into palavras(palavra) values ('receitarias');
 insert into palavras(palavra) values ('recenseareis');
 insert into palavras(palavra) values ('recensearias');
 insert into palavras(palavra) values ('recentissima');
 insert into palavras(palavra) values ('receptaremos');
 insert into palavras(palavra) values ('receptores');
 insert into palavras(palavra) values ('rechacarieis');
 insert into palavras(palavra) values ('rechearia');
 insert into palavras(palavra) values ('recheiem');
 insert into palavras(palavra) values ('recitasse');
 insert into palavras(palavra) values ('reclamos');
 insert into palavras(palavra) values ('reclinando');
 insert into palavras(palavra) values ('reclinaremo');
 insert into palavras(palavra) values ('recobrar');
 insert into palavras(palavra) values ('recobrirmos');
 insert into palavras(palavra) values ('recomendais');
 insert into palavras(palavra) values ('recomendamo');
 insert into palavras(palavra) values ('recomendaste');
 insert into palavras(palavra) values ('recomendo');
 insert into palavras(palavra) values ('reconduz');
 insert into palavras(palavra) values ('reconectais');
 insert into palavras(palavra) values ('reconectam');
 insert into palavras(palavra) values ('reconectamos');
 insert into palavras(palavra) values ('reconectemos');
 insert into palavras(palavra) values ('reconfortado');
 insert into palavras(palavra) values ('reconquistem');
 insert into palavras(palavra) values ('reconquisto');
 insert into palavras(palavra) values ('reconstroem');
 insert into palavras(palavra) values ('recordassem');
 insert into palavras(palavra) values ('recordaveis');
 insert into palavras(palavra) values ('recortaria');
 insert into palavras(palavra) values ('recortei');
 insert into palavras(palavra) values ('recortavamos');
 insert into palavras(palavra) values ('recriarmos');
 insert into palavras(palavra) values ('recriemo');
 insert into palavras(palavra) values ('recuperamo');
 insert into palavras(palavra) values ('recuperava');
 insert into palavras(palavra) values ('recuperei');
 insert into palavras(palavra) values ('redecorastes');
 insert into palavras(palavra) values ('redencao');
 insert into palavras(palavra) values ('redigitai');
 insert into palavras(palavra) values ('redimais');
 insert into palavras(palavra) values ('redirecionam');
 insert into palavras(palavra) values ('redisparara');
 insert into palavras(palavra) values ('redobrardes');
 insert into palavras(palavra) values ('redobravam');
 insert into palavras(palavra) values ('reduzires');
 insert into palavras(palavra) values ('reduzira');
 insert into palavras(palavra) values ('reeditas');
 insert into palavras(palavra) values ('reediteis');
 insert into palavras(palavra) values ('reencarnaria');
 insert into palavras(palavra) values ('reencarnara');
 insert into palavras(palavra) values ('reencontramo');
 insert into palavras(palavra) values ('reencontrou');
 insert into palavras(palavra) values ('reengajes');
 insert into palavras(palavra) values ('reescrevamos');
 insert into palavras(palavra) values ('reescreves');
 insert into palavras(palavra) values ('reescrita');
 insert into palavras(palavra) values ('reexaminamo');
 insert into palavras(palavra) values ('reexaminares');
 insert into palavras(palavra) values ('reexpedirmos');
 insert into palavras(palavra) values ('reexpecais');
 insert into palavras(palavra) values ('reexpecamo');
 insert into palavras(palavra) values ('refarieis');
 insert into palavras(palavra) values ('referencia');
 insert into palavras(palavra) values ('referendamo');
 insert into palavras(palavra) values ('referendarem');
 insert into palavras(palavra) values ('referendas');
 insert into palavras(palavra) values ('referendeis');
 insert into palavras(palavra) values ('referendes');
 insert into palavras(palavra) values ('referveis');
 insert into palavras(palavra) values ('refervera');
 insert into palavras(palavra) values ('referveriam');
 insert into palavras(palavra) values ('refinamos');
 insert into palavras(palavra) values ('refinariamos');
 insert into palavras(palavra) values ('refineis');
 insert into palavras(palavra) values ('refletirieis');
 insert into palavras(palavra) values ('refletiu');
 insert into palavras(palavra) values ('reflorescera');
 insert into palavras(palavra) values ('reformam');
 insert into palavras(palavra) values ('reformulares');
 insert into palavras(palavra) values ('reforcarieis');
 insert into palavras(palavra) values ('refratavam');
 insert into palavras(palavra) values ('refreava');
 insert into palavras(palavra) values ('refrescarias');
 insert into palavras(palavra) values ('refresque');
 insert into palavras(palavra) values ('refrigeraria');
 insert into palavras(palavra) values ('refugadas');
 insert into palavras(palavra) values ('refugiavamos');
 insert into palavras(palavra) values ('refutado');
 insert into palavras(palavra) values ('refutaras');
 insert into palavras(palavra) values ('regalavam');
 insert into palavras(palavra) values ('regatearam');
 insert into palavras(palavra) values ('regatearas');
 insert into palavras(palavra) values ('regateiem');
 insert into palavras(palavra) values ('regeneraste');
 insert into palavras(palavra) values ('regerara');
 insert into palavras(palavra) values ('regestes');
 insert into palavras(palavra) values ('regimentais');
 insert into palavras(palavra) values ('registrarao');
 insert into palavras(palavra) values ('registras');
 insert into palavras(palavra) values ('regrares');
 insert into palavras(palavra) values ('regravaras');
 insert into palavras(palavra) values ('regravaremo');
 insert into palavras(palavra) values ('regressai');
 insert into palavras(palavra) values ('regulamentas');
 insert into palavras(palavra) values ('regurgitava');
 insert into palavras(palavra) values ('reiniciam');
 insert into palavras(palavra) values ('reiniciem');
 insert into palavras(palavra) values ('reintegramos');
 insert into palavras(palavra) values ('reinvestiria');
 insert into palavras(palavra) values ('reiterarias');
 insert into palavras(palavra) values ('reivindicai');
 insert into palavras(palavra) values ('rejubilamo');
 insert into palavras(palavra) values ('rejuntariam');
 insert into palavras(palavra) values ('rejuntara');
 insert into palavras(palavra) values ('rejuvenescei');
 insert into palavras(palavra) values ('relacione');
 insert into palavras(palavra) values ('relampejamo');
 insert into palavras(palavra) values ('relampejara');
 insert into palavras(palavra) values ('relataste');
 insert into palavras(palavra) values ('relativizo');
 insert into palavras(palavra) values ('relegaria');
 insert into palavras(palavra) values ('releguei');
 insert into palavras(palavra) values ('relegareis');
 insert into palavras(palavra) values ('relembra');
 insert into palavras(palavra) values ('relembrareis');
 insert into palavras(palavra) values ('relembrara');
 insert into palavras(palavra) values ('relembre');
 insert into palavras(palavra) values ('releriam');
 insert into palavras(palavra) values ('relessem');
 insert into palavras(palavra) values ('religara');
 insert into palavras(palavra) values ('relincharei');
 insert into palavras(palavra) values ('relinchareis');
 insert into palavras(palavra) values ('relutarao');
 insert into palavras(palavra) values ('relessemos');
 insert into palavras(palavra) values ('remanejarao');
 insert into palavras(palavra) values ('remanejastes');
 insert into palavras(palavra) values ('remanesces');
 insert into palavras(palavra) values ('remansarao');
 insert into palavras(palavra) values ('remarcares');
 insert into palavras(palavra) values ('remataremo');
 insert into palavras(palavra) values ('remediareis');
 insert into palavras(palavra) values ('rememorareis');
 insert into palavras(palavra) values ('remendando');
 insert into palavras(palavra) values ('remendos');
 insert into palavras(palavra) values ('remeteres');
 insert into palavras(palavra) values ('remexera');
 insert into palavras(palavra) values ('remodelariam');
 insert into palavras(palavra) values ('remodelemos');
 insert into palavras(palavra) values ('removeriam');
 insert into palavras(palavra) values ('remoessemos');
 insert into palavras(palavra) values ('remunerares');
 insert into palavras(palavra) values ('renasceria');
 insert into palavras(palavra) values ('renderiza');
 insert into palavras(palavra) values ('rendilharao');
 insert into palavras(palavra) values ('rendilhe');
 insert into palavras(palavra) values ('rendimentos');
 insert into palavras(palavra) values ('rendicao');
 insert into palavras(palavra) values ('renegamo');
 insert into palavras(palavra) values ('renomeado');
 insert into palavras(palavra) values ('renomeamo');
 insert into palavras(palavra) values ('renomeareis');
 insert into palavras(palavra) values ('renomearmos');
 insert into palavras(palavra) values ('renomearao');
 insert into palavras(palavra) values ('renovasseis');
 insert into palavras(palavra) values ('renumeraram');
 insert into palavras(palavra) values ('renuncie');
 insert into palavras(palavra) values ('reocupem');
 insert into palavras(palavra) values ('repartirieis');
 insert into palavras(palavra) values ('repartisses');
 insert into palavras(palavra) values ('repassai');
 insert into palavras(palavra) values ('repassarmos');
 insert into palavras(palavra) values ('repassaras');
 insert into palavras(palavra) values ('repassassem');
 insert into palavras(palavra) values ('repassaveis');
 insert into palavras(palavra) values ('repatriarem');
 insert into palavras(palavra) values ('repatriavas');
 insert into palavras(palavra) values ('repelirmos');
 insert into palavras(palavra) values ('repelira');
 insert into palavras(palavra) values ('repeliriamos');
 insert into palavras(palavra) values ('repensamo');
 insert into palavras(palavra) values ('repercutais');
 insert into palavras(palavra) values ('repetido');
 insert into palavras(palavra) values ('repliquemos');
 insert into palavras(palavra) values ('represamos');
 insert into palavras(palavra) values ('represarieis');
 insert into palavras(palavra) values ('representes');
 insert into palavras(palavra) values ('representa');
 insert into palavras(palavra) values ('reprisem');
 insert into palavras(palavra) values ('reprocessais');
 insert into palavras(palavra) values ('reprodutoras');
 insert into palavras(palavra) values ('reprovavamos');
 insert into palavras(palavra) values ('repudiasse');
 insert into palavras(palavra) values ('repugnais');
 insert into palavras(palavra) values ('repusereis');
 insert into palavras(palavra) values ('reputados');
 insert into palavras(palavra) values ('reputavam');
 insert into palavras(palavra) values ('repuxeis');
 insert into palavras(palavra) values ('repunheis');
 insert into palavras(palavra) values ('requebrar');
 insert into palavras(palavra) values ('requebrem');
 insert into palavras(palavra) values ('requeimes');
 insert into palavras(palavra) values ('requentas');
 insert into palavras(palavra) values ('requintem');
 insert into palavras(palavra) values ('requiseras');
 insert into palavras(palavra) values ('requisitara');
 insert into palavras(palavra) values ('requiseramos');
 insert into palavras(palavra) values ('reservavas');
 insert into palavras(palavra) values ('resfolegavas');
 insert into palavras(palavra) values ('resfriasses');
 insert into palavras(palavra) values ('resgatareis');
 insert into palavras(palavra) values ('residido');
 insert into palavras(palavra) values ('residiramos');
 insert into palavras(palavra) values ('resignaremos');
 insert into palavras(palavra) values ('resignarmos');
 insert into palavras(palavra) values ('resignaras');
 insert into palavras(palavra) values ('resignavas');
 insert into palavras(palavra) values ('resolvesseis');
 insert into palavras(palavra) values ('respeitara');
 insert into palavras(palavra) values ('respeitassem');
 insert into palavras(palavra) values ('respeitosos');
 insert into palavras(palavra) values ('respingardes');
 insert into palavras(palavra) values ('respingou');
 insert into palavras(palavra) values ('resplandecei');
 insert into palavras(palavra) values ('resplandeceu');
 insert into palavras(palavra) values ('respondamos');
 insert into palavras(palavra) values ('responderem');
 insert into palavras(palavra) values ('respondidos');
 insert into palavras(palavra) values ('ressaltara');
 insert into palavras(palavra) values ('ressaltares');
 insert into palavras(palavra) values ('ressaltariam');
 insert into palavras(palavra) values ('ressaltasse');
 insert into palavras(palavra) values ('ressalva');
 insert into palavras(palavra) values ('ressalvam');
 insert into palavras(palavra) values ('ressalvaremo');
 insert into palavras(palavra) values ('ressarcimos');
 insert into palavras(palavra) values ('ressarcirmo');
 insert into palavras(palavra) values ('ressecado');
 insert into palavras(palavra) values ('ressegurasse');
 insert into palavras(palavra) values ('ressequirmos');
 insert into palavras(palavra) values ('ressurjas');
 insert into palavras(palavra) values ('ressuscitai');
 insert into palavras(palavra) values ('restaras');
 insert into palavras(palavra) values ('restaurara');
 insert into palavras(palavra) values ('restaurares');
 insert into palavras(palavra) values ('restaurariam');
 insert into palavras(palavra) values ('restaurava');
 insert into palavras(palavra) values ('restringir');
 insert into palavras(palavra) values ('restricoes');
 insert into palavras(palavra) values ('resultasse');
 insert into palavras(palavra) values ('resumimos');
 insert into palavras(palavra) values ('resvalaras');
 insert into palavras(palavra) values ('resvalaremo');
 insert into palavras(palavra) values ('retaguardas');
 insert into palavras(palavra) values ('retalharas');
 insert into palavras(palavra) values ('retemperes');
 insert into palavras(palavra) values ('retesarem');
 insert into palavras(palavra) values ('retesaste');
 insert into palavras(palavra) values ('retificamos');
 insert into palavras(palavra) values ('retificavas');
 insert into palavras(palavra) values ('retinirieis');
 insert into palavras(palavra) values ('retinissem');
 insert into palavras(palavra) values ('retomaste');
 insert into palavras(palavra) values ('retomeis');
 insert into palavras(palavra) values ('retorcem');
 insert into palavras(palavra) values ('retornavas');
 insert into palavras(palavra) values ('retraiamos');
 insert into palavras(palavra) values ('retratados');
 insert into palavras(palavra) values ('retratando');
 insert into palavras(palavra) values ('retracadas');
 insert into palavras(palavra) values ('retracaste');
 insert into palavras(palavra) values ('retraissem');
 insert into palavras(palavra) values ('retribuidos');
 insert into palavras(palavra) values ('retribuieis');
 insert into palavras(palavra) values ('retrocedas');
 insert into palavras(palavra) values ('retrocedeis');
 insert into palavras(palavra) values ('retrocederam');
 insert into palavras(palavra) values ('retroegem');
 insert into palavras(palavra) values ('retumbaram');
 insert into palavras(palavra) values ('retumbastes');
 insert into palavras(palavra) values ('reutilizamo');
 insert into palavras(palavra) values ('reutilizavam');
 insert into palavras(palavra) values ('reutilizo');
 insert into palavras(palavra) values ('reverberara');
 insert into palavras(palavra) values ('revertem');
 insert into palavras(palavra) values ('reverteu');
 insert into palavras(palavra) values ('revidaveis');
 insert into palavras(palavra) values ('revigorariam');
 insert into palavras(palavra) values ('reviraremo');
 insert into palavras(palavra) values ('revirara');
 insert into palavras(palavra) values ('revirarieis');
 insert into palavras(palavra) values ('reviseis');
 insert into palavras(palavra) values ('revivais');
 insert into palavras(palavra) values ('revivesceria');
 insert into palavras(palavra) values ('revivescamos');
 insert into palavras(palavra) values ('revivesco');
 insert into palavras(palavra) values ('revogasseis');
 insert into palavras(palavra) values ('revolucionem');
 insert into palavras(palavra) values ('revolvemo');
 insert into palavras(palavra) values ('revolverei');
 insert into palavras(palavra) values ('rezastes');
 insert into palavras(palavra) values ('ribombarmo');
 insert into palavras(palavra) values ('ribombastes');
 insert into palavras(palavra) values ('ribombavamos');
 insert into palavras(palavra) values ('ricocheteiem');
 insert into palavras(palavra) values ('ridicularize');
 insert into palavras(palavra) values ('rimaremos');
 insert into palavras(palavra) values ('rimareis');
 insert into palavras(palavra) values ('riscaras');
 insert into palavras(palavra) values ('riscaramos');
 insert into palavras(palavra) values ('robustecieis');
 insert into palavras(palavra) values ('rodeaste');
 insert into palavras(palavra) values ('roldanas');
 insert into palavras(palavra) values ('romanizarao');
 insert into palavras(palavra) values ('romantizais');
 insert into palavras(palavra) values ('romantizei');
 insert into palavras(palavra) values ('romantizo');
 insert into palavras(palavra) values ('rompamos');
 insert into palavras(palavra) values ('rompemos');
 insert into palavras(palavra) values ('rompidos');
 insert into palavras(palavra) values ('romazeiras');
 insert into palavras(palavra) values ('rosnaremo');
 insert into palavras(palavra) values ('rotacionara');
 insert into palavras(palavra) values ('rotacionemos');
 insert into palavras(palavra) values ('roteaveis');
 insert into palavras(palavra) values ('rotularas');
 insert into palavras(palavra) values ('roubaria');
 insert into palavras(palavra) values ('rouquejara');
 insert into palavras(palavra) values ('rouquejemo');
 insert into palavras(palavra) values ('rocastes');
 insert into palavras(palavra) values ('rocaramos');
 insert into palavras(palavra) values ('rocasseis');
 insert into palavras(palavra) values ('ruborizarmo');
 insert into palavras(palavra) values ('ruborizastes');
 insert into palavras(palavra) values ('rubricando');
 insert into palavras(palavra) values ('rugidoras');
 insert into palavras(palavra) values ('ruminantes');
 insert into palavras(palavra) values ('ruminavas');
 insert into palavras(palavra) values ('sabatinaras');
 insert into palavras(palavra) values ('sabatinarmos');
 insert into palavras(palavra) values ('saberemo');
 insert into palavras(palavra) values ('sacaremos');
 insert into palavras(palavra) values ('sacolejavas');
 insert into palavras(palavra) values ('sacramentemo');
 insert into palavras(palavra) values ('sacrificaras');
 insert into palavras(palavra) values ('sacrilegos');
 insert into palavras(palavra) values ('sacudais');
 insert into palavras(palavra) values ('sacudimos');
 insert into palavras(palavra) values ('sacavamos');
 insert into palavras(palavra) values ('safardes');
 insert into palavras(palavra) values ('sagrares');
 insert into palavras(palavra) values ('sagrarmos');
 insert into palavras(palavra) values ('salgarias');
 insert into palavras(palavra) values ('salientais');
 insert into palavras(palavra) values ('salientem');
 insert into palavras(palavra) values ('salivariamos');
 insert into palavras(palavra) values ('salpicando');
 insert into palavras(palavra) values ('salsicharias');
 insert into palavras(palavra) values ('saltarem');
 insert into palavras(palavra) values ('saltasse');
 insert into palavras(palavra) values ('saltearemo');
 insert into palavras(palavra) values ('salvaguardar');
 insert into palavras(palavra) values ('salvareis');
 insert into palavras(palavra) values ('salvares');
 insert into palavras(palavra) values ('salvacoes');
 insert into palavras(palavra) values ('sanatorio');
 insert into palavras(palavra) values ('sancionado');
 insert into palavras(palavra) values ('sancionaria');
 insert into palavras(palavra) values ('sancionarmos');
 insert into palavras(palavra) values ('saneardes');
 insert into palavras(palavra) values ('sangrarei');
 insert into palavras(palavra) values ('sangrava');
 insert into palavras(palavra) values ('santificavam');
 insert into palavras(palavra) values ('sapecada');
 insert into palavras(palavra) values ('saqueiam');
 insert into palavras(palavra) values ('saracotea');
 insert into palavras(palavra) values ('satirizaram');
 insert into palavras(palavra) values ('satirizaras');
 insert into palavras(palavra) values ('satisfarao');
 insert into palavras(palavra) values ('sazonais');
 insert into palavras(palavra) values ('sazonarmos');
 insert into palavras(palavra) values ('sazonavam');
 insert into palavras(palavra) values ('sectaria');
 insert into palavras(palavra) values ('secundarmo');
 insert into palavras(palavra) values ('sedentarias');
 insert into palavras(palavra) values ('sediarias');
 insert into palavras(palavra) values ('seduziras');
 insert into palavras(palavra) values ('segmento');
 insert into palavras(palavra) values ('segredaremo');
 insert into palavras(palavra) values ('segredaras');
 insert into palavras(palavra) values ('segregarmo');
 insert into palavras(palavra) values ('segregacao');
 insert into palavras(palavra) values ('seguindo');
 insert into palavras(palavra) values ('segurasseis');
 insert into palavras(palavra) values ('selariamos');
 insert into palavras(palavra) values ('selecionares');
 insert into palavras(palavra) values ('selecionem');
 insert into palavras(palavra) values ('selecoes');
 insert into palavras(palavra) values ('selareis');
 insert into palavras(palavra) values ('sementeira');
 insert into palavras(palavra) values ('seminais');
 insert into palavras(palavra) values ('sensitivos');
 insert into palavras(palavra) values ('sensualistas');
 insert into palavras(palavra) values ('sentirias');
 insert into palavras(palavra) values ('sentiras');
 insert into palavras(palavra) values ('sentiriamos');
 insert into palavras(palavra) values ('separatas');
 insert into palavras(palavra) values ('separatismo');
 insert into palavras(palavra) values ('separatista');
 insert into palavras(palavra) values ('separatistas');
 insert into palavras(palavra) values ('sepultarem');
 insert into palavras(palavra) values ('sepultaste');
 insert into palavras(palavra) values ('sequenciarao');
 insert into palavras(palavra) values ('serelepe');
 insert into palavras(palavra) values ('serenata');
 insert into palavras(palavra) values ('seriarmo');
 insert into palavras(palavra) values ('serpejarem');
 insert into palavras(palavra) values ('serrinha');
 insert into palavras(palavra) values ('servirmos');
 insert into palavras(palavra) values ('serziram');
 insert into palavras(palavra) values ('serzirieis');
 insert into palavras(palavra) values ('serzisseis');
 insert into palavras(palavra) values ('setoriza');
 insert into palavras(palavra) values ('setorizaras');
 insert into palavras(palavra) values ('seviciareis');
 insert into palavras(palavra) values ('sexagenario');
 insert into palavras(palavra) values ('significaste');
 insert into palavras(palavra) values ('silabados');
 insert into palavras(palavra) values ('silencias');
 insert into palavras(palavra) values ('silabicos');
 insert into palavras(palavra) values ('simbolismos');
 insert into palavras(palavra) values ('simbolizeis');
 insert into palavras(palavra) values ('simpatizes');
 insert into palavras(palavra) values ('simplicidade');
 insert into palavras(palavra) values ('simulemo');
 insert into palavras(palavra) values ('simultaneos');
 insert into palavras(palavra) values ('sinagoga');
 insert into palavras(palavra) values ('sinalizarao');
 insert into palavras(palavra) values ('sincronizais');
 insert into palavras(palavra) values ('sinfonico');
 insert into palavras(palavra) values ('singraste');
 insert into palavras(palavra) values ('singularize');
 insert into palavras(palavra) values ('sintaxes');
 insert into palavras(palavra) values ('sintetizara');
 insert into palavras(palavra) values ('sintetizou');
 insert into palavras(palavra) values ('sintonizamo');
 insert into palavras(palavra) values ('sintonizava');
 insert into palavras(palavra) values ('sintatico');
 insert into palavras(palavra) values ('sismografia');
 insert into palavras(palavra) values ('sobrancelhas');
 insert into palavras(palavra) values ('sobremaneira');
 insert into palavras(palavra) values ('sobreolhamo');
 insert into palavras(palavra) values ('sobrepujara');
 insert into palavras(palavra) values ('sobrescrita');
 insert into palavras(palavra) values ('sobresteve');
 insert into palavras(palavra) values ('sobreviva');
 insert into palavras(palavra) values ('sociologos');
 insert into palavras(palavra) values ('sofismasse');
 insert into palavras(palavra) values ('sofismava');
 insert into palavras(palavra) values ('sofisticada');
 insert into palavras(palavra) values ('sofressemos');
 insert into palavras(palavra) values ('sofriveis');
 insert into palavras(palavra) values ('sofrivel');
 insert into palavras(palavra) values ('solapariam');
 insert into palavras(palavra) values ('solapara');
 insert into palavras(palavra) values ('soldassem');
 insert into palavras(palavra) values ('solenissimas');
 insert into palavras(palavra) values ('soletrardes');
 insert into palavras(palavra) values ('soletraremos');
 insert into palavras(palavra) values ('soletraramos');
 insert into palavras(palavra) values ('soletrareis');
 insert into palavras(palavra) values ('soletrasseis');
 insert into palavras(palavra) values ('solicitada');
 insert into palavras(palavra) values ('solicitado');
 insert into palavras(palavra) values ('solicitando');
 insert into palavras(palavra) values ('solicitem');
 insert into palavras(palavra) values ('solucaste');
 insert into palavras(palavra) values ('sombreado');
 insert into palavras(palavra) values ('sombrinha');
 insert into palavras(palavra) values ('somaramos');
 insert into palavras(palavra) values ('sondares');
 insert into palavras(palavra) values ('sondarmos');
 insert into palavras(palavra) values ('sonegariam');
 insert into palavras(palavra) values ('sonegacoes');
 insert into palavras(palavra) values ('sonorizarao');
 insert into palavras(palavra) values ('sonorizei');
 insert into palavras(palavra) values ('sonorizemo');
 insert into palavras(palavra) values ('sopraveis');
 insert into palavras(palavra) values ('sorrindo');
 insert into palavras(palavra) values ('sorrisse');
 insert into palavras(palavra) values ('sorteara');
 insert into palavras(palavra) values ('sortearemo');
 insert into palavras(palavra) values ('sortilegios');
 insert into palavras(palavra) values ('sortisses');
 insert into palavras(palavra) values ('sossegardes');
 insert into palavras(palavra) values ('sossobras');
 insert into palavras(palavra) values ('sossobrava');
 insert into palavras(palavra) values ('sossobraveis');
 insert into palavras(palavra) values ('sovarmos');
 insert into palavras(palavra) values ('sovaveis');
 insert into palavras(palavra) values ('sozinhas');
 insert into palavras(palavra) values ('socobrando');
 insert into palavras(palavra) values ('subdividais');
 insert into palavras(palavra) values ('subdivide');
 insert into palavras(palavra) values ('subdivididos');
 insert into palavras(palavra) values ('subdividiras');
 insert into palavras(palavra) values ('subentendais');
 insert into palavras(palavra) values ('subentendamo');
 insert into palavras(palavra) values ('subjuntiva');
 insert into palavras(palavra) values ('submergiu');
 insert into palavras(palavra) values ('submergiamos');
 insert into palavras(palavra) values ('submeterem');
 insert into palavras(palavra) values ('submetes');
 insert into palavras(palavra) values ('submetesse');
 insert into palavras(palavra) values ('subordinar');
 insert into palavras(palavra) values ('subordinarei');
 insert into palavras(palavra) values ('subordineis');
 insert into palavras(palavra) values ('subornaremos');
 insert into palavras(palavra) values ('subornem');
 insert into palavras(palavra) values ('subscrevamos');
 insert into palavras(palavra) values ('subscrevido');
 insert into palavras(palavra) values ('subsequentes');
 insert into palavras(palavra) values ('subsidiado');
 insert into palavras(palavra) values ('substancia');
 insert into palavras(palavra) values ('substituira');
 insert into palavras(palavra) values ('subterraneo');
 insert into palavras(palavra) values ('subtraireis');
 insert into palavras(palavra) values ('subvencoes');
 insert into palavras(palavra) values ('subverteras');
 insert into palavras(palavra) values ('subvertia');
 insert into palavras(palavra) values ('sucessiva');
 insert into palavras(palavra) values ('sufocasse');
 insert into palavras(palavra) values ('sufragar');
 insert into palavras(palavra) values ('sufragasseis');
 insert into palavras(palavra) values ('sugeridas');
 insert into palavras(palavra) values ('suicidardes');
 insert into palavras(palavra) values ('suicideis');
 insert into palavras(palavra) values ('sujeitarem');
 insert into palavras(palavra) values ('sujeitassem');
 insert into palavras(palavra) values ('sulcarias');
 insert into palavras(palavra) values ('sulfuricos');
 insert into palavras(palavra) values ('superlotamos');
 insert into palavras(palavra) values ('superlotou');
 insert into palavras(palavra) values ('superponhas');
 insert into palavras(palavra) values ('suplantastes');
 insert into palavras(palavra) values ('suplantemos');
 insert into palavras(palavra) values ('suplicarmos');
 insert into palavras(palavra) values ('supliciasse');
 insert into palavras(palavra) values ('suponhais');
 insert into palavras(palavra) values ('supremacia');
 insert into palavras(palavra) values ('suprissem');
 insert into palavras(palavra) values ('surgimentos');
 insert into palavras(palavra) values ('surravas');
 insert into palavras(palavra) values ('surrupiariam');
 insert into palavras(palavra) values ('suspeitamo');
 insert into palavras(palavra) values ('suspeitara');
 insert into palavras(palavra) values ('suspeitemos');
 insert into palavras(palavra) values ('susterei');
 insert into palavras(palavra) values ('suturamo');
 insert into palavras(palavra) values ('suturaremo');
 insert into palavras(palavra) values ('sutureis');
 insert into palavras(palavra) values ('tabelionatos');
 insert into palavras(palavra) values ('tabuletas');
 insert into palavras(palavra) values ('tacariamos');
 insert into palavras(palavra) values ('tacassem');
 insert into palavras(palavra) values ('tacasses');
 insert into palavras(palavra) values ('tacharmo');
 insert into palavras(palavra) values ('tacharmos');
 insert into palavras(palavra) values ('tacasseis');
 insert into palavras(palavra) values ('tagarelices');
 insert into palavras(palavra) values ('talharias');
 insert into palavras(palavra) values ('talharmos');
 insert into palavras(palavra) values ('talhassem');
 insert into palavras(palavra) values ('tamparemo');
 insert into palavras(palavra) values ('tamparamos');
 insert into palavras(palavra) values ('tangencia');
 insert into palavras(palavra) values ('tangenciara');
 insert into palavras(palavra) values ('tangeremos');
 insert into palavras(palavra) values ('tangeramos');
 insert into palavras(palavra) values ('tanquinhos');
 insert into palavras(palavra) values ('taparmos');
 insert into palavras(palavra) values ('tapearamos');
 insert into palavras(palavra) values ('tarifando');
 insert into palavras(palavra) values ('tarifara');
 insert into palavras(palavra) values ('tarifava');
 insert into palavras(palavra) values ('tarifasseis');
 insert into palavras(palavra) values ('tartamudeei');
 insert into palavras(palavra) values ('tateando');
 insert into palavras(palavra) values ('tatuavam');
 insert into palavras(palavra) values ('tatuzinho');
 insert into palavras(palavra) values ('taxariam');
 insert into palavras(palavra) values ('taxasses');
 insert into palavras(palavra) values ('teclaste');
 insert into palavras(palavra) values ('telegrafam');
 insert into palavras(palavra) values ('telepatia');
 insert into palavras(palavra) values ('televisionar');
 insert into palavras(palavra) values ('temperaremos');
 insert into palavras(palavra) values ('temperasse');
 insert into palavras(palavra) values ('tempesteemo');
 insert into palavras(palavra) values ('tencionou');
 insert into palavras(palavra) values ('tendesse');
 insert into palavras(palavra) values ('tendeste');
 insert into palavras(palavra) values ('teologias');
 insert into palavras(palavra) values ('teorizes');
 insert into palavras(palavra) values ('terapeuta');
 insert into palavras(palavra) values ('terapeutas');
 insert into palavras(palavra) values ('terciarios');
 insert into palavras(palavra) values ('terminarei');
 insert into palavras(palavra) values ('termoquimica');
 insert into palavras(palavra) values ('testarem');
 insert into palavras(palavra) values ('testemunhai');
 insert into palavras(palavra) values ('testemunho');
 insert into palavras(palavra) values ('testificares');
 insert into palavras(palavra) values ('testificaste');
 insert into palavras(palavra) values ('tetraedros');
 insert into palavras(palavra) values ('texturas');
 insert into palavras(palavra) values ('teoricos');
 insert into palavras(palavra) values ('tilintavas');
 insert into palavras(palavra) values ('tilintareis');
 insert into palavras(palavra) values ('tilintaveis');
 insert into palavras(palavra) values ('timbrara');
 insert into palavras(palavra) values ('timbraramos');
 insert into palavras(palavra) values ('tipicamente');
 insert into palavras(palavra) values ('tiranizaria');
 insert into palavras(palavra) values ('tiranizemos');
 insert into palavras(palavra) values ('tiritarmo');
 insert into palavras(palavra) values ('titubeio');
 insert into palavras(palavra) values ('tocaiaremos');
 insert into palavras(palavra) values ('tolerastes');
 insert into palavras(palavra) values ('tombadora');
 insert into palavras(palavra) values ('tombaremos');
 insert into palavras(palavra) values ('torcerem');
 insert into palavras(palavra) values ('torneavas');
 insert into palavras(palavra) values ('torneemo');
 insert into palavras(palavra) values ('tornaveis');
 insert into palavras(palavra) values ('torrarem');
 insert into palavras(palavra) values ('tosquiados');
 insert into palavras(palavra) values ('tosquiaras');
 insert into palavras(palavra) values ('tosquiaramos');
 insert into palavras(palavra) values ('totalidade');
 insert into palavras(palavra) values ('tourearmo');
 insert into palavras(palavra) values ('toureava');
 insert into palavras(palavra) values ('trabalhamos');
 insert into palavras(palavra) values ('tracionem');
 insert into palavras(palavra) values ('traduzindo');
 insert into palavras(palavra) values ('traficarmo');
 insert into palavras(palavra) values ('traficasse');
 insert into palavras(palavra) values ('tragares');
 insert into palavras(palavra) values ('trairemos');
 insert into palavras(palavra) values ('trairmos');
 insert into palavras(palavra) values ('trajaremo');
 insert into palavras(palavra) values ('tramitai');
 insert into palavras(palavra) values ('tramitares');
 insert into palavras(palavra) values ('tramitarmo');
 insert into palavras(palavra) values ('trancados');
 insert into palavras(palavra) values ('trancariam');
 insert into palavras(palavra) values ('trancarmos');
 insert into palavras(palavra) values ('trancassemos');
 insert into palavras(palavra) values ('tranquilizai');
 insert into palavras(palavra) values ('transaram');
 insert into palavras(palavra) values ('transcorres');
 insert into palavras(palavra) values ('transcrever');
 insert into palavras(palavra) values ('transcrevias');
 insert into palavras(palavra) values ('transferem');
 insert into palavras(palavra) values ('transferiria');
 insert into palavras(palavra) values ('transferiu');
 insert into palavras(palavra) values ('transgrida');
 insert into palavras(palavra) values ('transijais');
 insert into palavras(palavra) values ('transitorias');
 insert into palavras(palavra) values ('transitorio');
 insert into palavras(palavra) values ('transladarem');
 insert into palavras(palavra) values ('transmudarao');
 insert into palavras(palavra) values ('transmutado');
 insert into palavras(palavra) values ('transmutares');
 insert into palavras(palavra) values ('transponhas');
 insert into palavras(palavra) values ('transporeis');
 insert into palavras(palavra) values ('transporta');
 insert into palavras(palavra) values ('transvia');
 insert into palavras(palavra) values ('trancassemos');
 insert into palavras(palavra) values ('traquejado');
 insert into palavras(palavra) values ('traquinasse');
 insert into palavras(palavra) values ('traquinaste');
 insert into palavras(palavra) values ('traquinemo');
 insert into palavras(palavra) values ('traquinareis');
 insert into palavras(palavra) values ('traqueia');
 insert into palavras(palavra) values ('tratarieis');
 insert into palavras(palavra) values ('traumatizai');
 insert into palavras(palavra) values ('traumaticas');
 insert into palavras(palavra) values ('traumatico');
 insert into palavras(palavra) values ('travastes');
 insert into palavras(palavra) values ('tracaras');
 insert into palavras(palavra) values ('tracasses');
 insert into palavras(palavra) values ('trefilavam');
 insert into palavras(palavra) values ('treinariam');
 insert into palavras(palavra) values ('trepares');
 insert into palavras(palavra) values ('trepasses');
 insert into palavras(palavra) values ('treslermo');
 insert into palavras(palavra) values ('tribulacoes');
 insert into palavras(palavra) values ('tributardes');
 insert into palavras(palavra) values ('trilhados');
 insert into palavras(palavra) values ('trilhariamos');
 insert into palavras(palavra) values ('trincavas');
 insert into palavras(palavra) values ('tripudiai');
 insert into palavras(palavra) values ('tripudiasses');
 insert into palavras(palavra) values ('triturasses');
 insert into palavras(palavra) values ('triunfador');
 insert into palavras(palavra) values ('trocariamos');
 insert into palavras(palavra) values ('trocasseis');
 insert into palavras(palavra) values ('trombetas');
 insert into palavras(palavra) values ('trombavamos');
 insert into palavras(palavra) values ('troteastes');
 insert into palavras(palavra) values ('trouxeras');
 insert into palavras(palavra) values ('trovejemo');
 insert into palavras(palavra) values ('trocasseis');
 insert into palavras(palavra) values ('trucidado');
 insert into palavras(palavra) values ('trucidarmo');
 insert into palavras(palavra) values ('trucidas');
 insert into palavras(palavra) values ('trucidastes');
 insert into palavras(palavra) values ('truncaremo');
 insert into palavras(palavra) values ('truncarmo');
 insert into palavras(palavra) values ('truncaramos');
 insert into palavras(palavra) values ('tubulacao');
 insert into palavras(palavra) values ('tuberculos');
 insert into palavras(palavra) values ('tumultos');
 insert into palavras(palavra) values ('tumultuarei');
 insert into palavras(palavra) values ('tumultuas');
 insert into palavras(palavra) values ('turbaras');
 insert into palavras(palavra) values ('turmalina');
 insert into palavras(palavra) values ('turquesa');
 insert into palavras(palavra) values ('tutelassemos');
 insert into palavras(palavra) values ('ufanavamos');
 insert into palavras(palavra) values ('ultrajes');
 insert into palavras(palavra) values ('ultrapassa');
 insert into palavras(palavra) values ('ultravioleta');
 insert into palavras(palavra) values ('umedecermos');
 insert into palavras(palavra) values ('umedeciam');
 insert into palavras(palavra) values ('umedecas');
 insert into palavras(palavra) values ('unificarmos');
 insert into palavras(palavra) values ('uniriamos');
 insert into palavras(palavra) values ('urbanizava');
 insert into palavras(palavra) values ('urdireis');
 insert into palavras(palavra) values ('usufruais');
 insert into palavras(palavra) values ('usufruas');
 insert into palavras(palavra) values ('usufruirmos');
 insert into palavras(palavra) values ('usurpada');
 insert into palavras(palavra) values ('usurparias');
 insert into palavras(palavra) values ('utilizamo');
 insert into palavras(palavra) values ('utilizares');
 insert into palavras(palavra) values ('utilizemo');
 insert into palavras(palavra) values ('vacilareis');
 insert into palavras(palavra) values ('vacinasseis');
 insert into palavras(palavra) values ('vadeavam');
 insert into palavras(palavra) values ('vagabundeio');
 insert into palavras(palavra) values ('vagiamos');
 insert into palavras(palavra) values ('validariam');
 insert into palavras(palavra) values ('vangloriara');
 insert into palavras(palavra) values ('vangloriaria');
 insert into palavras(palavra) values ('vangloriavam');
 insert into palavras(palavra) values ('vanglorieis');
 insert into palavras(palavra) values ('vanguarda');
 insert into palavras(palavra) values ('vaporizaras');
 insert into palavras(palavra) values ('vaporizaria');
 insert into palavras(palavra) values ('vaporizariam');
 insert into palavras(palavra) values ('vaporizo');
 insert into palavras(palavra) values ('varassem');
 insert into palavras(palavra) values ('varejais');
 insert into palavras(palavra) values ('varejariamos');
 insert into palavras(palavra) values ('variasses');
 insert into palavras(palavra) values ('varreremos');
 insert into palavras(palavra) values ('varrerias');
 insert into palavras(palavra) values ('varreriamos');
 insert into palavras(palavra) values ('vasculharao');
 insert into palavras(palavra) values ('vasculheis');
 insert into palavras(palavra) values ('vasculhes');
 insert into palavras(palavra) values ('vassouradas');
 insert into palavras(palavra) values ('vassouremo');
 insert into palavras(palavra) values ('vaticinamos');
 insert into palavras(palavra) values ('vaticinavam');
 insert into palavras(palavra) values ('vaticina');
 insert into palavras(palavra) values ('vedariam');
 insert into palavras(palavra) values ('vedastes');
 insert into palavras(palavra) values ('vegetarei');
 insert into palavras(palavra) values ('vegetaras');
 insert into palavras(palavra) values ('vegetativo');
 insert into palavras(palavra) values ('veiculara');
 insert into palavras(palavra) values ('velariam');
 insert into palavras(palavra) values ('velariamos');
 insert into palavras(palavra) values ('veleidade');
 insert into palavras(palavra) values ('velozmente');
 insert into palavras(palavra) values ('vencessemos');
 insert into palavras(palavra) values ('vendando');
 insert into palavras(palavra) values ('venderemo');
 insert into palavras(palavra) values ('venerareis');
 insert into palavras(palavra) values ('veneravam');
 insert into palavras(palavra) values ('veneziana');
 insert into palavras(palavra) values ('ventaras');
 insert into palavras(palavra) values ('ventilais');
 insert into palavras(palavra) values ('veranearieis');
 insert into palavras(palavra) values ('veraneaste');
 insert into palavras(palavra) values ('veraneava');
 insert into palavras(palavra) values ('veraneiem');
 insert into palavras(palavra) values ('veraneasseis');
 insert into palavras(palavra) values ('verbalizei');
 insert into palavras(palavra) values ('verbatim');
 insert into palavras(palavra) values ('vergastaria');
 insert into palavras(palavra) values ('vergastou');
 insert into palavras(palavra) values ('verificadora');
 insert into palavras(palavra) values ('verificaria');
 insert into palavras(palavra) values ('verificariam');
 insert into palavras(palavra) values ('verificarao');
 insert into palavras(palavra) values ('verifica');
 insert into palavras(palavra) values ('verrugosas');
 insert into palavras(palavra) values ('vertesse');
 insert into palavras(palavra) values ('vestirao');
 insert into palavras(palavra) values ('vetorizarei');
 insert into palavras(palavra) values ('viabilizais');
 insert into palavras(palavra) values ('viabilizemo');
 insert into palavras(palavra) values ('viajarmo');
 insert into palavras(palavra) values ('viajastes');
 insert into palavras(palavra) values ('vicejara');
 insert into palavras(palavra) values ('vidrareis');
 insert into palavras(palavra) values ('vigiasseis');
 insert into palavras(palavra) values ('vigorassem');
 insert into palavras(palavra) values ('vincariamos');
 insert into palavras(palavra) values ('vindicacoes');
 insert into palavras(palavra) values ('vindicareis');
 insert into palavras(palavra) values ('vingarieis');
 insert into palavras(palavra) values ('vingaramos');
 insert into palavras(palavra) values ('vingaveis');
 insert into palavras(palavra) values ('virilizarei');
 insert into palavras(palavra) values ('virilizariam');
 insert into palavras(palavra) values ('virilizaveis');
 insert into palavras(palavra) values ('visitasseis');
 insert into palavras(palavra) values ('visualizam');
 insert into palavras(palavra) values ('visualizamos');
 insert into palavras(palavra) values ('visualizar');
 insert into palavras(palavra) values ('visualizacao');
 insert into palavras(palavra) values ('visualizou');
 insert into palavras(palavra) values ('vitalizaremo');
 insert into palavras(palavra) values ('vitalizares');
 insert into palavras(palavra) values ('vitalizasses');
 insert into palavras(palavra) values ('vitimarem');
 insert into palavras(palavra) values ('vitimariamos');
 insert into palavras(palavra) values ('vitimassem');
 insert into palavras(palavra) values ('viveramos');
 insert into palavras(palavra) values ('vivissima');
 insert into palavras(palavra) values ('vocalizaras');
 insert into palavras(palavra) values ('vociferemo');
 insert into palavras(palavra) values ('volantes');
 insert into palavras(palavra) values ('volatiliza');
 insert into palavras(palavra) values ('voltariamos');
 insert into palavras(palavra) values ('vomitariamos');
 insert into palavras(palavra) values ('voracissimo');
 insert into palavras(palavra) values ('vulcanizares');
 insert into palavras(palavra) values ('xeretares');
 insert into palavras(palavra) values ('xeretasseis');
 insert into palavras(palavra) values ('xilogravuras');
 insert into palavras(palavra) values ('xingaria');
 insert into palavras(palavra) values ('xingassem');
 insert into palavras(palavra) values ('xingavamos');
 insert into palavras(palavra) values ('zangarieis');
 insert into palavras(palavra) values ('zanzaria');
 insert into palavras(palavra) values ('zanzarmo');
 insert into palavras(palavra) values ('zarpavamos');
 insert into palavras(palavra) values ('zerariam');
 insert into palavras(palavra) values ('zombareis');
 insert into palavras(palavra) values ('zumbiria');
 insert into palavras(palavra) values ('zumbisse');
 insert into palavras(palavra) values ('zumbiste');
 insert into palavras(palavra) values ('zunireis');
 insert into palavras(palavra) values ('zurrastes');
 insert into palavras(palavra) values ('arbitros');


insert into atualizacoes(atu_nome) values ('v21040003_170621.sql');

alter table loteexternorequisicao add leq_codigoreqapoio varchar(20);



insert into atualizacoes(atu_nome) values ('v21040004_220621.sql');

alter table configuracaoweb add cwe_titulopoliticalogin varchar(1000), add cwe_titulolinkpoliticalogin varchar(250), add cwe_apresentarpoliticalogin boolean default false;



insert into atualizacoes(atu_nome) values ('v21040005_280621.sql');



alter table examerequisicao add exr_codmatalvaro integer, add exr_descmatalvaro varchar(150);

alter table parametros add par_copiatermoconsentimento varchar(200);


create table materialalvaro (
       fil_codigo           integer not null,
       lae_codigo           integer not null,
       mav_codigo           integer not null,
       mav_descricao        varchar(150),
       mav_inativo          boolean default false
);

create unique index xpkmaterialalvaro on materialalvaro
(
       fil_codigo,
       lae_codigo,
       mav_codigo
);

create index xif1materialalvaro on materialalvaro
(
       fil_codigo,
       lae_codigo
);


alter table materialalvaro
       add primary key (fil_codigo, lae_codigo, mav_codigo);


create table modelotermoconsentimento (
       fil_codigo           integer not null,
       mtc_codigo           integer not null,
       lay_codigo           integer not null,
       mmt_tipo             varchar(1),
       mmt_formato          text,
       mmt_padrao           boolean default false
);

create unique index xpkmodelotermoconsentimento on modelotermoconsentimento
(
       fil_codigo,
       mtc_codigo,
       lay_codigo
);

create index xif1modelotermoconsentimento on modelotermoconsentimento
(
       fil_codigo,
       mtc_codigo
);

create index xif2modelotermoconsentimento on modelotermoconsentimento
(
       lay_codigo,
       fil_codigo
);


alter table modelotermoconsentimento
       add primary key (fil_codigo, mtc_codigo, lay_codigo);


create table termoconsentimento (
       fil_codigo           integer not null,
       mtc_codigo           integer not null,
       mtc_descricao        varchar(150),
       mtc_inativo          boolean default false
);

create unique index xpktermoconsentimento on termoconsentimento
(
       fil_codigo,
       mtc_codigo
);

create index xif1termoconsentimento on termoconsentimento
(
       fil_codigo
);


alter table termoconsentimento
       add primary key (fil_codigo, mtc_codigo);




drop function fn_td_labexterno() cascade;

create function fn_td_labexterno() returns opaque as '
declare
	numrows integer;										 
begin
    select count(*) into numrows
      from materialalvaro
      where
        materialalvaro.fil_codigo = old.fil_codigo and
        materialalvaro.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela materialalvaro.'';
    end if;

    delete from labexternolotepardini
      where
        labexternolotepardini.fil_codigo = old.fil_codigo and
        labexternolotepardini.lae_codigo = old.lae_codigo;

    delete from labexternologintegracao
      where
        labexternologintegracao.fil_codigo = old.fil_codigo and
        labexternologintegracao.lae_codigo = old.lae_codigo;

    delete from labexternoversaotermo
      where
        labexternoversaotermo.fil_codigo = old.fil_codigo and
        labexternoversaotermo.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from examessaomarcos
      where
        examessaomarcos.fil_codigo = old.fil_codigo and
        examessaomarcos.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examessaomarcos.'';
    end if;

    delete from examessyslab
      where
        examessyslab.fil_codigo = old.fil_codigo and
        examessyslab.lae_codigo = old.lae_codigo;

    delete from examesunilab
      where
        examesunilab.fil_codigo = old.fil_codigo and
        examesunilab.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from filiais_postocoleta
      where
        filiais_postocoleta.fil_codigo = old.fil_codigo and
        filiais_postocoleta.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela filiais_postocoleta.'';
    end if;

    delete from logimportacaolabexterno
      where
        logimportacaolabexterno.fil_codigo = old.fil_codigo and
        logimportacaolabexterno.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from examessolucao
      where
        examessolucao.fil_codigo = old.fil_codigo and
        examessolucao.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examessolucao.'';
    end if;

    select count(*) into numrows
      from examesdb
      where
        examesdb.fil_codigo = old.fil_codigo and
        examesdb.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesdb.'';
    end if;

    delete from examesatitude
      where
        examesatitude.fil_codigo = old.fil_codigo and
        examesatitude.lae_codigo = old.lae_codigo;

    delete from examesbalague
      where
        examesbalague.fil_codigo = old.fil_codigo and
        examesbalague.lae_codigo = old.lae_codigo;

    delete from examesdelta
      where
        examesdelta.fil_codigo = old.fil_codigo and
        examesdelta.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from examematcoletalabexterno
      where
        examematcoletalabexterno.fil_codigo = old.fil_codigo and
        examematcoletalabexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examematcoletalabexterno.'';
    end if;

    select count(*) into numrows
      from examesmatrix
      where
        examesmatrix.fil_codigo = old.fil_codigo and
        examesmatrix.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesmatrix.'';
    end if;

    select count(*) into numrows
      from examesrede
      where
        examesrede.fil_codigo = old.fil_codigo and
        examesrede.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesrede.'';
    end if;

    delete from examesreacao
      where
        examesreacao.fil_codigo = old.fil_codigo and
        examesreacao.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from pacientelabexterno
      where
        pacientelabexterno.fil_codigo = old.fil_codigo and
        pacientelabexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela pacientelabexterno.'';
    end if;

    select count(*) into numrows
      from requisicaolabexterno
      where
        requisicaolabexterno.fil_codigo = old.fil_codigo and
        requisicaolabexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela requisicaolabexterno.'';
    end if;

    delete from examessergiofranco
      where
        examessergiofranco.fil_codigo = old.fil_codigo and
        examessergiofranco.lae_codigo = old.lae_codigo;

    delete from examesalvaro
      where
        examesalvaro.fil_codigo = old.fil_codigo and
        examesalvaro.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from examesjalis
      where
        examesjalis.fil_codigo = old.fil_codigo and
        examesjalis.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examesjalis.'';
    end if;

    delete from examespardini
      where
        examespardini.fil_codigo = old.fil_codigo and
        examespardini.lae_codigo = old.lae_codigo;

    select count(*) into numrows
      from loteexterno
      where
        loteexterno.fil_codigo = old.fil_codigo and
        loteexterno.lae_codigo = old.lae_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela loteexterno.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_labexterno
after delete on labexterno
for each row execute procedure fn_td_labexterno();


drop function fn_ti_labexterno() cascade;

create function fn_ti_labexterno() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from prazoentrega
      where
        new.fil_codigo = prazoentrega.fil_codigo and
        new.prz_codigo = prazoentrega.prz_codigo;
    tmp:=''prazoentrega|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''prz_codigo='' || new.prz_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.prz_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela prazoentrega. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from metodologia
      where
        new.fil_codigo = metodologia.fil_codigo and
        new.met_codigo = metodologia.met_codigo;
    tmp:=''metodologia|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''met_codigo='' || new.met_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.met_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela metodologia. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from setores
      where
        new.fil_codigo = setores.fil_codigo and
        new.set_codigo = setores.set_codigo;
    tmp:=''setores|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''set_codigo='' || new.set_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.fil_codigo is not null and
      new.set_codigo is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela setores. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from usuario
      where
        new.usr_codconferir = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codconferir || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      new.usr_codconferir is not null and
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_labexterno
after insert on labexterno
for each row execute procedure fn_ti_labexterno();


drop function fn_tu_labexterno() cascade;

create function fn_tu_labexterno() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from materialalvaro
      where
        materialalvaro.fil_codigo = old.fil_codigo and
        materialalvaro.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela materialalvaro.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from labexternolotepardini
      where
        labexternolotepardini.fil_codigo = old.fil_codigo and
        labexternolotepardini.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela labexternolotepardini.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from labexternologintegracao
      where
        labexternologintegracao.fil_codigo = old.fil_codigo and
        labexternologintegracao.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela labexternologintegracao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from labexternoversaotermo
      where
        labexternoversaotermo.fil_codigo = old.fil_codigo and
        labexternoversaotermo.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela labexternoversaotermo.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examessaomarcos
      where
        examessaomarcos.fil_codigo = old.fil_codigo and
        examessaomarcos.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examessaomarcos.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examessyslab
      where
        examessyslab.fil_codigo = old.fil_codigo and
        examessyslab.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examessyslab.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesunilab
      where
        examesunilab.fil_codigo = old.fil_codigo and
        examesunilab.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesunilab.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from filiais_postocoleta
      where
        filiais_postocoleta.fil_codigo = old.fil_codigo and
        filiais_postocoleta.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela filiais_postocoleta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from logimportacaolabexterno
      where
        logimportacaolabexterno.fil_codigo = old.fil_codigo and
        logimportacaolabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela logimportacaolabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examessolucao
      where
        examessolucao.fil_codigo = old.fil_codigo and
        examessolucao.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examessolucao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesdb
      where
        examesdb.fil_codigo = old.fil_codigo and
        examesdb.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesdb.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesatitude
      where
        examesatitude.fil_codigo = old.fil_codigo and
        examesatitude.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesatitude.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesbalague
      where
        examesbalague.fil_codigo = old.fil_codigo and
        examesbalague.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesbalague.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesdelta
      where
        examesdelta.fil_codigo = old.fil_codigo and
        examesdelta.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesdelta.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examematcoletalabexterno
      where
        examematcoletalabexterno.fil_codigo = old.fil_codigo and
        examematcoletalabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examematcoletalabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesmatrix
      where
        examesmatrix.fil_codigo = old.fil_codigo and
        examesmatrix.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesmatrix.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesrede
      where
        examesrede.fil_codigo = old.fil_codigo and
        examesrede.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesrede.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesreacao
      where
        examesreacao.fil_codigo = old.fil_codigo and
        examesreacao.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesreacao.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from pacientelabexterno
      where
        pacientelabexterno.fil_codigo = old.fil_codigo and
        pacientelabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela pacientelabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from requisicaolabexterno
      where
        requisicaolabexterno.fil_codigo = old.fil_codigo and
        requisicaolabexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela requisicaolabexterno.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examessergiofranco
      where
        examessergiofranco.fil_codigo = old.fil_codigo and
        examessergiofranco.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examessergiofranco.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesalvaro
      where
        examesalvaro.fil_codigo = old.fil_codigo and
        examesalvaro.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesalvaro.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examesjalis
      where
        examesjalis.fil_codigo = old.fil_codigo and
        examesjalis.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examesjalis.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from examespardini
      where
        examespardini.fil_codigo = old.fil_codigo and
        examespardini.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examespardini.'';
    end if;
  end if;
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.lae_codigo <> new.lae_codigo) then
    select count(*)
      from loteexterno
      where
        loteexterno.fil_codigo = old.fil_codigo and
        loteexterno.lae_codigo = old.lae_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela loteexterno.'';
    end if;
  end if;
  select count(*) into numrows
    from prazoentrega
    where
      new.fil_codigo = prazoentrega.fil_codigo and
      new.prz_codigo = prazoentrega.prz_codigo;
    tmp:=''prazoentrega|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''prz_codigo='' || new.prz_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.prz_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela prazoentrega. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from metodologia
    where
      new.fil_codigo = metodologia.fil_codigo and
      new.met_codigo = metodologia.met_codigo;
    tmp:=''metodologia|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''met_codigo='' || new.met_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.met_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela metodologia. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from setores
    where
      new.fil_codigo = setores.fil_codigo and
      new.set_codigo = setores.set_codigo;
    tmp:=''setores|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''set_codigo='' || new.set_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.fil_codigo is not null and
    new.set_codigo is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela setores. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from usuario
    where
      new.usr_codconferir = usuario.usr_codigo;
    tmp:=''usuario|'';
    
      tmp:=tmp || ''usr_codigo='' || new.usr_codconferir || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    new.usr_codconferir is not null and
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela usuario. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_labexterno
after update on labexterno
for each row execute procedure fn_tu_labexterno();


drop function fn_td_layout() cascade;

create function fn_td_layout() returns opaque as '
declare
	numrows integer;										 
begin
    select count(*) into numrows
      from modelotermoconsentimento
      where
        modelotermoconsentimento.lay_codigo = old.lay_codigo and
        modelotermoconsentimento.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela modelotermoconsentimento.'';
    end if;

    select count(*) into numrows
      from convenios
      where
        convenios.lay_codigoapoio = old.lay_codigo and
        convenios.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela convenios.'';
    end if;

    select count(*) into numrows
      from paciente
      where
        paciente.lay_codigoapoio = old.lay_codigo and
        paciente.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela paciente.'';
    end if;

    select count(*) into numrows
      from convenios
      where
        convenios.lay_codigo = old.lay_codigo and
        convenios.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela convenios.'';
    end if;

    select count(*) into numrows
      from parametros
      where
        parametros.lay_codigo = old.lay_codigo and
        parametros.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela parametros.'';
    end if;

    select count(*) into numrows
      from examelayout
      where
        examelayout.lay_codigo = old.lay_codigo and
        examelayout.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela examelayout.'';
    end if;

    select count(*) into numrows
      from destinoconvlayout
      where
        destinoconvlayout.lay_codigo = old.lay_codigo and
        destinoconvlayout.fil_codigo = old.fil_codigo;
    if (numrows > 0) then
      raise exception ''o registro nao pode ser excluido, por estar sendo utilizado na tabela destinoconvlayout.'';
    end if;


return old;
end;'
language 'plpgsql';
					
create trigger td_layout
after delete on layout
for each row execute procedure fn_td_layout();


drop function fn_ti_layout() cascade;

create function fn_ti_layout() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_layout
after insert on layout
for each row execute procedure fn_ti_layout();


drop function fn_tu_layout() cascade;

create function fn_tu_layout() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.lay_codigo <> new.lay_codigo or 
     old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from modelotermoconsentimento
      where
        modelotermoconsentimento.lay_codigo = old.lay_codigo and
        modelotermoconsentimento.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela modelotermoconsentimento.'';
    end if;
  end if;
  if
    (old.lay_codigo <> new.lay_codigo or 
     old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from convenios
      where
        convenios.lay_codigoapoio = old.lay_codigo and
        convenios.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenios.'';
    end if;
  end if;
  if
    (old.lay_codigo <> new.lay_codigo or 
     old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from paciente
      where
        paciente.lay_codigoapoio = old.lay_codigo and
        paciente.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela paciente.'';
    end if;
  end if;
  if
    (old.lay_codigo <> new.lay_codigo or 
     old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from convenios
      where
        convenios.lay_codigo = old.lay_codigo and
        convenios.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela convenios.'';
    end if;
  end if;
  if
    (old.lay_codigo <> new.lay_codigo or 
     old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from parametros
      where
        parametros.lay_codigo = old.lay_codigo and
        parametros.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela parametros.'';
    end if;
  end if;
  if
    (old.lay_codigo <> new.lay_codigo or 
     old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from examelayout
      where
        examelayout.lay_codigo = old.lay_codigo and
        examelayout.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela examelayout.'';
    end if;
  end if;
  if
    (old.lay_codigo <> new.lay_codigo or 
     old.fil_codigo <> new.fil_codigo) then
    select count(*)
      from destinoconvlayout
      where
        destinoconvlayout.lay_codigo = old.lay_codigo and
        destinoconvlayout.fil_codigo = old.fil_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela destinoconvlayout.'';
    end if;
  end if;
  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_layout
after update on layout
for each row execute procedure fn_tu_layout();


--drop function fn_ti_materialalvaro() cascade;

create function fn_ti_materialalvaro() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from labexterno
      where
        new.fil_codigo = labexterno.fil_codigo and
        new.lae_codigo = labexterno.lae_codigo;
    tmp:=''labexterno|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''lae_codigo='' || new.lae_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela labexterno. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_materialalvaro
after insert on materialalvaro
for each row execute procedure fn_ti_materialalvaro();


--drop function fn_tu_materialalvaro() cascade;

create function fn_tu_materialalvaro() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from labexterno
    where
      new.fil_codigo = labexterno.fil_codigo and
      new.lae_codigo = labexterno.lae_codigo;
    tmp:=''labexterno|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''lae_codigo='' || new.lae_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela labexterno. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_materialalvaro
after update on materialalvaro
for each row execute procedure fn_tu_materialalvaro();


--drop function fn_ti_modelotermoconsentimento() cascade;

create function fn_ti_modelotermoconsentimento() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from layout
      where
        new.lay_codigo = layout.lay_codigo and
        new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigo || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;

    select count(*) into numrows
      from termoconsentimento
      where
        new.fil_codigo = termoconsentimento.fil_codigo and
        new.mtc_codigo = termoconsentimento.mtc_codigo;
    tmp:=''termoconsentimento|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''mtc_codigo='' || new.mtc_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela termoconsentimento. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_modelotermoconsentimento
after insert on modelotermoconsentimento
for each row execute procedure fn_ti_modelotermoconsentimento();


--drop function fn_tu_modelotermoconsentimento() cascade;

create function fn_tu_modelotermoconsentimento() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  select count(*) into numrows
    from layout
    where
      new.lay_codigo = layout.lay_codigo and
      new.fil_codigo = layout.fil_codigo;
    tmp:=''layout|'';
    
      tmp:=tmp || ''lay_codigo='' || new.lay_codigo || ''|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela layout. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;

  select count(*) into numrows
    from termoconsentimento
    where
      new.fil_codigo = termoconsentimento.fil_codigo and
      new.mtc_codigo = termoconsentimento.mtc_codigo;
    tmp:=''termoconsentimento|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
      tmp:=tmp || ''mtc_codigo='' || new.mtc_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela termoconsentimento. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_modelotermoconsentimento
after update on modelotermoconsentimento
for each row execute procedure fn_tu_modelotermoconsentimento();


--drop function fn_td_termoconsentimento() cascade;

create function fn_td_termoconsentimento() returns opaque as '
declare
	numrows integer;										 
begin
    delete from modelotermoconsentimento
      where
        modelotermoconsentimento.fil_codigo = old.fil_codigo and
        modelotermoconsentimento.mtc_codigo = old.mtc_codigo;


return old;
end;'
language 'plpgsql';
					
create trigger td_termoconsentimento
after delete on termoconsentimento
for each row execute procedure fn_td_termoconsentimento();


--drop function fn_ti_termoconsentimento() cascade;

create function fn_ti_termoconsentimento() returns opaque as '
declare
	numrows integer;
	tmp varchar;									 
begin
    select count(*) into numrows
      from filiais_postocoleta
      where
        new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);

    if (
      
      numrows = 0
    ) then
      raise exception ''o registro nao pode ser inserido, pois um valor informado nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ifkne'');
    end if;


return new;
end;'
language 'plpgsql';
					
create trigger ti_termoconsentimento
after insert on termoconsentimento
for each row execute procedure fn_ti_termoconsentimento();


--drop function fn_tu_termoconsentimento() cascade;

create function fn_tu_termoconsentimento() returns opaque as '
declare
	numrows integer;
        tmp varchar;										 
begin
  if
    (old.fil_codigo <> new.fil_codigo or 
     old.mtc_codigo <> new.mtc_codigo) then
    select count(*)
      from modelotermoconsentimento
      where
        modelotermoconsentimento.fil_codigo = old.fil_codigo and
        modelotermoconsentimento.mtc_codigo = old.mtc_codigo into numrows;
    if (numrows > 0) then
     raise exception ''o registro nao pode ser alterado, pois um valor esta sendo utilizado na tabela modelotermoconsentimento.'';
    end if;
  end if;
  select count(*) into numrows
    from filiais_postocoleta
    where
      new.fil_codigo = filiais_postocoleta.fil_codigo;
    tmp:=''filiais_postocoleta|'';
    
      tmp:=tmp || ''fil_codigo='' || new.fil_codigo || ''|'';
    
    tmp:=substring(tmp,1,length(tmp)-1);
  if (
    
    numrows = 0
  ) then
    raise exception ''o registro nao pode ser alterado, pois um valor nao existe na tabela filiais_postocoleta. chave para consulta:[%]'',tmp using errcode=upper(''ufkne'');
  end if;


return old;
end;'
language 'plpgsql';
					
create trigger tu_termoconsentimento
after update on termoconsentimento
for each row execute procedure fn_tu_termoconsentimento();





create sequence termoconsentimento_sequence;

select criasequencia('termoconsentimento');

select configurageralog('termoconsentimento');
select configurageralog('modelotermoconsentimento');
select configurageralog('materialalvaro');


insert into atualizacoes(atu_nome) values ('v21040006_080721.sql');



alter table requisicao add req_dadospacienteconfirmados boolean;

alter table parametros add par_diasatualizarpaciente integer, add par_exigirconfirmacaopaciente boolean default false;


insert into atualizacoes(atu_nome) values ('v21040007_300721.sql');



delete from tabelaignoradalog where til_tabela in ('requisicao', 'examerequisicao', 'examerequisicaoresultado', 'lanctocaixa', 'detalhetabelapreco', 'examematcoleta', 'exames', 'examesalvaro', 'examespardini', 'interfaceexamerequisicao', 'examerequisicaohash');

insert into atualizacoes(atu_nome) values ('v21040008_300721.sql');



drop function fn_tu_b_examerequisicao() cascade;

create function fn_tu_b_examerequisicao() returns opaque as $$
declare
  req bigint;
begin
if (new.exr_situacao is null or trim(new.exr_situacao) = '') and (new.exr_dataassina is not null or old.exr_dataassina is not null) then
  raise exception 'O exame já foi alterado por outro usuário, verifique a situação atual do exame, %, %', new.req_codigo, new.exa_codigo;
end if;

select req_codigo into req from examerequisicaoresultado where fil_codigo = new.fil_codigo and req_codigo = new.req_codigo and exa_codigo = new.exa_codigo and mco_codigo = new.mco_codigo;
if (NOT FOUND) then
  insert into examerequisicaoresultado(fil_codigo, req_codigo, exa_codigo, mco_codigo) values (new.fil_codigo, new.req_codigo, new.exa_codigo, new.mco_codigo);
end if;


if ((upper(new.exr_situacao) = upper('L') or upper(new.exr_situacao) = upper('C') or upper(new.exr_situacao) = upper('I') or upper(new.exr_situacao) = upper('E') or upper(new.exr_situacao) = upper('P')) and 
  new.exr_resultado is not null and length(new.exr_resultado) > 0) then
  update examerequisicaoresultado set ert_resultado = new.exr_resultado where fil_codigo = new.fil_codigo and req_codigo = new.req_codigo and exa_codigo = new.exa_codigo and mco_codigo = new.mco_codigo;
end if;

if ((new.exr_situacao is null or new.exr_situacao = '' or upper(new.exr_situacao) = upper('F') or upper(new.exr_situacao) = upper('T') or upper(new.exr_situacao) = upper('R'))) then
  update examerequisicaoresultado set ert_resultado = new.exr_resultado where fil_codigo = new.fil_codigo and req_codigo = new.req_codigo and exa_codigo = new.exa_codigo and mco_codigo = new.mco_codigo;
end if;


/* troca o valor do campo de resultado na tabela exame requisicao */
new.exr_resultado := null;

return new;

END
$$
language 'plpgsql';



CREATE TRIGGER tu_b_examerequisicao 
  BEFORE UPDATE on ExameRequisicao
for each row execute procedure fn_tu_b_examerequisicao();





insert into atualizacoes(atu_nome) values ('v21040009_160921.sql');
